import java.io.*;
import java.util.zip.*;
import java.util.*;

public class ConnectedTextures
{
    private static ConnectedProperties[][] blockProperties;
    private static ConnectedProperties[][] tileProperties;
    private static boolean multipass;
    private static boolean defaultGlassTexture;
    private static final int BOTTOM = 0;
    private static final int TOP = 1;
    private static final int EAST = 2;
    private static final int WEST = 3;
    private static final int NORTH = 4;
    private static final int SOUTH = 5;
    private static final String[] propSuffixes;
    private static final int[] ctmIndexes;
    
    public static void update(final bge re) {
    }
    
    private static ConnectedProperties[][] readConnectedProperties(final String prefix, final int num, final bge re, final int defConnect) {
        return null;
    }
    
    public static lx getConnectedTexture(final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon) {
        if (blockAccess == null) {
            return icon;
        }
        final lx newIcon = getConnectedTextureSingle(blockAccess, block, x, y, z, side, icon, true);
        if (!ConnectedTextures.multipass) {
            return newIcon;
        }
        if (newIcon == icon) {
            return newIcon;
        }
        lx mpIcon = newIcon;
        for (int i = 0; i < 3; ++i) {
            final lx newMpIcon = getConnectedTextureSingle(blockAccess, block, x, y, z, side, mpIcon, false);
            if (newMpIcon == mpIcon) {
                break;
            }
            mpIcon = newMpIcon;
        }
        return mpIcon;
    }
    
    public static lx getConnectedTextureSingle(final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final boolean checkBlocks) {
        if (!(icon instanceof bil)) {
            return icon;
        }
        final bil ts = (bil)icon;
        final int iconId = ts.getIndexInMap();
        int metadata = -1;
        if (ConnectedTextures.tileProperties != null && bgd.a.defaultTexture && iconId >= 0 && iconId < ConnectedTextures.tileProperties.length) {
            final ConnectedProperties[] cps = ConnectedTextures.tileProperties[iconId];
            if (cps != null) {
                if (metadata < 0) {
                    metadata = blockAccess.h(x, y, z);
                }
                final lx newIcon = getConnectedTexture(cps, blockAccess, block, x, y, z, side, ts, metadata);
                if (newIcon != null) {
                    return newIcon;
                }
            }
        }
        if (ConnectedTextures.blockProperties != null && checkBlocks) {
            final int blockId = block.cz;
            if (blockId >= 0 && blockId < ConnectedTextures.blockProperties.length) {
                final ConnectedProperties[] cps2 = ConnectedTextures.blockProperties[blockId];
                if (cps2 != null) {
                    if (metadata < 0) {
                        metadata = blockAccess.h(x, y, z);
                    }
                    final lx newIcon2 = getConnectedTexture(cps2, blockAccess, block, x, y, z, side, ts, metadata);
                    if (newIcon2 != null) {
                        return newIcon2;
                    }
                }
            }
        }
        return icon;
    }
    
    public static ConnectedProperties getConnectedProperties(final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon) {
        if (blockAccess == null) {
            return null;
        }
        if (!(icon instanceof bil)) {
            return null;
        }
        final bil ts = (bil)icon;
        final int iconId = ts.getIndexInMap();
        int metadata = -1;
        if (ConnectedTextures.tileProperties != null && bgd.a.defaultTexture && iconId >= 0 && iconId < ConnectedTextures.tileProperties.length) {
            final ConnectedProperties[] cps = ConnectedTextures.tileProperties[iconId];
            if (cps != null) {
                if (metadata < 0) {
                    metadata = blockAccess.h(x, y, z);
                }
                final ConnectedProperties cp = getConnectedProperties(cps, blockAccess, block, x, y, z, side, ts, metadata);
                if (cp != null) {
                    return cp;
                }
            }
        }
        if (ConnectedTextures.blockProperties != null) {
            final int blockId = block.cz;
            if (blockId >= 0 && blockId < ConnectedTextures.blockProperties.length) {
                final ConnectedProperties[] cps2 = ConnectedTextures.blockProperties[blockId];
                if (cps2 != null) {
                    if (metadata < 0) {
                        metadata = blockAccess.h(x, y, z);
                    }
                    final ConnectedProperties cp2 = getConnectedProperties(cps2, blockAccess, block, x, y, z, side, ts, metadata);
                    if (cp2 != null) {
                        return cp2;
                    }
                }
            }
        }
        return null;
    }
    
    private static lx getConnectedTexture(final ConnectedProperties[] cps, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        for (int i = 0; i < cps.length; ++i) {
            final ConnectedProperties cp = cps[i];
            if (cp != null) {
                final lx newIcon = getConnectedTexture(cp, blockAccess, block, x, y, z, side, icon, metadata);
                if (newIcon != null) {
                    return newIcon;
                }
            }
        }
        return null;
    }
    
    private static ConnectedProperties getConnectedProperties(final ConnectedProperties[] cps, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        for (int i = 0; i < cps.length; ++i) {
            final ConnectedProperties cp = cps[i];
            if (cp != null) {
                final lx newIcon = getConnectedTexture(cp, blockAccess, block, x, y, z, side, icon, metadata);
                if (newIcon != null) {
                    return cp;
                }
            }
        }
        return null;
    }
    
    private static lx getConnectedTexture(final ConnectedProperties cp, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        if (y < cp.minHeight || y > cp.maxHeight) {
            return null;
        }
        if (cp.biomes != null) {
            final aav blockBiome = blockAccess.a(x, z);
            boolean biomeOk = false;
            for (int i = 0; i < cp.biomes.length; ++i) {
                final aav biome = cp.biomes[i];
                if (blockBiome == biome) {
                    biomeOk = true;
                    break;
                }
            }
            if (!biomeOk) {
                return null;
            }
        }
        final boolean blockWood = block instanceof apk;
        if (side >= 0 && cp.faces != 63) {
            int checkSide = side;
            if (blockWood) {
                checkSide = fixWoodSide(blockAccess, x, y, z, side, metadata);
            }
            if ((1 << checkSide & cp.faces) == 0x0) {
                return null;
            }
        }
        int checkMetadata = metadata;
        if (blockWood) {
            checkMetadata &= 0x3;
        }
        if (cp.metadatas != null) {
            final int[] mds = cp.metadatas;
            boolean metadataFound = false;
            for (int j = 0; j < mds.length; ++j) {
                if (mds[j] == checkMetadata) {
                    metadataFound = true;
                    break;
                }
            }
            if (!metadataFound) {
                return null;
            }
        }
        switch (cp.method) {
            case 1: {
                return getConnectedTextureCtm(cp, blockAccess, block, x, y, z, side, icon, metadata);
            }
            case 2: {
                return getConnectedTextureHorizontal(cp, blockAccess, block, x, y, z, side, icon, metadata);
            }
            case 6: {
                return getConnectedTextureVertical(cp, blockAccess, block, x, y, z, side, icon, metadata);
            }
            case 3: {
                return getConnectedTextureTop(cp, blockAccess, block, x, y, z, side, icon, metadata);
            }
            case 4: {
                return getConnectedTextureRandom(cp, x, y, z, side);
            }
            case 5: {
                return getConnectedTextureRepeat(cp, x, y, z, side);
            }
            case 7: {
                return getConnectedTextureFixed(cp);
            }
            default: {
                return null;
            }
        }
    }
    
    private static int fixWoodSide(final aak blockAccess, final int x, final int y, final int z, final int side, final int metadata) {
        final int orient = (metadata & 0xC) >> 2;
        Label_0141: {
            switch (orient) {
                case 0: {
                    return side;
                }
                case 1: {
                    switch (side) {
                        case 0: {
                            return 4;
                        }
                        case 1: {
                            return 5;
                        }
                        case 4: {
                            return 1;
                        }
                        case 5: {
                            return 0;
                        }
                        default: {
                            break Label_0141;
                        }
                    }
                    break;
                }
                case 2: {
                    switch (side) {
                        case 0: {
                            return 2;
                        }
                        case 1: {
                            return 3;
                        }
                        case 2: {
                            return 1;
                        }
                        case 3: {
                            return 0;
                        }
                        default: {
                            break Label_0141;
                        }
                    }
                    break;
                }
                case 3: {
                    return 2;
                }
            }
        }
        return side;
    }
    
    private static lx getConnectedTextureRandom(final ConnectedProperties cp, final int x, final int y, final int z, final int side) {
        if (cp.tileIcons.length == 1) {
            return cp.tileIcons[0];
        }
        final int face = side / cp.symmetry * cp.symmetry;
        final int rand = Config.getRandom(x, y, z, face) & Integer.MAX_VALUE;
        int index = 0;
        if (cp.weights == null) {
            index = rand % cp.tileIcons.length;
        }
        else {
            final int randWeight = rand % cp.sumAllWeights;
            final int[] sumWeights = cp.sumWeights;
            for (int i = 0; i < sumWeights.length; ++i) {
                if (randWeight < sumWeights[i]) {
                    index = i;
                    break;
                }
            }
        }
        return cp.tileIcons[index];
    }
    
    private static lx getConnectedTextureFixed(final ConnectedProperties cp) {
        return cp.tileIcons[0];
    }
    
    private static lx getConnectedTextureRepeat(final ConnectedProperties cp, final int x, final int y, final int z, final int side) {
        if (cp.tileIcons.length == 1) {
            return cp.tileIcons[0];
        }
        int nx = 0;
        int ny = 0;
        switch (side) {
            case 0: {
                nx = x;
                ny = z;
                break;
            }
            case 1: {
                nx = x;
                ny = z;
                break;
            }
            case 2: {
                nx = -x - 1;
                ny = -y;
                break;
            }
            case 3: {
                nx = x;
                ny = -y;
                break;
            }
            case 4: {
                nx = z;
                ny = -y;
                break;
            }
            case 5: {
                nx = -z - 1;
                ny = -y;
                break;
            }
        }
        nx %= cp.width;
        ny %= cp.height;
        if (nx < 0) {
            nx += cp.width;
        }
        if (ny < 0) {
            ny += cp.height;
        }
        final int index = ny * cp.width + nx;
        return cp.tileIcons[index];
    }
    
    private static lx getConnectedTextureCtm(final ConnectedProperties cp, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        final boolean[] borders = new boolean[6];
        switch (side) {
            case 0:
            case 1: {
                borders[0] = isNeighbour(cp, blockAccess, block, x - 1, y, z, side, icon, metadata);
                borders[1] = isNeighbour(cp, blockAccess, block, x + 1, y, z, side, icon, metadata);
                borders[2] = isNeighbour(cp, blockAccess, block, x, y, z + 1, side, icon, metadata);
                borders[3] = isNeighbour(cp, blockAccess, block, x, y, z - 1, side, icon, metadata);
                break;
            }
            case 2: {
                borders[0] = isNeighbour(cp, blockAccess, block, x + 1, y, z, side, icon, metadata);
                borders[1] = isNeighbour(cp, blockAccess, block, x - 1, y, z, side, icon, metadata);
                borders[2] = isNeighbour(cp, blockAccess, block, x, y - 1, z, side, icon, metadata);
                borders[3] = isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata);
                break;
            }
            case 3: {
                borders[0] = isNeighbour(cp, blockAccess, block, x - 1, y, z, side, icon, metadata);
                borders[1] = isNeighbour(cp, blockAccess, block, x + 1, y, z, side, icon, metadata);
                borders[2] = isNeighbour(cp, blockAccess, block, x, y - 1, z, side, icon, metadata);
                borders[3] = isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata);
                break;
            }
            case 4: {
                borders[0] = isNeighbour(cp, blockAccess, block, x, y, z - 1, side, icon, metadata);
                borders[1] = isNeighbour(cp, blockAccess, block, x, y, z + 1, side, icon, metadata);
                borders[2] = isNeighbour(cp, blockAccess, block, x, y - 1, z, side, icon, metadata);
                borders[3] = isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata);
                break;
            }
            case 5: {
                borders[0] = isNeighbour(cp, blockAccess, block, x, y, z + 1, side, icon, metadata);
                borders[1] = isNeighbour(cp, blockAccess, block, x, y, z - 1, side, icon, metadata);
                borders[2] = isNeighbour(cp, blockAccess, block, x, y - 1, z, side, icon, metadata);
                borders[3] = isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata);
                break;
            }
        }
        int index = 0;
        if (borders[0] & !borders[1] & !borders[2] & !borders[3]) {
            index = 3;
        }
        else if (!borders[0] & borders[1] & !borders[2] & !borders[3]) {
            index = 1;
        }
        else if (!borders[0] & !borders[1] & borders[2] & !borders[3]) {
            index = 12;
        }
        else if (!borders[0] & !borders[1] & !borders[2] & borders[3]) {
            index = 36;
        }
        else if (borders[0] & borders[1] & !borders[2] & !borders[3]) {
            index = 2;
        }
        else if (!borders[0] & !borders[1] & borders[2] & borders[3]) {
            index = 24;
        }
        else if (borders[0] & !borders[1] & borders[2] & !borders[3]) {
            index = 15;
        }
        else if (borders[0] & !borders[1] & !borders[2] & borders[3]) {
            index = 39;
        }
        else if (!borders[0] & borders[1] & borders[2] & !borders[3]) {
            index = 13;
        }
        else if (!borders[0] & borders[1] & !borders[2] & borders[3]) {
            index = 37;
        }
        else if (!borders[0] & borders[1] & borders[2] & borders[3]) {
            index = 25;
        }
        else if (borders[0] & !borders[1] & borders[2] & borders[3]) {
            index = 27;
        }
        else if (borders[0] & borders[1] & !borders[2] & borders[3]) {
            index = 38;
        }
        else if (borders[0] & borders[1] & borders[2] & !borders[3]) {
            index = 14;
        }
        else if (borders[0] & borders[1] & borders[2] & borders[3]) {
            index = 26;
        }
        if (!Config.isConnectedTexturesFancy()) {
            return cp.tileIcons[index];
        }
        final boolean[] edges = new boolean[6];
        switch (side) {
            case 0:
            case 1: {
                edges[0] = !isNeighbour(cp, blockAccess, block, x + 1, y, z + 1, side, icon, metadata);
                edges[1] = !isNeighbour(cp, blockAccess, block, x - 1, y, z + 1, side, icon, metadata);
                edges[2] = !isNeighbour(cp, blockAccess, block, x + 1, y, z - 1, side, icon, metadata);
                edges[3] = !isNeighbour(cp, blockAccess, block, x - 1, y, z - 1, side, icon, metadata);
                break;
            }
            case 2: {
                edges[0] = !isNeighbour(cp, blockAccess, block, x - 1, y - 1, z, side, icon, metadata);
                edges[1] = !isNeighbour(cp, blockAccess, block, x + 1, y - 1, z, side, icon, metadata);
                edges[2] = !isNeighbour(cp, blockAccess, block, x - 1, y + 1, z, side, icon, metadata);
                edges[3] = !isNeighbour(cp, blockAccess, block, x + 1, y + 1, z, side, icon, metadata);
                break;
            }
            case 3: {
                edges[0] = !isNeighbour(cp, blockAccess, block, x + 1, y - 1, z, side, icon, metadata);
                edges[1] = !isNeighbour(cp, blockAccess, block, x - 1, y - 1, z, side, icon, metadata);
                edges[2] = !isNeighbour(cp, blockAccess, block, x + 1, y + 1, z, side, icon, metadata);
                edges[3] = !isNeighbour(cp, blockAccess, block, x - 1, y + 1, z, side, icon, metadata);
                break;
            }
            case 4: {
                edges[0] = !isNeighbour(cp, blockAccess, block, x, y - 1, z + 1, side, icon, metadata);
                edges[1] = !isNeighbour(cp, blockAccess, block, x, y - 1, z - 1, side, icon, metadata);
                edges[2] = !isNeighbour(cp, blockAccess, block, x, y + 1, z + 1, side, icon, metadata);
                edges[3] = !isNeighbour(cp, blockAccess, block, x, y + 1, z - 1, side, icon, metadata);
                break;
            }
            case 5: {
                edges[0] = !isNeighbour(cp, blockAccess, block, x, y - 1, z - 1, side, icon, metadata);
                edges[1] = !isNeighbour(cp, blockAccess, block, x, y - 1, z + 1, side, icon, metadata);
                edges[2] = !isNeighbour(cp, blockAccess, block, x, y + 1, z - 1, side, icon, metadata);
                edges[3] = !isNeighbour(cp, blockAccess, block, x, y + 1, z + 1, side, icon, metadata);
                break;
            }
        }
        if (index == 13 && edges[0]) {
            index = 4;
        }
        if (index == 15 && edges[1]) {
            index = 5;
        }
        if (index == 37 && edges[2]) {
            index = 16;
        }
        if (index == 39 && edges[3]) {
            index = 17;
        }
        if (index == 14 && edges[0] && edges[1]) {
            index = 7;
        }
        if (index == 25 && edges[0] && edges[2]) {
            index = 6;
        }
        if (index == 27 && edges[3] && edges[1]) {
            index = 19;
        }
        if (index == 38 && edges[3] && edges[2]) {
            index = 18;
        }
        if (index == 14 && !edges[0] && edges[1]) {
            index = 31;
        }
        if (index == 25 && edges[0] && !edges[2]) {
            index = 30;
        }
        if (index == 27 && !edges[3] && edges[1]) {
            index = 41;
        }
        if (index == 38 && edges[3] && !edges[2]) {
            index = 40;
        }
        if (index == 14 && edges[0] && !edges[1]) {
            index = 29;
        }
        if (index == 25 && !edges[0] && edges[2]) {
            index = 28;
        }
        if (index == 27 && edges[3] && !edges[1]) {
            index = 43;
        }
        if (index == 38 && !edges[3] && edges[2]) {
            index = 42;
        }
        if (index == 26 && edges[0] && edges[1] && edges[2] && edges[3]) {
            index = 46;
        }
        if (index == 26 && !edges[0] && edges[1] && edges[2] && edges[3]) {
            index = 9;
        }
        if (index == 26 && edges[0] && !edges[1] && edges[2] && edges[3]) {
            index = 21;
        }
        if (index == 26 && edges[0] && edges[1] && !edges[2] && edges[3]) {
            index = 8;
        }
        if (index == 26 && edges[0] && edges[1] && edges[2] && !edges[3]) {
            index = 20;
        }
        if (index == 26 && edges[0] && edges[1] && !edges[2] && !edges[3]) {
            index = 11;
        }
        if (index == 26 && !edges[0] && !edges[1] && edges[2] && edges[3]) {
            index = 22;
        }
        if (index == 26 && !edges[0] && edges[1] && !edges[2] && edges[3]) {
            index = 23;
        }
        if (index == 26 && edges[0] && !edges[1] && edges[2] && !edges[3]) {
            index = 10;
        }
        if (index == 26 && edges[0] && !edges[1] && !edges[2] && edges[3]) {
            index = 34;
        }
        if (index == 26 && !edges[0] && edges[1] && edges[2] && !edges[3]) {
            index = 35;
        }
        if (index == 26 && edges[0] && !edges[1] && !edges[2] && !edges[3]) {
            index = 32;
        }
        if (index == 26 && !edges[0] && edges[1] && !edges[2] && !edges[3]) {
            index = 33;
        }
        if (index == 26 && !edges[0] && !edges[1] && edges[2] && !edges[3]) {
            index = 44;
        }
        if (index == 26 && !edges[0] && !edges[1] && !edges[2] && edges[3]) {
            index = 45;
        }
        return cp.tileIcons[index];
    }
    
    private static boolean isNeighbour(final ConnectedProperties cp, final aak iblockaccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        final int blockId = iblockaccess.a(x, y, z);
        if (cp.connect == 2) {
            final apa neighbourBlock = apa.r[blockId];
            if (neighbourBlock == null) {
                return false;
            }
            final lx neighbourIcon = neighbourBlock.b_(iblockaccess, x, y, z, side);
            return neighbourIcon == icon;
        }
        else {
            if (cp.connect == 3) {
                final apa neighbourBlock = apa.r[blockId];
                return neighbourBlock != null && neighbourBlock.cO == block.cO;
            }
            return blockId == block.cz && iblockaccess.h(x, y, z) == metadata;
        }
    }
    
    private static lx getConnectedTextureHorizontal(final ConnectedProperties cp, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        if (side == 0 || side == 1) {
            return null;
        }
        boolean left = false;
        boolean right = false;
        switch (side) {
            case 2: {
                left = isNeighbour(cp, blockAccess, block, x + 1, y, z, side, icon, metadata);
                right = isNeighbour(cp, blockAccess, block, x - 1, y, z, side, icon, metadata);
                break;
            }
            case 3: {
                left = isNeighbour(cp, blockAccess, block, x - 1, y, z, side, icon, metadata);
                right = isNeighbour(cp, blockAccess, block, x + 1, y, z, side, icon, metadata);
                break;
            }
            case 4: {
                left = isNeighbour(cp, blockAccess, block, x, y, z - 1, side, icon, metadata);
                right = isNeighbour(cp, blockAccess, block, x, y, z + 1, side, icon, metadata);
                break;
            }
            case 5: {
                left = isNeighbour(cp, blockAccess, block, x, y, z + 1, side, icon, metadata);
                right = isNeighbour(cp, blockAccess, block, x, y, z - 1, side, icon, metadata);
                break;
            }
        }
        int index = 3;
        if (left) {
            if (right) {
                index = 1;
            }
            else {
                index = 2;
            }
        }
        else if (right) {
            index = 0;
        }
        else {
            index = 3;
        }
        return cp.tileIcons[index];
    }
    
    private static lx getConnectedTextureVertical(final ConnectedProperties cp, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        if (side == 0 || side == 1) {
            return null;
        }
        final boolean bottom = isNeighbour(cp, blockAccess, block, x, y - 1, z, side, icon, metadata);
        final boolean top = isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata);
        int index = 3;
        if (bottom) {
            if (top) {
                index = 1;
            }
            else {
                index = 2;
            }
        }
        else if (top) {
            index = 0;
        }
        else {
            index = 3;
        }
        return cp.tileIcons[index];
    }
    
    private static lx getConnectedTextureTop(final ConnectedProperties cp, final aak blockAccess, final apa block, final int x, final int y, final int z, final int side, final lx icon, final int metadata) {
        if (side == 0 || side == 1) {
            return null;
        }
        if (isNeighbour(cp, blockAccess, block, x, y + 1, z, side, icon, metadata)) {
            return cp.tileIcons[0];
        }
        return null;
    }
    
    public static boolean isConnectedGlassPanes() {
        return Config.isConnectedTextures() && ConnectedTextures.defaultGlassTexture;
    }
    
    private static boolean getMatchingCtmPng(final bge re) {
        return false;
    }
    
    private static ConnectedProperties makeDefaultProperties(final String methodStr, final bge re) {
        return null;
    }
    
    public static void updateIcons(final bir textureMap) {
        ConnectedTextures.blockProperties = null;
        ConnectedTextures.tileProperties = null;
        ConnectedTextures.defaultGlassTexture = false;
        final bge re = Config.getRenderEngine();
        if (re == null) {
            return;
        }
        final bjt tp = re.getTexturePack().e();
        if (tp == null) {
            return;
        }
        final boolean tpHasGlass = tp.b("/textures/blocks/glass.png", false);
        ConnectedTextures.defaultGlassTexture = !tpHasGlass;
        final String[] names = collectFiles(tp, "ctm/", ".properties");
        Arrays.sort(names);
        final List tileList = new ArrayList();
        final List blockList = new ArrayList();
        for (int i = 0; i < names.length; ++i) {
            final String name = names[i];
            Config.dbg("ConnectedTextures: " + name);
            try {
                final String file = "/" + name;
                final InputStream in = tp.a(file);
                if (in == null) {
                    Config.dbg("ConnectedTextures file not found: " + name);
                }
                else {
                    final Properties props = new Properties();
                    props.load(in);
                    final ConnectedProperties cp = new ConnectedProperties(props, name);
                    if (cp.isValid(file)) {
                        cp.updateIcons(textureMap);
                        addToTileList(cp, tileList);
                        addToBlockList(cp, blockList);
                    }
                }
            }
            catch (FileNotFoundException e2) {
                Config.dbg("ConnectedTextures file not found: " + name);
            }
            catch (IOException e) {
                e.printStackTrace();
            }
        }
        ConnectedTextures.blockProperties = propertyListToArray(blockList);
        ConnectedTextures.tileProperties = propertyListToArray(tileList);
        ConnectedTextures.multipass = detectMultipass();
        Config.dbg("Multipass connected textures: " + ConnectedTextures.multipass);
    }
    
    private static boolean detectMultipass() {
        final List propList = new ArrayList();
        for (int i = 0; i < ConnectedTextures.tileProperties.length; ++i) {
            final ConnectedProperties[] cps = ConnectedTextures.tileProperties[i];
            if (cps != null) {
                propList.addAll(Arrays.asList(cps));
            }
        }
        for (int i = 0; i < ConnectedTextures.blockProperties.length; ++i) {
            final ConnectedProperties[] cps = ConnectedTextures.blockProperties[i];
            if (cps != null) {
                propList.addAll(Arrays.asList(cps));
            }
        }
        final ConnectedProperties[] props = propList.toArray(new ConnectedProperties[propList.size()]);
        final Set matchIconSet = new HashSet();
        final Set tileIconSet = new HashSet();
        for (int j = 0; j < props.length; ++j) {
            final ConnectedProperties cp = props[j];
            if (cp.matchTileIcons != null) {
                matchIconSet.addAll(Arrays.asList(cp.matchTileIcons));
            }
            if (cp.tileIcons != null) {
                tileIconSet.addAll(Arrays.asList(cp.tileIcons));
            }
        }
        matchIconSet.retainAll(tileIconSet);
        return !matchIconSet.isEmpty();
    }
    
    private static ConnectedProperties[][] propertyListToArray(final List list) {
        final ConnectedProperties[][] propArr = new ConnectedProperties[list.size()][];
        for (int i = 0; i < list.size(); ++i) {
            final List subList = list.get(i);
            if (subList != null) {
                final ConnectedProperties[] subArr = subList.toArray(new ConnectedProperties[subList.size()]);
                propArr[i] = subArr;
            }
        }
        return propArr;
    }
    
    private static void addToTileList(final ConnectedProperties cp, final List tileList) {
        if (cp.matchTileIcons == null) {
            return;
        }
        for (int i = 0; i < cp.matchTileIcons.length; ++i) {
            final lx icon = cp.matchTileIcons[i];
            if (!(icon instanceof bil)) {
                Config.dbg("Icon is not TextureStitched: " + icon + ", name: " + icon.i());
            }
            else {
                final bil ts = (bil)icon;
                final int tileId = ts.getIndexInMap();
                if (tileId < 0) {
                    Config.dbg("Invalid tile ID: " + tileId + ", icon: " + ts.i());
                }
                else {
                    addToList(cp, tileList, tileId);
                }
            }
        }
    }
    
    private static void addToBlockList(final ConnectedProperties cp, final List blockList) {
        if (cp.matchBlocks == null) {
            return;
        }
        for (int i = 0; i < cp.matchBlocks.length; ++i) {
            final int blockId = cp.matchBlocks[i];
            if (blockId < 0) {
                Config.dbg("Invalid block ID: " + blockId);
            }
            else {
                addToList(cp, blockList, blockId);
            }
        }
    }
    
    private static void addToList(final ConnectedProperties cp, final List list, final int id) {
        while (id >= list.size()) {
            list.add(null);
        }
        List subList = list.get(id);
        if (subList == null) {
            subList = new ArrayList();
            list.set(id, subList);
        }
        subList.add(cp);
    }
    
    private static String[] collectFiles(final bjt tp, final String prefix, final String suffix) {
        if (!(tp instanceof bjp)) {
            return new String[0];
        }
        final bjp tpi = (bjp)tp;
        if (tpi instanceof bjq) {
            return collectFilesDefault(tpi);
        }
        final File tpFile = tpi.a;
        if (tpFile == null) {
            return new String[0];
        }
        if (tpFile.isDirectory()) {
            return collectFilesFolder(tpFile, "", prefix, suffix);
        }
        if (tpFile.isFile()) {
            return collectFilesZIP(tpFile, prefix, suffix);
        }
        return new String[0];
    }
    
    private static String[] collectFilesDefault(final bjp tpi) {
        final List list = new ArrayList();
        final String[] names = { "ctm/default/bookshelf.properties", "ctm/default/glass.properties", "ctm/default/glasspane.properties", "ctm/default/sandstone.properties" };
        for (int i = 0; i < names.length; ++i) {
            final String name = names[i];
            if (tpi.c("/" + name)) {
                list.add(name);
            }
        }
        final String[] nameArr = list.toArray(new String[list.size()]);
        return nameArr;
    }
    
    private static String[] collectFilesFolder(final File tpFile, final String basePath, final String prefix, final String suffix) {
        final List list = new ArrayList();
        final File[] files = tpFile.listFiles();
        if (files == null) {
            return new String[0];
        }
        for (int i = 0; i < files.length; ++i) {
            final File file = files[i];
            if (file.isFile()) {
                final String name = basePath + file.getName();
                if (name.startsWith(prefix)) {
                    if (name.endsWith(suffix)) {
                        list.add(name);
                    }
                }
            }
            else if (file.isDirectory()) {
                final String dirPath = basePath + file.getName() + "/";
                final String[] names = collectFilesFolder(file, dirPath, prefix, suffix);
                for (int n = 0; n < names.length; ++n) {
                    final String name2 = names[n];
                    list.add(name2);
                }
            }
        }
        final String[] names2 = list.toArray(new String[list.size()]);
        return names2;
    }
    
    private static String[] collectFilesZIP(final File tpFile, final String prefix, final String suffix) {
        final List list = new ArrayList();
        try {
            final ZipFile zf = new ZipFile(tpFile);
            final Enumeration en = zf.entries();
            while (en.hasMoreElements()) {
                final ZipEntry ze = en.nextElement();
                final String name = ze.getName();
                if (!name.startsWith(prefix)) {
                    continue;
                }
                if (!name.endsWith(suffix)) {
                    continue;
                }
                list.add(name);
            }
            zf.close();
            final String[] names = list.toArray(new String[list.size()]);
            return names;
        }
        catch (IOException e) {
            e.printStackTrace();
            return new String[0];
        }
    }
    
    public static int getPaneTextureIndex(final boolean linkP, final boolean linkN, final boolean linkYp, final boolean linkYn) {
        if (linkN && linkP) {
            if (linkYp) {
                if (linkYn) {
                    return 34;
                }
                return 50;
            }
            else {
                if (linkYn) {
                    return 18;
                }
                return 2;
            }
        }
        else if (linkN && !linkP) {
            if (linkYp) {
                if (linkYn) {
                    return 35;
                }
                return 51;
            }
            else {
                if (linkYn) {
                    return 19;
                }
                return 3;
            }
        }
        else if (!linkN && linkP) {
            if (linkYp) {
                if (linkYn) {
                    return 33;
                }
                return 49;
            }
            else {
                if (linkYn) {
                    return 17;
                }
                return 1;
            }
        }
        else if (linkYp) {
            if (linkYn) {
                return 32;
            }
            return 48;
        }
        else {
            if (linkYn) {
                return 16;
            }
            return 0;
        }
    }
    
    public static int getReversePaneTextureIndex(final int texNum) {
        final int col = texNum % 16;
        if (col == 1) {
            return texNum + 2;
        }
        if (col == 3) {
            return texNum - 2;
        }
        return texNum;
    }
    
    public static lx getCtmTexture(final ConnectedProperties cp, final int ctmIndex, final lx icon) {
        if (cp.method != 1) {
            return icon;
        }
        if (ctmIndex < 0 || ctmIndex >= ConnectedTextures.ctmIndexes.length) {
            return icon;
        }
        final int index = ConnectedTextures.ctmIndexes[ctmIndex];
        final lx[] ctmIcons = cp.tileIcons;
        if (index < 0 || index >= ctmIcons.length) {
            return icon;
        }
        return ctmIcons[index];
    }
    
    static {
        ConnectedTextures.blockProperties = null;
        ConnectedTextures.tileProperties = null;
        ConnectedTextures.multipass = false;
        ConnectedTextures.defaultGlassTexture = false;
        propSuffixes = new String[] { "", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z" };
        ctmIndexes = new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 0, 0, 0, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 0, 0, 0, 0, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 0, 0, 0, 0, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 0, 0, 0, 0, 0 };
    }
}
