public class GuiPerformanceSettingsOF extends axr
{
    private axr prevScreen;
    protected String title;
    private avy settings;
    private static awa[] enumOptions;
    private int lastMouseX;
    private int lastMouseY;
    private long mouseStillTime;
    
    public GuiPerformanceSettingsOF(final axr guiscreen, final avy gamesettings) {
        this.lastMouseX = 0;
        this.lastMouseY = 0;
        this.mouseStillTime = 0L;
        this.title = "Performance Settings";
        this.prevScreen = guiscreen;
        this.settings = gamesettings;
    }
    
    public void A_() {
        final bp stringtranslate = bp.a();
        int i = 0;
        for (final awa enumoptions : GuiPerformanceSettingsOF.enumOptions) {
            final int x = this.h / 2 - 155 + i % 2 * 160;
            final int y = this.i / 6 + 21 * (i / 2) - 10;
            if (!enumoptions.a()) {
                this.k.add(new axy(enumoptions.c(), x, y, enumoptions, this.settings.c(enumoptions)));
            }
            else {
                this.k.add(new axx(enumoptions.c(), x, y, enumoptions, this.settings.c(enumoptions), this.settings.a(enumoptions)));
            }
            ++i;
        }
        this.k.add(new awg(200, this.h / 2 - 100, this.i / 6 + 168 + 11, stringtranslate.a("gui.done")));
    }
    
    protected void a(final awg guibutton) {
        if (!guibutton.g) {
            return;
        }
        if (guibutton.f < 100 && guibutton instanceof axy) {
            this.settings.a(((axy)guibutton).b(), 1);
            guibutton.e = this.settings.c(awa.a(guibutton.f));
        }
        if (guibutton.f == 200) {
            this.g.z.b();
            this.g.a(this.prevScreen);
        }
        if (guibutton.f != awa.CLOUD_HEIGHT.ordinal()) {
            final axs scaledresolution = new axs(this.g.z, this.g.c, this.g.d);
            final int i = scaledresolution.a();
            final int j = scaledresolution.b();
            this.a(this.g, i, j);
        }
    }
    
    public void a(final int x, final int y, final float f) {
        this.e();
        this.a(this.m, this.title, this.h / 2, 20, 16777215);
        super.a(x, y, f);
        if (Math.abs(x - this.lastMouseX) > 5 || Math.abs(y - this.lastMouseY) > 5) {
            this.lastMouseX = x;
            this.lastMouseY = y;
            this.mouseStillTime = System.currentTimeMillis();
            return;
        }
        final int activateDelay = 700;
        if (System.currentTimeMillis() < this.mouseStillTime + activateDelay) {
            return;
        }
        final int x2 = this.h / 2 - 150;
        int y2 = this.i / 6 - 5;
        if (y <= y2 + 98) {
            y2 += 105;
        }
        final int x3 = x2 + 150 + 150;
        final int y3 = y2 + 84 + 10;
        final awg btn = this.getSelectedButton(x, y);
        if (btn != null) {
            final String s = this.getButtonName(btn.e);
            final String[] lines = this.getTooltipLines(s);
            if (lines == null) {
                return;
            }
            this.a(x2, y2, x3, y3, -536870912, -536870912);
            for (int i = 0; i < lines.length; ++i) {
                final String line = lines[i];
                this.m.a(line, x2 + 5, y2 + 5 + i * 11, 14540253);
            }
        }
    }
    
    private String[] getTooltipLines(final String btnName) {
        if (btnName.equals("Smooth FPS")) {
            return new String[] { "Stabilizes FPS by flushing the graphic driver buffers", "  OFF - no stabilization, FPS may fluctuate", "  ON - FPS stabilization", "This option is graphic driver dependant and its effect", "is not always visible" };
        }
        if (btnName.equals("Smooth World")) {
            return new String[] { "Removes lag spikes caused by the internal server.", "  OFF - no stabilization, FPS may fluctuate", "  ON - FPS stabilization", "Stabilizes FPS by distributing the internal server load.", "Effective only for local worlds and single-core CPU." };
        }
        if (btnName.equals("Load Far")) {
            return new String[] { "Loads the world chunks at distance Far.", "Switching the render distance does not cause all chunks ", "to be loaded again.", "  OFF - world chunks loaded up to render distance", "  ON - world chunks loaded at distance Far, allows", "       fast render distance switching" };
        }
        if (btnName.equals("Preloaded Chunks")) {
            return new String[] { "Defines an area in which no chunks will be loaded", "  OFF - after 5m new chunks will be loaded", "  2 - after 32m  new chunks will be loaded", "  8 - after 128m new chunks will be loaded", "Higher values need more time to load all the chunks" };
        }
        if (btnName.equals("Chunk Updates")) {
            return new String[] { "Chunk updates per frame", " 1 - (default) slower world loading, higher FPS", " 3 - faster world loading, lower FPS", " 5 - fastest world loading, lowest FPS" };
        }
        if (btnName.equals("Dynamic Updates")) {
            return new String[] { "Dynamic chunk updates", " OFF - (default) standard chunk updates per frame", " ON - more updates while the player is standing still", "Dynamic updates force more chunk updates while", "the player is standing still to load the world faster." };
        }
        if (btnName.equals("Lazy Chunk Loading")) {
            return new String[] { "Lazy Chunk Loading", " OFF - default server chunk loading", " ON - lazy server chunk loading (smoother)", "Smooths the integrated server chunk loading by", "distributing the chunks over several ticks.", "Turn it OFF if parts of the world do not load correctly.", "Effective only for local worlds and single-core CPU." };
        }
        return null;
    }
    
    private String getButtonName(final String displayString) {
        final int pos = displayString.indexOf(58);
        if (pos < 0) {
            return displayString;
        }
        return displayString.substring(0, pos);
    }
    
    private awg getSelectedButton(final int i, final int j) {
        for (int k = 0; k < this.k.size(); ++k) {
            final awg btn = this.k.get(k);
            final boolean flag = i >= btn.c && j >= btn.d && i < btn.c + btn.a && j < btn.d + btn.b;
            if (flag) {
                return btn;
            }
        }
        return null;
    }
    
    static {
        GuiPerformanceSettingsOF.enumOptions = new awa[] { awa.SMOOTH_FPS, awa.SMOOTH_WORLD, awa.LOAD_FAR, awa.PRELOADED_CHUNKS, awa.CHUNK_UPDATES, awa.CHUNK_UPDATES_DYNAMIC, awa.LAZY_CHUNK_LOADING };
    }
}
