import java.lang.reflect.*;

public class Reflector
{
    public static ReflectorClass ModLoader;
    public static ReflectorMethod ModLoader_renderWorldBlock;
    public static ReflectorMethod ModLoader_renderInvBlock;
    public static ReflectorMethod ModLoader_renderBlockIsItemFull3D;
    public static ReflectorClass FMLRenderAccessLibrary;
    public static ReflectorMethod FMLRenderAccessLibrary_renderWorldBlock;
    public static ReflectorMethod FMLRenderAccessLibrary_renderInventoryBlock;
    public static ReflectorMethod FMLRenderAccessLibrary_renderItemAsFull3DBlock;
    public static ReflectorClass LightCache;
    public static ReflectorField LightCache_cache;
    public static ReflectorMethod LightCache_clear;
    public static ReflectorClass BlockCoord;
    public static ReflectorMethod BlockCoord_resetPool;
    public static ReflectorClass MinecraftForge;
    public static ReflectorField MinecraftForge_EVENT_BUS;
    public static ReflectorClass ForgeHooks;
    public static ReflectorMethod ForgeHooks_onLivingSetAttackTarget;
    public static ReflectorMethod ForgeHooks_onLivingUpdate;
    public static ReflectorMethod ForgeHooks_onLivingAttack;
    public static ReflectorMethod ForgeHooks_onLivingHurt;
    public static ReflectorMethod ForgeHooks_onLivingDeath;
    public static ReflectorMethod ForgeHooks_onLivingDrops;
    public static ReflectorMethod ForgeHooks_onLivingFall;
    public static ReflectorMethod ForgeHooks_onLivingJump;
    public static ReflectorMethod ForgeHooks_isLivingOnLadder;
    public static ReflectorClass ForgeHooksClient;
    public static ReflectorMethod ForgeHooksClient_onDrawBlockHighlight;
    public static ReflectorMethod ForgeHooksClient_orientBedCamera;
    public static ReflectorMethod ForgeHooksClient_dispatchRenderLast;
    public static ReflectorMethod ForgeHooksClient_onTextureLoadPre;
    public static ReflectorMethod ForgeHooksClient_onTextureLoad;
    public static ReflectorMethod ForgeHooksClient_setRenderPass;
    public static ReflectorMethod ForgeHooksClient_onTextureStitchedPre;
    public static ReflectorMethod ForgeHooksClient_onTextureStitchedPost;
    public static ReflectorClass FMLCommonHandler;
    public static ReflectorMethod FMLCommonHandler_instance;
    public static ReflectorMethod FMLCommonHandler_handleServerStarting;
    public static ReflectorMethod FMLCommonHandler_handleServerAboutToStart;
    public static ReflectorClass FMLClientHandler;
    public static ReflectorMethod FMLClientHandler_instance;
    public static ReflectorMethod FMLClientHandler_isLoading;
    public static ReflectorClass ForgeWorldProvider;
    public static ReflectorMethod ForgeWorldProvider_getSkyRenderer;
    public static ReflectorMethod ForgeWorldProvider_getCloudRenderer;
    public static ReflectorClass IRenderHandler;
    public static ReflectorMethod IRenderHandler_render;
    public static ReflectorClass DimensionManager;
    public static ReflectorMethod DimensionManager_getStaticDimensionIDs;
    public static ReflectorClass WorldEvent_Load;
    public static ReflectorConstructor WorldEvent_Load_Constructor;
    public static ReflectorClass EventBus;
    public static ReflectorMethod EventBus_post;
    public static ReflectorClass ChunkWatchEvent_UnWatch;
    public static ReflectorConstructor ChunkWatchEvent_UnWatch_Constructor;
    public static ReflectorClass ForgeBlock;
    public static ReflectorMethod ForgeBlock_getBedDirection;
    public static ReflectorMethod ForgeBlock_isBedFoot;
    public static ReflectorMethod ForgeBlock_canRenderInPass;
    public static ReflectorClass ForgeEntity;
    public static ReflectorField ForgeEntity_captureDrops;
    public static ReflectorField ForgeEntity_capturedDrops;
    public static ReflectorClass ForgeItem;
    public static ReflectorMethod ForgeItem_onEntitySwing;
    public static ReflectorClass ForgePotionEffect;
    public static ReflectorMethod ForgePotionEffect_isCurativeItem;
    
    public static void callVoid(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method m = refMethod.getTargetMethod();
            if (m == null) {
                return;
            }
            m.invoke(null, params);
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
        }
    }
    
    public static boolean callBoolean(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return false;
            }
            final Boolean retVal = (Boolean)method.invoke(null, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
            return false;
        }
    }
    
    public static int callInt(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return 0;
            }
            final Integer retVal = (Integer)method.invoke(null, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
            return 0;
        }
    }
    
    public static float callFloat(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return 0.0f;
            }
            final Float retVal = (Float)method.invoke(null, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
            return 0.0f;
        }
    }
    
    public static String callString(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return null;
            }
            final String retVal = (String)method.invoke(null, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
            return null;
        }
    }
    
    public static Object call(final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return null;
            }
            final Object retVal = method.invoke(null, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, null, refMethod, params);
            return null;
        }
    }
    
    public static void callVoid(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            if (obj == null) {
                return;
            }
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return;
            }
            method.invoke(obj, params);
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
        }
    }
    
    public static boolean callBoolean(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return false;
            }
            final Boolean retVal = (Boolean)method.invoke(obj, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
            return false;
        }
    }
    
    public static int callInt(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return 0;
            }
            final Integer retVal = (Integer)method.invoke(obj, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
            return 0;
        }
    }
    
    public static float callFloat(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return 0.0f;
            }
            final Float retVal = (Float)method.invoke(obj, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
            return 0.0f;
        }
    }
    
    public static String callString(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return null;
            }
            final String retVal = (String)method.invoke(obj, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
            return null;
        }
    }
    
    public static Object call(final Object obj, final ReflectorMethod refMethod, final Object... params) {
        try {
            final Method method = refMethod.getTargetMethod();
            if (method == null) {
                return null;
            }
            final Object retVal = method.invoke(obj, params);
            return retVal;
        }
        catch (Throwable e) {
            handleException(e, obj, refMethod, params);
            return null;
        }
    }
    
    public static Object getFieldValue(final ReflectorField refField) {
        return getFieldValue(null, refField);
    }
    
    public static Object getFieldValue(final Object obj, final ReflectorField refField) {
        try {
            final Field field = refField.getTargetField();
            if (field == null) {
                return null;
            }
            final Object value = field.get(obj);
            return value;
        }
        catch (Throwable e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static void setFieldValue(final ReflectorField refField, final Object value) {
        setFieldValue(null, refField, value);
    }
    
    public static void setFieldValue(final Object obj, final ReflectorField refField, final Object value) {
        try {
            final Field field = refField.getTargetField();
            if (field == null) {
                return;
            }
            field.set(obj, value);
        }
        catch (Throwable e) {
            e.printStackTrace();
        }
    }
    
    public static void postForgeBusEvent(final ReflectorConstructor constr, final Object... params) {
        try {
            final Object eventBus = getFieldValue(Reflector.MinecraftForge_EVENT_BUS);
            if (eventBus == null) {
                return;
            }
            final Constructor c = constr.getTargetConstructor();
            if (c == null) {
                return;
            }
            final Object event = c.newInstance(params);
            callVoid(eventBus, Reflector.EventBus_post, event);
        }
        catch (Throwable e) {
            e.printStackTrace();
        }
    }
    
    public static boolean matchesTypes(final Class[] pTypes, final Class[] cTypes) {
        if (pTypes.length != cTypes.length) {
            return false;
        }
        for (int i = 0; i < cTypes.length; ++i) {
            final Class pType = pTypes[i];
            final Class cType = cTypes[i];
            if (pType != cType) {
                return false;
            }
        }
        return true;
    }
    
    private static void dbgCall(final boolean isStatic, final String callType, final ReflectorMethod refMethod, final Object[] params, final Object retVal) {
        final String className = refMethod.getTargetMethod().getDeclaringClass().getName();
        final String methodName = refMethod.getTargetMethod().getName();
        String staticStr = "";
        if (isStatic) {
            staticStr = " static";
        }
        Config.dbg(callType + staticStr + " " + className + "." + methodName + "(" + Config.arrayToString(params) + ") => " + retVal);
    }
    
    private static void dbgCallVoid(final boolean isStatic, final String callType, final ReflectorMethod refMethod, final Object[] params) {
        final String className = refMethod.getTargetMethod().getDeclaringClass().getName();
        final String methodName = refMethod.getTargetMethod().getName();
        String staticStr = "";
        if (isStatic) {
            staticStr = " static";
        }
        Config.dbg(callType + staticStr + " " + className + "." + methodName + "(" + Config.arrayToString(params) + ")");
    }
    
    private static void dbgFieldValue(final boolean isStatic, final String accessType, final ReflectorField refField, final Object val) {
        final String className = refField.getTargetField().getDeclaringClass().getName();
        final String fieldName = refField.getTargetField().getName();
        String staticStr = "";
        if (isStatic) {
            staticStr = " static";
        }
        Config.dbg(accessType + staticStr + " " + className + "." + fieldName + " => " + val);
    }
    
    private static void handleException(final Throwable e, final Object obj, final ReflectorMethod refMethod, final Object[] params) {
        if (e instanceof InvocationTargetException) {
            e.printStackTrace();
            return;
        }
        if (e instanceof IllegalArgumentException) {
            Config.dbg("*** IllegalArgumentException ***");
            Config.dbg("Method: " + refMethod.getTargetMethod());
            Config.dbg("Object: " + obj);
            Config.dbg("Parameter classes: " + Config.arrayToString(getClasses(params)));
            Config.dbg("Parameters: " + Config.arrayToString(params));
        }
        Config.dbg("*** Exception outside of method ***");
        Config.dbg("Method deactivated: " + refMethod.getTargetMethod());
        refMethod.deactivate();
        e.printStackTrace();
    }
    
    private static Object[] getClasses(final Object[] objs) {
        if (objs == null) {
            return new Class[0];
        }
        final Class[] classes = new Class[objs.length];
        for (int i = 0; i < classes.length; ++i) {
            final Object obj = objs[i];
            if (obj != null) {
                classes[i] = obj.getClass();
            }
        }
        return classes;
    }
    
    static {
        Reflector.ModLoader = new ReflectorClass("ModLoader");
        Reflector.ModLoader_renderWorldBlock = new ReflectorMethod(Reflector.ModLoader, "renderWorldBlock");
        Reflector.ModLoader_renderInvBlock = new ReflectorMethod(Reflector.ModLoader, "renderInvBlock");
        Reflector.ModLoader_renderBlockIsItemFull3D = new ReflectorMethod(Reflector.ModLoader, "renderBlockIsItemFull3D");
        Reflector.FMLRenderAccessLibrary = new ReflectorClass("FMLRenderAccessLibrary");
        Reflector.FMLRenderAccessLibrary_renderWorldBlock = new ReflectorMethod(Reflector.FMLRenderAccessLibrary, "renderWorldBlock");
        Reflector.FMLRenderAccessLibrary_renderInventoryBlock = new ReflectorMethod(Reflector.FMLRenderAccessLibrary, "renderInventoryBlock");
        Reflector.FMLRenderAccessLibrary_renderItemAsFull3DBlock = new ReflectorMethod(Reflector.FMLRenderAccessLibrary, "renderItemAsFull3DBlock");
        Reflector.LightCache = new ReflectorClass("LightCache");
        Reflector.LightCache_cache = new ReflectorField(Reflector.LightCache, "cache");
        Reflector.LightCache_clear = new ReflectorMethod(Reflector.LightCache, "clear");
        Reflector.BlockCoord = new ReflectorClass("BlockCoord");
        Reflector.BlockCoord_resetPool = new ReflectorMethod(Reflector.BlockCoord, "resetPool");
        Reflector.MinecraftForge = new ReflectorClass("net.minecraftforge.common.MinecraftForge");
        Reflector.MinecraftForge_EVENT_BUS = new ReflectorField(Reflector.MinecraftForge, "EVENT_BUS");
        Reflector.ForgeHooks = new ReflectorClass("net.minecraftforge.common.ForgeHooks");
        Reflector.ForgeHooks_onLivingSetAttackTarget = new ReflectorMethod(Reflector.ForgeHooks, "onLivingSetAttackTarget");
        Reflector.ForgeHooks_onLivingUpdate = new ReflectorMethod(Reflector.ForgeHooks, "onLivingUpdate");
        Reflector.ForgeHooks_onLivingAttack = new ReflectorMethod(Reflector.ForgeHooks, "onLivingAttack");
        Reflector.ForgeHooks_onLivingHurt = new ReflectorMethod(Reflector.ForgeHooks, "onLivingHurt");
        Reflector.ForgeHooks_onLivingDeath = new ReflectorMethod(Reflector.ForgeHooks, "onLivingDeath");
        Reflector.ForgeHooks_onLivingDrops = new ReflectorMethod(Reflector.ForgeHooks, "onLivingDrops");
        Reflector.ForgeHooks_onLivingFall = new ReflectorMethod(Reflector.ForgeHooks, "onLivingFall");
        Reflector.ForgeHooks_onLivingJump = new ReflectorMethod(Reflector.ForgeHooks, "onLivingJump");
        Reflector.ForgeHooks_isLivingOnLadder = new ReflectorMethod(Reflector.ForgeHooks, "isLivingOnLadder");
        Reflector.ForgeHooksClient = new ReflectorClass("net.minecraftforge.client.ForgeHooksClient");
        Reflector.ForgeHooksClient_onDrawBlockHighlight = new ReflectorMethod(Reflector.ForgeHooksClient, "onDrawBlockHighlight");
        Reflector.ForgeHooksClient_orientBedCamera = new ReflectorMethod(Reflector.ForgeHooksClient, "orientBedCamera");
        Reflector.ForgeHooksClient_dispatchRenderLast = new ReflectorMethod(Reflector.ForgeHooksClient, "dispatchRenderLast");
        Reflector.ForgeHooksClient_onTextureLoadPre = new ReflectorMethod(Reflector.ForgeHooksClient, "onTextureLoadPre");
        Reflector.ForgeHooksClient_onTextureLoad = new ReflectorMethod(Reflector.ForgeHooksClient, "onTextureLoad");
        Reflector.ForgeHooksClient_setRenderPass = new ReflectorMethod(Reflector.ForgeHooksClient, "setRenderPass");
        Reflector.ForgeHooksClient_onTextureStitchedPre = new ReflectorMethod(Reflector.ForgeHooksClient, "onTextureStitchedPre");
        Reflector.ForgeHooksClient_onTextureStitchedPost = new ReflectorMethod(Reflector.ForgeHooksClient, "onTextureStitchedPost");
        Reflector.FMLCommonHandler = new ReflectorClass("cpw.mods.fml.common.FMLCommonHandler");
        Reflector.FMLCommonHandler_instance = new ReflectorMethod(Reflector.FMLCommonHandler, "instance");
        Reflector.FMLCommonHandler_handleServerStarting = new ReflectorMethod(Reflector.FMLCommonHandler, "handleServerStarting");
        Reflector.FMLCommonHandler_handleServerAboutToStart = new ReflectorMethod(Reflector.FMLCommonHandler, "handleServerAboutToStart");
        Reflector.FMLClientHandler = new ReflectorClass("cpw.mods.fml.client.FMLClientHandler");
        Reflector.FMLClientHandler_instance = new ReflectorMethod(Reflector.FMLClientHandler, "instance");
        Reflector.FMLClientHandler_isLoading = new ReflectorMethod(Reflector.FMLClientHandler, "isLoading");
        Reflector.ForgeWorldProvider = new ReflectorClass(acn.class);
        Reflector.ForgeWorldProvider_getSkyRenderer = new ReflectorMethod(Reflector.ForgeWorldProvider, "getSkyRenderer");
        Reflector.ForgeWorldProvider_getCloudRenderer = new ReflectorMethod(Reflector.ForgeWorldProvider, "getCloudRenderer");
        Reflector.IRenderHandler = new ReflectorClass("net.minecraftforge.client.IRenderHandler");
        Reflector.IRenderHandler_render = new ReflectorMethod(Reflector.IRenderHandler, "render");
        Reflector.DimensionManager = new ReflectorClass("net.minecraftforge.common.DimensionManager");
        Reflector.DimensionManager_getStaticDimensionIDs = new ReflectorMethod(Reflector.DimensionManager, "getStaticDimensionIDs");
        Reflector.WorldEvent_Load = new ReflectorClass("net.minecraftforge.event.world.WorldEvent$Load");
        Reflector.WorldEvent_Load_Constructor = new ReflectorConstructor(Reflector.WorldEvent_Load, new Class[] { aab.class });
        Reflector.EventBus = new ReflectorClass("net.minecraftforge.event.EventBus");
        Reflector.EventBus_post = new ReflectorMethod(Reflector.EventBus, "post");
        Reflector.ChunkWatchEvent_UnWatch = new ReflectorClass("net.minecraftforge.event.world.ChunkWatchEvent$UnWatch");
        Reflector.ChunkWatchEvent_UnWatch_Constructor = new ReflectorConstructor(Reflector.ChunkWatchEvent_UnWatch, new Class[] { zu.class, jc.class });
        Reflector.ForgeBlock = new ReflectorClass(apa.class);
        Reflector.ForgeBlock_getBedDirection = new ReflectorMethod(Reflector.ForgeBlock, "getBedDirection");
        Reflector.ForgeBlock_isBedFoot = new ReflectorMethod(Reflector.ForgeBlock, "isBedFoot");
        Reflector.ForgeBlock_canRenderInPass = new ReflectorMethod(Reflector.ForgeBlock, "canRenderInPass");
        Reflector.ForgeEntity = new ReflectorClass(mp.class);
        Reflector.ForgeEntity_captureDrops = new ReflectorField(Reflector.ForgeEntity, "captureDrops");
        Reflector.ForgeEntity_capturedDrops = new ReflectorField(Reflector.ForgeEntity, "capturedDrops");
        Reflector.ForgeItem = new ReflectorClass(wk.class);
        Reflector.ForgeItem_onEntitySwing = new ReflectorMethod(Reflector.ForgeItem, "onEntitySwing");
        Reflector.ForgePotionEffect = new ReflectorClass(ml.class);
        Reflector.ForgePotionEffect_isCurativeItem = new ReflectorMethod(Reflector.ForgePotionEffect, "isCurativeItem");
    }
}
