import java.util.*;
import java.awt.image.*;
import java.awt.*;

public class TextureUtils
{
    public static final String texGrassTop = "grass_top";
    public static final String texStone = "stone";
    public static final String texDirt = "dirt";
    public static final String texGrassSide = "grass_side";
    public static final String texStoneslabSide = "stoneslab_side";
    public static final String texStoneslabTop = "stoneslab_top";
    public static final String texBedrock = "bedrock";
    public static final String texSand = "sand";
    public static final String texGravel = "gravel";
    public static final String texTreeSide = "tree_side";
    public static final String texTreeTop = "tree_top";
    public static final String texOreGold = "oreGold";
    public static final String texOreIron = "oreIron";
    public static final String texOreCoal = "oreCoal";
    public static final String texObsidian = "obsidian";
    public static final String texGrassSideOverlay = "grass_side_overlay";
    public static final String texSnow = "snow";
    public static final String texSnowSide = "snow_side";
    public static final String texMycelSide = "mycel_side";
    public static final String texMycelTop = "mycel_top";
    public static final String texOreDiamond = "oreDiamond";
    public static final String texOreRedstone = "oreRedstone";
    public static final String texOreLapis = "oreLapis";
    public static final String texLeaves = "leaves";
    public static final String texLeavesOpaque = "leaves_opaque";
    public static final String texLeavesJungle = "leaves_jungle";
    public static final String texLeavesJungleOpaque = "leaves_jungle_opaque";
    public static final String texCactusSide = "cactus_side";
    public static final String texClay = "clay";
    public static final String texFarmlandWet = "farmland_wet";
    public static final String texFarmlandDry = "farmland_dry";
    public static final String texHellrock = "hellrock";
    public static final String texHellsand = "hellsand";
    public static final String texLightgem = "lightgem";
    public static final String texTreeSpruce = "tree_spruce";
    public static final String texTreeBirch = "tree_birch";
    public static final String texLeavesSpruce = "leaves_spruce";
    public static final String texLeavesSpruceOpaque = "leaves_spruce_opaque";
    public static final String texTreeJungle = "tree_jungle";
    public static final String texWhiteStone = "whiteStone";
    public static final String texSandstoneTop = "sandstone_top";
    public static final String texSandstoneBottom = "sandstone_bottom";
    public static final String texRedstoneLight = "redstoneLight";
    public static final String texRedstoneLightLit = "redstoneLight_lit";
    public static final String texWater = "water";
    public static final String texWaterFlow = "water_flow";
    public static final String texLava = "lava";
    public static final String texLavaFlow = "lava_flow";
    public static final String texFire0 = "fire_0";
    public static final String texFire1 = "fire_1";
    public static final String texPortal = "portal";
    public static lx iconGrassTop;
    public static lx iconGrassSide;
    public static lx iconGrassSideOverlay;
    public static lx iconSnow;
    public static lx iconSnowSide;
    public static lx iconMycelSide;
    public static lx iconMycelTop;
    public static lx iconWater;
    public static lx iconWaterFlow;
    public static lx iconLava;
    public static lx iconLavaFlow;
    public static lx iconPortal;
    public static lx iconFire0;
    public static lx iconFire1;
    private static Set atlasNames;
    private static Set atlasIds;
    
    private static Set makeAtlasNames() {
        final Set set = new HashSet();
        set.add("/terrain.png");
        set.add("/gui/items.png");
        set.add("/ctm.png");
        set.add("/eloraam/world/world1.png");
        set.add("/gfx/buildcraft/blocks/blocks.png");
        return set;
    }
    
    public static void update(final bge re) {
        final bir terrain = re.i;
        TextureUtils.iconGrassTop = terrain.a("grass_top");
        TextureUtils.iconGrassSide = terrain.a("grass_side");
        TextureUtils.iconGrassSideOverlay = terrain.a("grass_side_overlay");
        TextureUtils.iconSnow = terrain.a("snow");
        TextureUtils.iconSnowSide = terrain.a("snow_side");
        TextureUtils.iconMycelSide = terrain.a("mycel_side");
        TextureUtils.iconMycelTop = terrain.a("mycel_top");
        TextureUtils.iconWater = terrain.a("water");
        TextureUtils.iconWaterFlow = terrain.a("water_flow");
        TextureUtils.iconLava = terrain.a("lava");
        TextureUtils.iconLavaFlow = terrain.a("lava_flow");
        TextureUtils.iconFire0 = terrain.a("fire_0");
        TextureUtils.iconFire1 = terrain.a("fire_1");
        TextureUtils.iconPortal = terrain.a("portal");
    }
    
    public static void textureCreated(final String name, final int id) {
        if (TextureUtils.atlasNames.contains(name)) {
            TextureUtils.atlasIds.add(id);
        }
    }
    
    public static void addAtlasName(final String name) {
        if (name == null) {
            return;
        }
        TextureUtils.atlasNames.add(name);
        Config.dbg("TextureAtlas: " + name);
    }
    
    public static boolean isAtlasId(final int i) {
        return TextureUtils.atlasIds.contains(i);
    }
    
    public static boolean isAtlasName(final String name) {
        return TextureUtils.atlasNames.contains(name);
    }
    
    public static BufferedImage fixTextureDimensions(final String name, final BufferedImage bi) {
        if (name.startsWith("/mob/zombie") || name.startsWith("/mob/pigzombie")) {
            final int width = bi.getWidth();
            final int height = bi.getHeight();
            if (width == height * 2) {
                final BufferedImage scaledImage = new BufferedImage(width, height * 2, 2);
                final Graphics2D gr = scaledImage.createGraphics();
                gr.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
                gr.drawImage(bi, 0, 0, width, height, null);
                return scaledImage;
            }
        }
        return bi;
    }
    
    public static bil getTextureStitched(final lx icon) {
        if (icon instanceof bil) {
            return (bil)icon;
        }
        return null;
    }
    
    public static int ceilPowerOfTwo(final int val) {
        int i;
        for (i = 1; i < val; i *= 2) {}
        return i;
    }
    
    public static int getPowerOfTwo(final int val) {
        int i;
        int po2;
        for (i = 1, po2 = 0; i < val; i *= 2, ++po2) {}
        return po2;
    }
    
    public static int twoToPower(final int power) {
        int val = 1;
        for (int i = 0; i < power; ++i) {
            val *= 2;
        }
        return val;
    }
    
    static {
        TextureUtils.atlasNames = makeAtlasNames();
        TextureUtils.atlasIds = new HashSet();
    }
}
