import java.net.*;
import java.io.*;

public class VersionCheckThread extends Thread
{
    public void run() {
        HttpURLConnection conn = null;
        try {
            Config.dbg("Checking for new version");
            final URL url = new URL("http://optifine.net/version/1.5.2/HD_U.txt");
            conn = (HttpURLConnection)url.openConnection();
            conn.setDoInput(true);
            conn.setDoOutput(false);
            conn.connect();
            try {
                final InputStream in = conn.getInputStream();
                final String verStr = Config.readInputStream(in);
                in.close();
                final String[] verLines = Config.tokenize(verStr, "\n\r");
                if (verLines.length < 1) {
                    return;
                }
                final String newVer = verLines[0];
                Config.dbg("Version found: " + newVer);
                if (Config.compareRelease(newVer, "D2") <= 0) {
                    return;
                }
                Config.setNewRelease(newVer);
            }
            finally {
                if (conn != null) {
                    conn.disconnect();
                }
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
