import java.util.*;

public class WrUpdates
{
    private static IWrUpdater wrUpdater;
    
    public static void setWrUpdater(final IWrUpdater updater) {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.terminate();
        }
        WrUpdates.wrUpdater = updater;
        if (WrUpdates.wrUpdater != null) {
            try {
                WrUpdates.wrUpdater.initialize();
            }
            catch (Exception e) {
                WrUpdates.wrUpdater = null;
                e.printStackTrace();
            }
        }
    }
    
    public static boolean hasWrUpdater() {
        return WrUpdates.wrUpdater != null;
    }
    
    public static IWrUpdater getWrUpdater() {
        return WrUpdates.wrUpdater;
    }
    
    public static bfm makeWorldRenderer(final aab worldObj, final List tileEntities, final int x, final int y, final int z, final int glRenderListBase) {
        if (WrUpdates.wrUpdater == null) {
            return new bfm(worldObj, tileEntities, x, y, z, glRenderListBase);
        }
        return WrUpdates.wrUpdater.makeWorldRenderer(worldObj, tileEntities, x, y, z, glRenderListBase);
    }
    
    public static boolean updateRenderers(final bfy rg, final ng entityliving, final boolean flag) {
        try {
            return WrUpdates.wrUpdater.updateRenderers(rg, entityliving, flag);
        }
        catch (Exception e) {
            e.printStackTrace();
            setWrUpdater(null);
            return false;
        }
    }
    
    public static void resumeBackgroundUpdates() {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.resumeBackgroundUpdates();
        }
    }
    
    public static void pauseBackgroundUpdates() {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.pauseBackgroundUpdates();
        }
    }
    
    public static void finishCurrentUpdate() {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.finishCurrentUpdate();
        }
    }
    
    public static void preRender(final bfy rg, final ng player) {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.preRender(rg, player);
        }
    }
    
    public static void postRender() {
        if (WrUpdates.wrUpdater != null) {
            WrUpdates.wrUpdater.postRender();
        }
    }
    
    static {
        WrUpdates.wrUpdater = null;
    }
}
