package net.minecraft.src;

import java.io.*;

public class Packet53BlockChange extends Packet
{
    public int xPosition;
    public int yPosition;
    public int zPosition;
    public int type;
    public int metadata;
    
    public Packet53BlockChange() {
        this.isChunkDataPacket = true;
    }
    
    public Packet53BlockChange(final int par1, final int par2, final int par3, final World par4World) {
        this.isChunkDataPacket = true;
        this.xPosition = par1;
        this.yPosition = par2;
        this.zPosition = par3;
        this.type = par4World.getBlockId(par1, par2, par3);
        this.metadata = par4World.getBlockMetadata(par1, par2, par3);
    }
    
    @Override
    public void readPacketData(final DataInputStream par1DataInputStream) throws IOException {
        this.xPosition = par1DataInputStream.readInt();
        this.yPosition = par1DataInputStream.read();
        this.zPosition = par1DataInputStream.readInt();
        this.type = par1DataInputStream.readShort();
        this.metadata = par1DataInputStream.read();
    }
    
    @Override
    public void writePacketData(final DataOutputStream par1DataOutputStream) throws IOException {
        par1DataOutputStream.writeInt(this.xPosition);
        par1DataOutputStream.write(this.yPosition);
        par1DataOutputStream.writeInt(this.zPosition);
        par1DataOutputStream.writeShort(this.type);
        par1DataOutputStream.write(this.metadata);
    }
    
    @Override
    public void processPacket(final NetHandler par1NetHandler) {
        par1NetHandler.handleBlockChange(this);
    }
    
    @Override
    public int getPacketSize() {
        return 11;
    }
}
