package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.*;

public interface PKCSObjectIdentifiers
{
    public static final ASN1ObjectIdentifier pkcs_1 = new ASN1ObjectIdentifier("1.2.840.113549.1.1");
    public static final ASN1ObjectIdentifier rsaEncryption = PKCSObjectIdentifiers.pkcs_1.branch("1");
    public static final ASN1ObjectIdentifier md2WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("2");
    public static final ASN1ObjectIdentifier md4WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("3");
    public static final ASN1ObjectIdentifier md5WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("4");
    public static final ASN1ObjectIdentifier sha1WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("5");
    public static final ASN1ObjectIdentifier srsaOAEPEncryptionSET = PKCSObjectIdentifiers.pkcs_1.branch("6");
    public static final ASN1ObjectIdentifier id_RSAES_OAEP = PKCSObjectIdentifiers.pkcs_1.branch("7");
    public static final ASN1ObjectIdentifier id_mgf1 = PKCSObjectIdentifiers.pkcs_1.branch("8");
    public static final ASN1ObjectIdentifier id_pSpecified = PKCSObjectIdentifiers.pkcs_1.branch("9");
    public static final ASN1ObjectIdentifier id_RSASSA_PSS = PKCSObjectIdentifiers.pkcs_1.branch("10");
    public static final ASN1ObjectIdentifier sha256WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("11");
    public static final ASN1ObjectIdentifier sha384WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("12");
    public static final ASN1ObjectIdentifier sha512WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("13");
    public static final ASN1ObjectIdentifier sha224WithRSAEncryption = PKCSObjectIdentifiers.pkcs_1.branch("14");
    public static final ASN1ObjectIdentifier pkcs_3 = new ASN1ObjectIdentifier("1.2.840.113549.1.3");
    public static final ASN1ObjectIdentifier dhKeyAgreement = PKCSObjectIdentifiers.pkcs_3.branch("1");
    public static final ASN1ObjectIdentifier pkcs_5 = new ASN1ObjectIdentifier("1.2.840.113549.1.5");
    public static final ASN1ObjectIdentifier pbeWithMD2AndDES_CBC = PKCSObjectIdentifiers.pkcs_5.branch("1");
    public static final ASN1ObjectIdentifier pbeWithMD2AndRC2_CBC = PKCSObjectIdentifiers.pkcs_5.branch("4");
    public static final ASN1ObjectIdentifier pbeWithMD5AndDES_CBC = PKCSObjectIdentifiers.pkcs_5.branch("3");
    public static final ASN1ObjectIdentifier pbeWithMD5AndRC2_CBC = PKCSObjectIdentifiers.pkcs_5.branch("6");
    public static final ASN1ObjectIdentifier pbeWithSHA1AndDES_CBC = PKCSObjectIdentifiers.pkcs_5.branch("10");
    public static final ASN1ObjectIdentifier pbeWithSHA1AndRC2_CBC = PKCSObjectIdentifiers.pkcs_5.branch("11");
    public static final ASN1ObjectIdentifier id_PBES2 = PKCSObjectIdentifiers.pkcs_5.branch("13");
    public static final ASN1ObjectIdentifier id_PBKDF2 = PKCSObjectIdentifiers.pkcs_5.branch("12");
    public static final ASN1ObjectIdentifier encryptionAlgorithm = new ASN1ObjectIdentifier("1.2.840.113549.3");
    public static final ASN1ObjectIdentifier des_EDE3_CBC = PKCSObjectIdentifiers.encryptionAlgorithm.branch("7");
    public static final ASN1ObjectIdentifier RC2_CBC = PKCSObjectIdentifiers.encryptionAlgorithm.branch("2");
    public static final ASN1ObjectIdentifier digestAlgorithm = new ASN1ObjectIdentifier("1.2.840.113549.2");
    public static final ASN1ObjectIdentifier md2 = PKCSObjectIdentifiers.digestAlgorithm.branch("2");
    public static final ASN1ObjectIdentifier md4 = PKCSObjectIdentifiers.digestAlgorithm.branch("4");
    public static final ASN1ObjectIdentifier md5 = PKCSObjectIdentifiers.digestAlgorithm.branch("5");
    public static final ASN1ObjectIdentifier id_hmacWithSHA1 = PKCSObjectIdentifiers.digestAlgorithm.branch("7");
    public static final ASN1ObjectIdentifier id_hmacWithSHA224 = PKCSObjectIdentifiers.digestAlgorithm.branch("8");
    public static final ASN1ObjectIdentifier id_hmacWithSHA256 = PKCSObjectIdentifiers.digestAlgorithm.branch("9");
    public static final ASN1ObjectIdentifier id_hmacWithSHA384 = PKCSObjectIdentifiers.digestAlgorithm.branch("10");
    public static final ASN1ObjectIdentifier id_hmacWithSHA512 = PKCSObjectIdentifiers.digestAlgorithm.branch("11");
    public static final ASN1ObjectIdentifier data = new ASN1ObjectIdentifier("1.2.840.113549.1.7.1");
    public static final ASN1ObjectIdentifier signedData = new ASN1ObjectIdentifier("1.2.840.113549.1.7.2");
    public static final ASN1ObjectIdentifier envelopedData = new ASN1ObjectIdentifier("1.2.840.113549.1.7.3");
    public static final ASN1ObjectIdentifier signedAndEnvelopedData = new ASN1ObjectIdentifier("1.2.840.113549.1.7.4");
    public static final ASN1ObjectIdentifier digestedData = new ASN1ObjectIdentifier("1.2.840.113549.1.7.5");
    public static final ASN1ObjectIdentifier encryptedData = new ASN1ObjectIdentifier("1.2.840.113549.1.7.6");
    public static final ASN1ObjectIdentifier pkcs_9 = new ASN1ObjectIdentifier("1.2.840.113549.1.9");
    public static final ASN1ObjectIdentifier pkcs_9_at_emailAddress = PKCSObjectIdentifiers.pkcs_9.branch("1");
    public static final ASN1ObjectIdentifier pkcs_9_at_unstructuredName = PKCSObjectIdentifiers.pkcs_9.branch("2");
    public static final ASN1ObjectIdentifier pkcs_9_at_contentType = PKCSObjectIdentifiers.pkcs_9.branch("3");
    public static final ASN1ObjectIdentifier pkcs_9_at_messageDigest = PKCSObjectIdentifiers.pkcs_9.branch("4");
    public static final ASN1ObjectIdentifier pkcs_9_at_signingTime = PKCSObjectIdentifiers.pkcs_9.branch("5");
    public static final ASN1ObjectIdentifier pkcs_9_at_counterSignature = PKCSObjectIdentifiers.pkcs_9.branch("6");
    public static final ASN1ObjectIdentifier pkcs_9_at_challengePassword = PKCSObjectIdentifiers.pkcs_9.branch("7");
    public static final ASN1ObjectIdentifier pkcs_9_at_unstructuredAddress = PKCSObjectIdentifiers.pkcs_9.branch("8");
    public static final ASN1ObjectIdentifier pkcs_9_at_extendedCertificateAttributes = PKCSObjectIdentifiers.pkcs_9.branch("9");
    public static final ASN1ObjectIdentifier pkcs_9_at_signingDescription = PKCSObjectIdentifiers.pkcs_9.branch("13");
    public static final ASN1ObjectIdentifier pkcs_9_at_extensionRequest = PKCSObjectIdentifiers.pkcs_9.branch("14");
    public static final ASN1ObjectIdentifier pkcs_9_at_smimeCapabilities = PKCSObjectIdentifiers.pkcs_9.branch("15");
    public static final ASN1ObjectIdentifier pkcs_9_at_friendlyName = PKCSObjectIdentifiers.pkcs_9.branch("20");
    public static final ASN1ObjectIdentifier pkcs_9_at_localKeyId = PKCSObjectIdentifiers.pkcs_9.branch("21");
    public static final ASN1ObjectIdentifier x509certType = PKCSObjectIdentifiers.pkcs_9.branch("22.1");
    public static final ASN1ObjectIdentifier certTypes = PKCSObjectIdentifiers.pkcs_9.branch("22");
    public static final ASN1ObjectIdentifier x509Certificate = PKCSObjectIdentifiers.certTypes.branch("1");
    public static final ASN1ObjectIdentifier sdsiCertificate = PKCSObjectIdentifiers.certTypes.branch("2");
    public static final ASN1ObjectIdentifier crlTypes = PKCSObjectIdentifiers.pkcs_9.branch("23");
    public static final ASN1ObjectIdentifier x509Crl = PKCSObjectIdentifiers.crlTypes.branch("1");
    public static final ASN1ObjectIdentifier id_alg_PWRI_KEK = PKCSObjectIdentifiers.pkcs_9.branch("16.3.9");
    public static final ASN1ObjectIdentifier preferSignedData = PKCSObjectIdentifiers.pkcs_9.branch("15.1");
    public static final ASN1ObjectIdentifier canNotDecryptAny = PKCSObjectIdentifiers.pkcs_9.branch("15.2");
    public static final ASN1ObjectIdentifier sMIMECapabilitiesVersions = PKCSObjectIdentifiers.pkcs_9.branch("15.3");
    public static final ASN1ObjectIdentifier id_ct = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.1");
    public static final ASN1ObjectIdentifier id_ct_authData = PKCSObjectIdentifiers.id_ct.branch("2");
    public static final ASN1ObjectIdentifier id_ct_TSTInfo = PKCSObjectIdentifiers.id_ct.branch("4");
    public static final ASN1ObjectIdentifier id_ct_compressedData = PKCSObjectIdentifiers.id_ct.branch("9");
    public static final ASN1ObjectIdentifier id_ct_authEnvelopedData = PKCSObjectIdentifiers.id_ct.branch("23");
    public static final ASN1ObjectIdentifier id_ct_timestampedData = PKCSObjectIdentifiers.id_ct.branch("31");
    public static final ASN1ObjectIdentifier id_cti = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.6");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfOrigin = PKCSObjectIdentifiers.id_cti.branch("1");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfReceipt = PKCSObjectIdentifiers.id_cti.branch("2");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfDelivery = PKCSObjectIdentifiers.id_cti.branch("3");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfSender = PKCSObjectIdentifiers.id_cti.branch("4");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfApproval = PKCSObjectIdentifiers.id_cti.branch("5");
    public static final ASN1ObjectIdentifier id_cti_ets_proofOfCreation = PKCSObjectIdentifiers.id_cti.branch("6");
    public static final ASN1ObjectIdentifier id_aa = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.2");
    public static final ASN1ObjectIdentifier id_aa_receiptRequest = PKCSObjectIdentifiers.id_aa.branch("1");
    public static final ASN1ObjectIdentifier id_aa_contentHint = PKCSObjectIdentifiers.id_aa.branch("4");
    public static final ASN1ObjectIdentifier id_aa_msgSigDigest = PKCSObjectIdentifiers.id_aa.branch("5");
    public static final ASN1ObjectIdentifier id_aa_contentReference = PKCSObjectIdentifiers.id_aa.branch("10");
    public static final ASN1ObjectIdentifier id_aa_encrypKeyPref = PKCSObjectIdentifiers.id_aa.branch("11");
    public static final ASN1ObjectIdentifier id_aa_signingCertificate = PKCSObjectIdentifiers.id_aa.branch("12");
    public static final ASN1ObjectIdentifier id_aa_signingCertificateV2 = PKCSObjectIdentifiers.id_aa.branch("47");
    public static final ASN1ObjectIdentifier id_aa_contentIdentifier = PKCSObjectIdentifiers.id_aa.branch("7");
    public static final ASN1ObjectIdentifier id_aa_signatureTimeStampToken = PKCSObjectIdentifiers.id_aa.branch("14");
    public static final ASN1ObjectIdentifier id_aa_ets_sigPolicyId = PKCSObjectIdentifiers.id_aa.branch("15");
    public static final ASN1ObjectIdentifier id_aa_ets_commitmentType = PKCSObjectIdentifiers.id_aa.branch("16");
    public static final ASN1ObjectIdentifier id_aa_ets_signerLocation = PKCSObjectIdentifiers.id_aa.branch("17");
    public static final ASN1ObjectIdentifier id_aa_ets_signerAttr = PKCSObjectIdentifiers.id_aa.branch("18");
    public static final ASN1ObjectIdentifier id_aa_ets_otherSigCert = PKCSObjectIdentifiers.id_aa.branch("19");
    public static final ASN1ObjectIdentifier id_aa_ets_contentTimestamp = PKCSObjectIdentifiers.id_aa.branch("20");
    public static final ASN1ObjectIdentifier id_aa_ets_certificateRefs = PKCSObjectIdentifiers.id_aa.branch("21");
    public static final ASN1ObjectIdentifier id_aa_ets_revocationRefs = PKCSObjectIdentifiers.id_aa.branch("22");
    public static final ASN1ObjectIdentifier id_aa_ets_certValues = PKCSObjectIdentifiers.id_aa.branch("23");
    public static final ASN1ObjectIdentifier id_aa_ets_revocationValues = PKCSObjectIdentifiers.id_aa.branch("24");
    public static final ASN1ObjectIdentifier id_aa_ets_escTimeStamp = PKCSObjectIdentifiers.id_aa.branch("25");
    public static final ASN1ObjectIdentifier id_aa_ets_certCRLTimestamp = PKCSObjectIdentifiers.id_aa.branch("26");
    public static final ASN1ObjectIdentifier id_aa_ets_archiveTimestamp = PKCSObjectIdentifiers.id_aa.branch("27");
    public static final ASN1ObjectIdentifier id_aa_sigPolicyId = PKCSObjectIdentifiers.id_aa_ets_sigPolicyId;
    public static final ASN1ObjectIdentifier id_aa_commitmentType = PKCSObjectIdentifiers.id_aa_ets_commitmentType;
    public static final ASN1ObjectIdentifier id_aa_signerLocation = PKCSObjectIdentifiers.id_aa_ets_signerLocation;
    public static final ASN1ObjectIdentifier id_aa_otherSigCert = PKCSObjectIdentifiers.id_aa_ets_otherSigCert;
    public static final ASN1ObjectIdentifier id_spq_ets_uri = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.5.1");
    public static final ASN1ObjectIdentifier id_spq_ets_unotice = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.5.2");
    public static final ASN1ObjectIdentifier pkcs_12 = new ASN1ObjectIdentifier("1.2.840.113549.1.12");
    public static final ASN1ObjectIdentifier bagtypes = PKCSObjectIdentifiers.pkcs_12.branch("10.1");
    public static final ASN1ObjectIdentifier keyBag = PKCSObjectIdentifiers.bagtypes.branch("1");
    public static final ASN1ObjectIdentifier pkcs8ShroudedKeyBag = PKCSObjectIdentifiers.bagtypes.branch("2");
    public static final ASN1ObjectIdentifier certBag = PKCSObjectIdentifiers.bagtypes.branch("3");
    public static final ASN1ObjectIdentifier crlBag = PKCSObjectIdentifiers.bagtypes.branch("4");
    public static final ASN1ObjectIdentifier secretBag = PKCSObjectIdentifiers.bagtypes.branch("5");
    public static final ASN1ObjectIdentifier safeContentsBag = PKCSObjectIdentifiers.bagtypes.branch("6");
    public static final ASN1ObjectIdentifier pkcs_12PbeIds = PKCSObjectIdentifiers.pkcs_12.branch("1");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd128BitRC4 = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("1");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd40BitRC4 = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("2");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd3_KeyTripleDES_CBC = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("3");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd2_KeyTripleDES_CBC = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("4");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd128BitRC2_CBC = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("5");
    public static final ASN1ObjectIdentifier pbeWithSHAAnd40BitRC2_CBC = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("6");
    public static final ASN1ObjectIdentifier pbewithSHAAnd40BitRC2_CBC = PKCSObjectIdentifiers.pkcs_12PbeIds.branch("6");
    public static final ASN1ObjectIdentifier id_alg_CMS3DESwrap = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.3.6");
    public static final ASN1ObjectIdentifier id_alg_CMSRC2wrap = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.3.7");
}
