package org.lwjgl;

import java.awt.*;

final class LinuxSysImplementation extends J2SESysImplementation
{
    private static final int JNI_VERSION = 18;
    
    public int getRequiredJNIVersion() {
        return 18;
    }
    
    public boolean openURL(final String url) {
        final String[] browsers = { "xdg-open", "firefox", "mozilla", "opera", "konqueror", "nautilus", "galeon", "netscape" };
        int i = 0;
        while (i < browsers.length) {
            final String browser = browsers[i];
            try {
                LWJGLUtil.execPrivileged(new String[] { browser, url });
                return true;
            }
            catch (Exception e) {
                e.printStackTrace(System.err);
                ++i;
                continue;
            }
            break;
        }
        return false;
    }
    
    public boolean has64Bit() {
        return true;
    }
    
    static {
        Toolkit.getDefaultToolkit();
    }
}
