package org.lwjgl.openal;

import org.lwjgl.*;
import java.nio.*;

public final class AL10
{
    public static final int AL_INVALID = -1;
    public static final int AL_NONE = 0;
    public static final int AL_FALSE = 0;
    public static final int AL_TRUE = 1;
    public static final int AL_SOURCE_TYPE = 4135;
    public static final int AL_SOURCE_ABSOLUTE = 513;
    public static final int AL_SOURCE_RELATIVE = 514;
    public static final int AL_CONE_INNER_ANGLE = 4097;
    public static final int AL_CONE_OUTER_ANGLE = 4098;
    public static final int AL_PITCH = 4099;
    public static final int AL_POSITION = 4100;
    public static final int AL_DIRECTION = 4101;
    public static final int AL_VELOCITY = 4102;
    public static final int AL_LOOPING = 4103;
    public static final int AL_BUFFER = 4105;
    public static final int AL_GAIN = 4106;
    public static final int AL_MIN_GAIN = 4109;
    public static final int AL_MAX_GAIN = 4110;
    public static final int AL_ORIENTATION = 4111;
    public static final int AL_REFERENCE_DISTANCE = 4128;
    public static final int AL_ROLLOFF_FACTOR = 4129;
    public static final int AL_CONE_OUTER_GAIN = 4130;
    public static final int AL_MAX_DISTANCE = 4131;
    public static final int AL_CHANNEL_MASK = 12288;
    public static final int AL_SOURCE_STATE = 4112;
    public static final int AL_INITIAL = 4113;
    public static final int AL_PLAYING = 4114;
    public static final int AL_PAUSED = 4115;
    public static final int AL_STOPPED = 4116;
    public static final int AL_BUFFERS_QUEUED = 4117;
    public static final int AL_BUFFERS_PROCESSED = 4118;
    public static final int AL_FORMAT_MONO8 = 4352;
    public static final int AL_FORMAT_MONO16 = 4353;
    public static final int AL_FORMAT_STEREO8 = 4354;
    public static final int AL_FORMAT_STEREO16 = 4355;
    public static final int AL_FORMAT_VORBIS_EXT = 65539;
    public static final int AL_FREQUENCY = 8193;
    public static final int AL_BITS = 8194;
    public static final int AL_CHANNELS = 8195;
    public static final int AL_SIZE = 8196;
    public static final int AL_DATA = 8197;
    public static final int AL_UNUSED = 8208;
    public static final int AL_PENDING = 8209;
    public static final int AL_PROCESSED = 8210;
    public static final int AL_NO_ERROR = 0;
    public static final int AL_INVALID_NAME = 40961;
    public static final int AL_INVALID_ENUM = 40962;
    public static final int AL_INVALID_VALUE = 40963;
    public static final int AL_INVALID_OPERATION = 40964;
    public static final int AL_OUT_OF_MEMORY = 40965;
    public static final int AL_VENDOR = 45057;
    public static final int AL_VERSION = 45058;
    public static final int AL_RENDERER = 45059;
    public static final int AL_EXTENSIONS = 45060;
    public static final int AL_DOPPLER_FACTOR = 49152;
    public static final int AL_DOPPLER_VELOCITY = 49153;
    public static final int AL_DISTANCE_MODEL = 53248;
    public static final int AL_INVERSE_DISTANCE = 53249;
    public static final int AL_INVERSE_DISTANCE_CLAMPED = 53250;
    
    static native void initNativeStubs() throws LWJGLException;
    
    public static native void alEnable(final int p0);
    
    public static native void alDisable(final int p0);
    
    public static native boolean alIsEnabled(final int p0);
    
    public static native boolean alGetBoolean(final int p0);
    
    public static native int alGetInteger(final int p0);
    
    public static native float alGetFloat(final int p0);
    
    public static native double alGetDouble(final int p0);
    
    public static void alGetInteger(final int pname, final IntBuffer data) {
        BufferChecks.checkBuffer(data, 1);
        nalGetIntegerv(pname, data, data.position());
    }
    
    private static native void nalGetIntegerv(final int p0, final IntBuffer p1, final int p2);
    
    public static void alGetFloat(final int pname, final FloatBuffer data) {
        BufferChecks.checkBuffer(data, 1);
        nalGetFloatv(pname, data, data.position());
    }
    
    private static native void nalGetFloatv(final int p0, final FloatBuffer p1, final int p2);
    
    public static void alGetDouble(final int pname, final DoubleBuffer data) {
        BufferChecks.checkBuffer(data, 1);
        nalGetDoublev(pname, data, data.position());
    }
    
    private static native void nalGetDoublev(final int p0, final DoubleBuffer p1, final int p2);
    
    public static native String alGetString(final int p0);
    
    public static native int alGetError();
    
    public static boolean alIsExtensionPresent(final String fname) {
        BufferChecks.checkNotNull(fname);
        final boolean __result = nalIsExtensionPresent(fname);
        return __result;
    }
    
    private static native boolean nalIsExtensionPresent(final String p0);
    
    public static int alGetEnumValue(final String ename) {
        BufferChecks.checkNotNull(ename);
        final int __result = nalGetEnumValue(ename);
        return __result;
    }
    
    private static native int nalGetEnumValue(final String p0);
    
    public static native void alListeneri(final int p0, final int p1);
    
    public static native void alListenerf(final int p0, final float p1);
    
    public static void alListener(final int pname, final FloatBuffer value) {
        BufferChecks.checkBuffer(value, 1);
        nalListenerfv(pname, value, value.position());
    }
    
    private static native void nalListenerfv(final int p0, final FloatBuffer p1, final int p2);
    
    public static native void alListener3f(final int p0, final float p1, final float p2, final float p3);
    
    public static native int alGetListeneri(final int p0);
    
    public static native float alGetListenerf(final int p0);
    
    public static void alGetListener(final int pname, final FloatBuffer floatdata) {
        BufferChecks.checkBuffer(floatdata, 1);
        nalGetListenerfv(pname, floatdata, floatdata.position());
    }
    
    private static native void nalGetListenerfv(final int p0, final FloatBuffer p1, final int p2);
    
    public static void alGenSources(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalGenSources(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalGenSources(final int p0, final IntBuffer p1, final int p2);
    
    public static int alGenSources() {
        final int __result = nalGenSources2(1);
        return __result;
    }
    
    private static native int nalGenSources2(final int p0);
    
    public static void alDeleteSources(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalDeleteSources(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalDeleteSources(final int p0, final IntBuffer p1, final int p2);
    
    public static void alDeleteSources(final int source) {
        nalDeleteSources2(1, source);
    }
    
    private static native void nalDeleteSources2(final int p0, final int p1);
    
    public static native boolean alIsSource(final int p0);
    
    public static native void alSourcei(final int p0, final int p1, final int p2);
    
    public static native void alSourcef(final int p0, final int p1, final float p2);
    
    public static void alSource(final int source, final int pname, final FloatBuffer value) {
        BufferChecks.checkBuffer(value, 1);
        nalSourcefv(source, pname, value, value.position());
    }
    
    private static native void nalSourcefv(final int p0, final int p1, final FloatBuffer p2, final int p3);
    
    public static native void alSource3f(final int p0, final int p1, final float p2, final float p3, final float p4);
    
    public static native int alGetSourcei(final int p0, final int p1);
    
    public static native float alGetSourcef(final int p0, final int p1);
    
    public static void alGetSource(final int source, final int pname, final FloatBuffer floatdata) {
        BufferChecks.checkBuffer(floatdata, 1);
        nalGetSourcefv(source, pname, floatdata, floatdata.position());
    }
    
    private static native void nalGetSourcefv(final int p0, final int p1, final FloatBuffer p2, final int p3);
    
    public static void alSourcePlay(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalSourcePlayv(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalSourcePlayv(final int p0, final IntBuffer p1, final int p2);
    
    public static void alSourcePause(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalSourcePausev(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalSourcePausev(final int p0, final IntBuffer p1, final int p2);
    
    public static void alSourceStop(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalSourceStopv(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalSourceStopv(final int p0, final IntBuffer p1, final int p2);
    
    public static void alSourceRewind(final IntBuffer sources) {
        BufferChecks.checkDirect(sources);
        nalSourceRewindv(sources.remaining(), sources, sources.position());
    }
    
    private static native void nalSourceRewindv(final int p0, final IntBuffer p1, final int p2);
    
    public static native void alSourcePlay(final int p0);
    
    public static native void alSourcePause(final int p0);
    
    public static native void alSourceStop(final int p0);
    
    public static native void alSourceRewind(final int p0);
    
    public static void alGenBuffers(final IntBuffer buffers) {
        BufferChecks.checkDirect(buffers);
        nalGenBuffers(buffers.remaining(), buffers, buffers.position());
    }
    
    private static native void nalGenBuffers(final int p0, final IntBuffer p1, final int p2);
    
    public static int alGenBuffers() {
        final int __result = nalGenBuffers2(1);
        return __result;
    }
    
    private static native int nalGenBuffers2(final int p0);
    
    public static void alDeleteBuffers(final IntBuffer buffers) {
        BufferChecks.checkDirect(buffers);
        nalDeleteBuffers(buffers.remaining(), buffers, buffers.position());
    }
    
    private static native void nalDeleteBuffers(final int p0, final IntBuffer p1, final int p2);
    
    public static void alDeleteBuffers(final int buffer) {
        nalDeleteBuffers2(1, buffer);
    }
    
    private static native void nalDeleteBuffers2(final int p0, final int p1);
    
    public static native boolean alIsBuffer(final int p0);
    
    public static void alBufferData(final int buffer, final int format, final ByteBuffer data, final int freq) {
        BufferChecks.checkDirect(data);
        nalBufferData(buffer, format, data, data.position(), data.remaining(), freq);
    }
    
    public static void alBufferData(final int buffer, final int format, final IntBuffer data, final int freq) {
        BufferChecks.checkDirect(data);
        nalBufferData(buffer, format, data, data.position() << 2, data.remaining() << 2, freq);
    }
    
    public static void alBufferData(final int buffer, final int format, final ShortBuffer data, final int freq) {
        BufferChecks.checkDirect(data);
        nalBufferData(buffer, format, data, data.position() << 1, data.remaining() << 1, freq);
    }
    
    private static native void nalBufferData(final int p0, final int p1, final Buffer p2, final int p3, final int p4, final int p5);
    
    public static native int alGetBufferi(final int p0, final int p1);
    
    public static native float alGetBufferf(final int p0, final int p1);
    
    public static void alSourceQueueBuffers(final int source, final IntBuffer buffers) {
        BufferChecks.checkDirect(buffers);
        nalSourceQueueBuffers(source, buffers.remaining(), buffers, buffers.position());
    }
    
    private static native void nalSourceQueueBuffers(final int p0, final int p1, final IntBuffer p2, final int p3);
    
    public static void alSourceQueueBuffers(final int source, final int buffer) {
        nalSourceQueueBuffers2(source, 1, buffer);
    }
    
    private static native void nalSourceQueueBuffers2(final int p0, final int p1, final int p2);
    
    public static void alSourceUnqueueBuffers(final int source, final IntBuffer buffers) {
        BufferChecks.checkDirect(buffers);
        nalSourceUnqueueBuffers(source, buffers.remaining(), buffers, buffers.position());
    }
    
    private static native void nalSourceUnqueueBuffers(final int p0, final int p1, final IntBuffer p2, final int p3);
    
    public static int alSourceUnqueueBuffers(final int source) {
        final int __result = nalSourceUnqueueBuffers2(source, 1);
        return __result;
    }
    
    private static native int nalSourceUnqueueBuffers2(final int p0, final int p1);
    
    public static native void alDistanceModel(final int p0);
    
    public static native void alDopplerFactor(final float p0);
    
    public static native void alDopplerVelocity(final float p0);
}
