package org.lwjgl.openal;

import org.lwjgl.*;
import java.nio.*;

public final class AL11
{
    public static final int AL_SEC_OFFSET = 4132;
    public static final int AL_SAMPLE_OFFSET = 4133;
    public static final int AL_BYTE_OFFSET = 4134;
    public static final int AL_STATIC = 4136;
    public static final int AL_STREAMING = 4137;
    public static final int AL_UNDETERMINED = 4144;
    public static final int AL_ILLEGAL_COMMAND = 40964;
    public static final int AL_SPEED_OF_SOUND = 49155;
    public static final int AL_LINEAR_DISTANCE = 53251;
    public static final int AL_LINEAR_DISTANCE_CLAMPED = 53252;
    public static final int AL_EXPONENT_DISTANCE = 53253;
    public static final int AL_EXPONENT_DISTANCE_CLAMPED = 53254;
    
    static native void initNativeStubs() throws LWJGLException;
    
    public static native void alListener3i(final int p0, final int p1, final int p2, final int p3);
    
    public static void alGetListeneri(final int pname, final FloatBuffer intdata) {
        BufferChecks.checkBuffer(intdata, 1);
        nalGetListeneriv(pname, intdata, intdata.position());
    }
    
    private static native void nalGetListeneriv(final int p0, final FloatBuffer p1, final int p2);
    
    public static native void alSource3i(final int p0, final int p1, final int p2, final int p3, final int p4);
    
    public static void alSource(final int source, final int pname, final IntBuffer value) {
        BufferChecks.checkBuffer(value, 1);
        nalSourceiv(source, pname, value, value.position());
    }
    
    private static native void nalSourceiv(final int p0, final int p1, final IntBuffer p2, final int p3);
    
    public static native void alBufferf(final int p0, final int p1, final float p2);
    
    public static native void alBuffer3f(final int p0, final int p1, final float p2, final float p3, final float p4);
    
    public static void alBuffer(final int buffer, final int pname, final FloatBuffer value) {
        BufferChecks.checkBuffer(value, 1);
        nalBufferfv(buffer, pname, value, value.position());
    }
    
    private static native void nalBufferfv(final int p0, final int p1, final FloatBuffer p2, final int p3);
    
    public static native void alBufferi(final int p0, final int p1, final int p2);
    
    public static native void alBuffer3i(final int p0, final int p1, final int p2, final int p3, final int p4);
    
    public static void alBuffer(final int buffer, final int pname, final IntBuffer value) {
        BufferChecks.checkBuffer(value, 1);
        nalBufferiv(buffer, pname, value, value.position());
    }
    
    private static native void nalBufferiv(final int p0, final int p1, final IntBuffer p2, final int p3);
    
    public static native int alGetBufferi(final int p0, final int p1);
    
    public static void alGetBuffer(final int buffer, final int pname, final IntBuffer values) {
        BufferChecks.checkBuffer(values, 1);
        nalGetBufferiv(buffer, pname, values, values.position());
    }
    
    private static native void nalGetBufferiv(final int p0, final int p1, final IntBuffer p2, final int p3);
    
    public static native float alGetBufferf(final int p0, final int p1);
    
    public static void alGetBuffer(final int buffer, final int pname, final FloatBuffer values) {
        BufferChecks.checkBuffer(values, 1);
        nalGetBufferfv(buffer, pname, values, values.position());
    }
    
    private static native void nalGetBufferfv(final int p0, final int p1, final FloatBuffer p2, final int p3);
    
    public static native void alSpeedOfSound(final float p0);
}
