package org.lwjgl.openal;

import java.util.*;

public final class ALCdevice
{
    final long device;
    private boolean valid;
    private HashMap contexts;
    
    ALCdevice(final long device) {
        this.valid = false;
        this.contexts = new HashMap();
        this.device = device;
        this.valid = true;
    }
    
    public boolean equals(final Object device) {
        if (device instanceof ALCdevice) {
            return ((ALCdevice)device).device == this.device;
        }
        return super.equals(device);
    }
    
    void addContext(final ALCcontext context) {
        synchronized (this.contexts) {
            this.contexts.put(new Long(context.context), context);
        }
    }
    
    void removeContext(final ALCcontext context) {
        synchronized (this.contexts) {
            this.contexts.remove(new Long(context.context));
        }
    }
    
    void setInvalid() {
        this.valid = false;
        synchronized (this.contexts) {
            for (final ALCcontext context : this.contexts.values()) {
                context.setInvalid();
            }
        }
        this.contexts.clear();
    }
    
    public boolean isValid() {
        return this.valid;
    }
}
