package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class APPLEFence
{
    public static final int GL_DRAW_PIXELS_APPLE = 35338;
    public static final int GL_FENCE_APPLE = 35339;
    
    public static void glGenFencesAPPLE(final IntBuffer fences) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glGenFencesAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(fences);
        nglGenFencesAPPLE(fences.remaining(), fences, fences.position(), function_pointer);
    }
    
    private static native void nglGenFencesAPPLE(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenFencesAPPLE() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glGenFencesAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer fences = APIUtils.getBufferInt();
        nglGenFencesAPPLE(1, fences, fences.position(), function_pointer);
        return fences.get(0);
    }
    
    public static void glDeleteFencesAPPLE(final IntBuffer fences) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glDeleteFencesAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(fences);
        nglDeleteFencesAPPLE(fences.remaining(), fences, fences.position(), function_pointer);
    }
    
    private static native void nglDeleteFencesAPPLE(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteFencesAPPLE(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glDeleteFencesAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteFencesAPPLE(1, APIUtils.getBufferInt().put(0, fence), 0, function_pointer);
    }
    
    public static void glSetFenceAPPLE(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glSetFenceAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglSetFenceAPPLE(fence, function_pointer);
    }
    
    private static native void nglSetFenceAPPLE(final int p0, final long p1);
    
    public static boolean glIsFenceAPPLE(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glIsFenceAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsFenceAPPLE(fence, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsFenceAPPLE(final int p0, final long p1);
    
    public static boolean glTestFenceAPPLE(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glTestFenceAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglTestFenceAPPLE(fence, function_pointer);
        return __result;
    }
    
    private static native boolean nglTestFenceAPPLE(final int p0, final long p1);
    
    public static void glFinishFenceAPPLE(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glFinishFenceAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFinishFenceAPPLE(fence, function_pointer);
    }
    
    private static native void nglFinishFenceAPPLE(final int p0, final long p1);
    
    public static boolean glTestObjectAPPLE(final int object, final int name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glTestObjectAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglTestObjectAPPLE(object, name, function_pointer);
        return __result;
    }
    
    private static native boolean nglTestObjectAPPLE(final int p0, final int p1, final long p2);
    
    public static void glFinishObjectAPPLE(final int object, final int name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.APPLE_fence_glFinishObjectAPPLE_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFinishObjectAPPLE(object, name, function_pointer);
    }
    
    private static native void nglFinishObjectAPPLE(final int p0, final int p1, final long p2);
}
