package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ARBBlendFuncExtended
{
    public static final int GL_SRC1_COLOR = 35065;
    public static final int GL_SRC1_ALPHA = 34185;
    public static final int GL_ONE_MINUS_SRC1_COLOR = 35066;
    public static final int GL_ONE_MINUS_SRC1_ALPHA = 35067;
    public static final int GL_MAX_DUAL_SOURCE_DRAW_BUFFERS = 35068;
    
    public static void glBindFragDataLocationIndexed(final int program, final int colorNumber, final int index, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_blend_func_extended_glBindFragDataLocationIndexed_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        nglBindFragDataLocationIndexed(program, colorNumber, index, name, name.position(), function_pointer);
    }
    
    private static native void nglBindFragDataLocationIndexed(final int p0, final int p1, final int p2, final ByteBuffer p3, final int p4, final long p5);
    
    public static void glBindFragDataLocationIndexed(final int program, final int colorNumber, final int index, final CharSequence name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_blend_func_extended_glBindFragDataLocationIndexed_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindFragDataLocationIndexed(program, colorNumber, index, APIUtils.getBufferNT(name), 0, function_pointer);
    }
    
    public static int glGetFragDataIndex(final int program, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_blend_func_extended_glGetFragDataIndex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        final int __result = nglGetFragDataIndex(program, name, name.position(), function_pointer);
        return __result;
    }
    
    private static native int nglGetFragDataIndex(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static int glGetFragDataIndex(final int program, final CharSequence name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_blend_func_extended_glGetFragDataIndex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglGetFragDataIndex(program, APIUtils.getBufferNT(name), 0, function_pointer);
        return __result;
    }
}
