package org.lwjgl.opengl;

import org.lwjgl.*;

public final class ARBDrawBuffersBlend
{
    public static void glBlendEquationiARB(final int buf, final int mode) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_buffers_blend_glBlendEquationiARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendEquationiARB(buf, mode, function_pointer);
    }
    
    private static native void nglBlendEquationiARB(final int p0, final int p1, final long p2);
    
    public static void glBlendEquationSeparateiARB(final int buf, final int modeRGB, final int modeAlpha) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_buffers_blend_glBlendEquationSeparateiARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendEquationSeparateiARB(buf, modeRGB, modeAlpha, function_pointer);
    }
    
    private static native void nglBlendEquationSeparateiARB(final int p0, final int p1, final int p2, final long p3);
    
    public static void glBlendFunciARB(final int buf, final int src, final int dst) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_buffers_blend_glBlendFunciARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendFunciARB(buf, src, dst, function_pointer);
    }
    
    private static native void nglBlendFunciARB(final int p0, final int p1, final int p2, final long p3);
    
    public static void glBlendFuncSeparateiARB(final int buf, final int srcRGB, final int dstRGB, final int srcAlpha, final int dstAlpha) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_buffers_blend_glBlendFuncSeparateiARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendFuncSeparateiARB(buf, srcRGB, dstRGB, srcAlpha, dstAlpha, function_pointer);
    }
    
    private static native void nglBlendFuncSeparateiARB(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
}
