package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBDrawElementsBaseVertex
{
    public static void glDrawElementsBaseVertex(final int mode, final ByteBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsBaseVertex(mode, indices.remaining(), 5121, indices, indices.position(), basevertex, function_pointer);
    }
    
    public static void glDrawElementsBaseVertex(final int mode, final IntBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsBaseVertex(mode, indices.remaining(), 5125, indices, indices.position() << 2, basevertex, function_pointer);
    }
    
    public static void glDrawElementsBaseVertex(final int mode, final ShortBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsBaseVertex(mode, indices.remaining(), 5123, indices, indices.position() << 1, basevertex, function_pointer);
    }
    
    private static native void nglDrawElementsBaseVertex(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final int p5, final long p6);
    
    public static void glDrawElementsBaseVertex(final int mode, final int count, final int type, final long indices_buffer_offset, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOenabled(caps);
        nglDrawElementsBaseVertexBO(mode, count, type, indices_buffer_offset, basevertex, function_pointer);
    }
    
    private static native void nglDrawElementsBaseVertexBO(final int p0, final int p1, final int p2, final long p3, final int p4, final long p5);
    
    public static void glDrawRangeElementsBaseVertex(final int mode, final int start, final int end, final ByteBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawRangeElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawRangeElementsBaseVertex(mode, start, end, indices.remaining(), 5121, indices, indices.position(), basevertex, function_pointer);
    }
    
    public static void glDrawRangeElementsBaseVertex(final int mode, final int start, final int end, final IntBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawRangeElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawRangeElementsBaseVertex(mode, start, end, indices.remaining(), 5125, indices, indices.position() << 2, basevertex, function_pointer);
    }
    
    public static void glDrawRangeElementsBaseVertex(final int mode, final int start, final int end, final ShortBuffer indices, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawRangeElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawRangeElementsBaseVertex(mode, start, end, indices.remaining(), 5123, indices, indices.position() << 1, basevertex, function_pointer);
    }
    
    private static native void nglDrawRangeElementsBaseVertex(final int p0, final int p1, final int p2, final int p3, final int p4, final Buffer p5, final int p6, final int p7, final long p8);
    
    public static void glDrawRangeElementsBaseVertex(final int mode, final int start, final int end, final int count, final int type, final long indices_buffer_offset, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawRangeElementsBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOenabled(caps);
        nglDrawRangeElementsBaseVertexBO(mode, start, end, count, type, indices_buffer_offset, basevertex, function_pointer);
    }
    
    private static native void nglDrawRangeElementsBaseVertexBO(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5, final int p6, final long p7);
    
    public static void glDrawElementsInstancedBaseVertex(final int mode, final ByteBuffer indices, final int primcount, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsInstancedBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedBaseVertex(mode, indices.remaining(), 5121, indices, indices.position(), primcount, basevertex, function_pointer);
    }
    
    public static void glDrawElementsInstancedBaseVertex(final int mode, final IntBuffer indices, final int primcount, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsInstancedBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedBaseVertex(mode, indices.remaining(), 5125, indices, indices.position() << 2, primcount, basevertex, function_pointer);
    }
    
    public static void glDrawElementsInstancedBaseVertex(final int mode, final ShortBuffer indices, final int primcount, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsInstancedBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedBaseVertex(mode, indices.remaining(), 5123, indices, indices.position() << 1, primcount, basevertex, function_pointer);
    }
    
    private static native void nglDrawElementsInstancedBaseVertex(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final int p5, final int p6, final long p7);
    
    public static void glDrawElementsInstancedBaseVertex(final int mode, final int count, final int type, final long indices_buffer_offset, final int primcount, final int basevertex) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_elements_base_vertex_glDrawElementsInstancedBaseVertex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOenabled(caps);
        nglDrawElementsInstancedBaseVertexBO(mode, count, type, indices_buffer_offset, primcount, basevertex, function_pointer);
    }
    
    private static native void nglDrawElementsInstancedBaseVertexBO(final int p0, final int p1, final int p2, final long p3, final int p4, final int p5, final long p6);
}
