package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ARBDrawIndirect
{
    public static final int GL_DRAW_INDIRECT_BUFFER = 36671;
    public static final int GL_DRAW_INDIRECT_BUFFER_BINDING = 36675;
    
    public static void glDrawArraysIndirect(final int mode, final IntBuffer indirect) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_indirect_glDrawArraysIndirect_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureIndirectBOdisabled(caps);
        BufferChecks.checkBuffer(indirect, 4);
        BufferChecks.checkNullTerminated(indirect);
        nglDrawArraysIndirect(mode, indirect, indirect.position(), function_pointer);
    }
    
    private static native void nglDrawArraysIndirect(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDrawArraysIndirect(final int mode, final long indirect_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_indirect_glDrawArraysIndirect_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureIndirectBOenabled(caps);
        nglDrawArraysIndirectBO(mode, indirect_buffer_offset, function_pointer);
    }
    
    private static native void nglDrawArraysIndirectBO(final int p0, final long p1, final long p2);
    
    public static void glDrawElementsIndirect(final int mode, final int type, final IntBuffer indirect) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_indirect_glDrawElementsIndirect_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureIndirectBOdisabled(caps);
        BufferChecks.checkBuffer(indirect, 5);
        BufferChecks.checkNullTerminated(indirect);
        nglDrawElementsIndirect(mode, type, indirect, indirect.position(), function_pointer);
    }
    
    private static native void nglDrawElementsIndirect(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glDrawElementsIndirect(final int mode, final int type, final long indirect_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_draw_indirect_glDrawElementsIndirect_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureIndirectBOenabled(caps);
        nglDrawElementsIndirectBO(mode, type, indirect_buffer_offset, function_pointer);
    }
    
    private static native void nglDrawElementsIndirectBO(final int p0, final int p1, final long p2, final long p3);
}
