package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBFramebufferObject
{
    public static final int GL_FRAMEBUFFER = 36160;
    public static final int GL_READ_FRAMEBUFFER = 36008;
    public static final int GL_DRAW_FRAMEBUFFER = 36009;
    public static final int GL_RENDERBUFFER = 36161;
    public static final int GL_STENCIL_INDEX1 = 36166;
    public static final int GL_STENCIL_INDEX4 = 36167;
    public static final int GL_STENCIL_INDEX8 = 36168;
    public static final int GL_STENCIL_INDEX16 = 36169;
    public static final int GL_RENDERBUFFER_WIDTH = 36162;
    public static final int GL_RENDERBUFFER_HEIGHT = 36163;
    public static final int GL_RENDERBUFFER_INTERNAL_FORMAT = 36164;
    public static final int GL_RENDERBUFFER_RED_SIZE = 36176;
    public static final int GL_RENDERBUFFER_GREEN_SIZE = 36177;
    public static final int GL_RENDERBUFFER_BLUE_SIZE = 36178;
    public static final int GL_RENDERBUFFER_ALPHA_SIZE = 36179;
    public static final int GL_RENDERBUFFER_DEPTH_SIZE = 36180;
    public static final int GL_RENDERBUFFER_STENCIL_SIZE = 36181;
    public static final int GL_RENDERBUFFER_SAMPLES = 36011;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE = 36048;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME = 36049;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL = 36050;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE = 36051;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER = 36052;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING = 33296;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE = 33297;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE = 33298;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE = 33299;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE = 33300;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE = 33301;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE = 33302;
    public static final int GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE = 33303;
    public static final int GL_SRGB = 35904;
    public static final int GL_UNSIGNED_NORMALIZED = 35863;
    public static final int GL_FRAMEBUFFER_DEFAULT = 33304;
    public static final int GL_INDEX = 33314;
    public static final int GL_COLOR_ATTACHMENT0 = 36064;
    public static final int GL_COLOR_ATTACHMENT1 = 36065;
    public static final int GL_COLOR_ATTACHMENT2 = 36066;
    public static final int GL_COLOR_ATTACHMENT3 = 36067;
    public static final int GL_COLOR_ATTACHMENT4 = 36068;
    public static final int GL_COLOR_ATTACHMENT5 = 36069;
    public static final int GL_COLOR_ATTACHMENT6 = 36070;
    public static final int GL_COLOR_ATTACHMENT7 = 36071;
    public static final int GL_COLOR_ATTACHMENT8 = 36072;
    public static final int GL_COLOR_ATTACHMENT9 = 36073;
    public static final int GL_COLOR_ATTACHMENT10 = 36074;
    public static final int GL_COLOR_ATTACHMENT11 = 36075;
    public static final int GL_COLOR_ATTACHMENT12 = 36076;
    public static final int GL_COLOR_ATTACHMENT13 = 36077;
    public static final int GL_COLOR_ATTACHMENT14 = 36078;
    public static final int GL_COLOR_ATTACHMENT15 = 36079;
    public static final int GL_DEPTH_ATTACHMENT = 36096;
    public static final int GL_STENCIL_ATTACHMENT = 36128;
    public static final int GL_DEPTH_STENCIL_ATTACHMENT = 33306;
    public static final int GL_MAX_SAMPLES = 36183;
    public static final int GL_FRAMEBUFFER_COMPLETE = 36053;
    public static final int GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT = 36054;
    public static final int GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT = 36055;
    public static final int GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER = 36059;
    public static final int GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER = 36060;
    public static final int GL_FRAMEBUFFER_UNSUPPORTED = 36061;
    public static final int GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE = 36182;
    public static final int GL_FRAMEBUFFER_UNDEFINED = 33305;
    public static final int GL_FRAMEBUFFER_BINDING = 36006;
    public static final int GL_DRAW_FRAMEBUFFER_BINDING = 36006;
    public static final int GL_READ_FRAMEBUFFER_BINDING = 36010;
    public static final int GL_RENDERBUFFER_BINDING = 36007;
    public static final int GL_MAX_COLOR_ATTACHMENTS = 36063;
    public static final int GL_MAX_RENDERBUFFER_SIZE = 34024;
    public static final int GL_INVALID_FRAMEBUFFER_OPERATION = 1286;
    public static final int GL_DEPTH_STENCIL = 34041;
    public static final int GL_UNSIGNED_INT_24_8 = 34042;
    public static final int GL_DEPTH24_STENCIL8 = 35056;
    public static final int GL_TEXTURE_STENCIL_SIZE = 35057;
    
    public static boolean glIsRenderbuffer(final int renderbuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glIsRenderbuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsRenderbuffer(renderbuffer, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsRenderbuffer(final int p0, final long p1);
    
    public static void glBindRenderbuffer(final int target, final int renderbuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glBindRenderbuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindRenderbuffer(target, renderbuffer, function_pointer);
    }
    
    private static native void nglBindRenderbuffer(final int p0, final int p1, final long p2);
    
    public static void glDeleteRenderbuffers(final IntBuffer renderbuffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glDeleteRenderbuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(renderbuffers);
        nglDeleteRenderbuffers(renderbuffers.remaining(), renderbuffers, renderbuffers.position(), function_pointer);
    }
    
    private static native void nglDeleteRenderbuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteRenderbuffers(final int renderbuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glDeleteRenderbuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteRenderbuffers(1, APIUtils.getBufferInt().put(0, renderbuffer), 0, function_pointer);
    }
    
    public static void glGenRenderbuffers(final IntBuffer renderbuffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGenRenderbuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(renderbuffers);
        nglGenRenderbuffers(renderbuffers.remaining(), renderbuffers, renderbuffers.position(), function_pointer);
    }
    
    private static native void nglGenRenderbuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenRenderbuffers() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGenRenderbuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer renderbuffers = APIUtils.getBufferInt();
        nglGenRenderbuffers(1, renderbuffers, renderbuffers.position(), function_pointer);
        return renderbuffers.get(0);
    }
    
    public static void glRenderbufferStorage(final int target, final int internalformat, final int width, final int height) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glRenderbufferStorage_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglRenderbufferStorage(target, internalformat, width, height, function_pointer);
    }
    
    private static native void nglRenderbufferStorage(final int p0, final int p1, final int p2, final int p3, final long p4);
    
    public static void glRenderbufferStorageMultisample(final int target, final int samples, final int internalformat, final int width, final int height) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glRenderbufferStorageMultisample_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglRenderbufferStorageMultisample(target, samples, internalformat, width, height, function_pointer);
    }
    
    private static native void nglRenderbufferStorageMultisample(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glGetRenderbufferParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGetRenderbufferParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetRenderbufferParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetRenderbufferParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetRenderbufferParameter(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGetRenderbufferParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetRenderbufferParameteriv(target, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static boolean glIsFramebuffer(final int framebuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glIsFramebuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsFramebuffer(framebuffer, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsFramebuffer(final int p0, final long p1);
    
    public static void glBindFramebuffer(final int target, final int framebuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glBindFramebuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindFramebuffer(target, framebuffer, function_pointer);
    }
    
    private static native void nglBindFramebuffer(final int p0, final int p1, final long p2);
    
    public static void glDeleteFramebuffers(final IntBuffer framebuffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glDeleteFramebuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(framebuffers);
        nglDeleteFramebuffers(framebuffers.remaining(), framebuffers, framebuffers.position(), function_pointer);
    }
    
    private static native void nglDeleteFramebuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteFramebuffers(final int framebuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glDeleteFramebuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteFramebuffers(1, APIUtils.getBufferInt().put(0, framebuffer), 0, function_pointer);
    }
    
    public static void glGenFramebuffers(final IntBuffer framebuffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGenFramebuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(framebuffers);
        nglGenFramebuffers(framebuffers.remaining(), framebuffers, framebuffers.position(), function_pointer);
    }
    
    private static native void nglGenFramebuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenFramebuffers() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGenFramebuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer framebuffers = APIUtils.getBufferInt();
        nglGenFramebuffers(1, framebuffers, framebuffers.position(), function_pointer);
        return framebuffers.get(0);
    }
    
    public static int glCheckFramebufferStatus(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glCheckFramebufferStatus_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglCheckFramebufferStatus(target, function_pointer);
        return __result;
    }
    
    private static native int nglCheckFramebufferStatus(final int p0, final long p1);
    
    public static void glFramebufferTexture1D(final int target, final int attachment, final int textarget, final int texture, final int level) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glFramebufferTexture1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFramebufferTexture1D(target, attachment, textarget, texture, level, function_pointer);
    }
    
    private static native void nglFramebufferTexture1D(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glFramebufferTexture2D(final int target, final int attachment, final int textarget, final int texture, final int level) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glFramebufferTexture2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFramebufferTexture2D(target, attachment, textarget, texture, level, function_pointer);
    }
    
    private static native void nglFramebufferTexture2D(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glFramebufferTexture3D(final int target, final int attachment, final int textarget, final int texture, final int level, final int layer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glFramebufferTexture3D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFramebufferTexture3D(target, attachment, textarget, texture, level, layer, function_pointer);
    }
    
    private static native void nglFramebufferTexture3D(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final long p6);
    
    public static void glFramebufferTextureLayer(final int target, final int attachment, final int texture, final int level, final int layer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glFramebufferTextureLayer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFramebufferTextureLayer(target, attachment, texture, level, layer, function_pointer);
    }
    
    private static native void nglFramebufferTextureLayer(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glFramebufferRenderbuffer(final int target, final int attachment, final int renderbuffertarget, final int renderbuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glFramebufferRenderbuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFramebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer, function_pointer);
    }
    
    private static native void nglFramebufferRenderbuffer(final int p0, final int p1, final int p2, final int p3, final long p4);
    
    public static void glGetFramebufferAttachmentParameter(final int target, final int attachment, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGetFramebufferAttachmentParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetFramebufferAttachmentParameteriv(target, attachment, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetFramebufferAttachmentParameteriv(final int p0, final int p1, final int p2, final IntBuffer p3, final int p4, final long p5);
    
    public static int glGetFramebufferAttachmentParameter(final int target, final int attachment, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGetFramebufferAttachmentParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetFramebufferAttachmentParameteriv(target, attachment, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glBlitFramebuffer(final int srcX0, final int srcY0, final int srcX1, final int srcY1, final int dstX0, final int dstY0, final int dstX1, final int dstY1, final int mask, final int filter) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glBlitFramebuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter, function_pointer);
    }
    
    private static native void nglBlitFramebuffer(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final int p6, final int p7, final int p8, final int p9, final long p10);
    
    public static void glGenerateMipmap(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_framebuffer_object_glGenerateMipmap_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglGenerateMipmap(target, function_pointer);
    }
    
    private static native void nglGenerateMipmap(final int p0, final long p1);
}
