package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBGpuShaderFp64
{
    public static final int GL_DOUBLE = 5130;
    public static final int GL_DOUBLE_VEC2 = 36860;
    public static final int GL_DOUBLE_VEC3 = 36861;
    public static final int GL_DOUBLE_VEC4 = 36862;
    public static final int GL_DOUBLE_MAT2 = 36678;
    public static final int GL_DOUBLE_MAT3 = 36679;
    public static final int GL_DOUBLE_MAT4 = 36680;
    public static final int GL_DOUBLE_MAT2x3 = 36681;
    public static final int GL_DOUBLE_MAT2x4 = 36682;
    public static final int GL_DOUBLE_MAT3x2 = 36683;
    public static final int GL_DOUBLE_MAT3x4 = 36684;
    public static final int GL_DOUBLE_MAT4x2 = 36685;
    public static final int GL_DOUBLE_MAT4x3 = 36686;
    
    public static void glUniform1d(final int location, final double x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform1d_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform1d(location, x, function_pointer);
    }
    
    private static native void nglUniform1d(final int p0, final double p1, final long p2);
    
    public static void glUniform2d(final int location, final double x, final double y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform2d_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform2d(location, x, y, function_pointer);
    }
    
    private static native void nglUniform2d(final int p0, final double p1, final double p2, final long p3);
    
    public static void glUniform3d(final int location, final double x, final double y, final double z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform3d_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform3d(location, x, y, z, function_pointer);
    }
    
    private static native void nglUniform3d(final int p0, final double p1, final double p2, final double p3, final long p4);
    
    public static void glUniform4d(final int location, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform4d_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform4d(location, x, y, z, w, function_pointer);
    }
    
    private static native void nglUniform4d(final int p0, final double p1, final double p2, final double p3, final double p4, final long p5);
    
    public static void glUniform1(final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform1dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniform1dv(location, value.remaining(), value, value.position(), function_pointer);
    }
    
    private static native void nglUniform1dv(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glUniform2(final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform2dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniform2dv(location, value.remaining() >> 1, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform2dv(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glUniform3(final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform3dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniform3dv(location, value.remaining() / 3, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform3dv(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glUniform4(final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniform4dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniform4dv(location, value.remaining() >> 2, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform4dv(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glUniformMatrix2(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix2dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix2dv(location, value.remaining() >> 2, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix2dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix3(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix3dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix3dv(location, value.remaining() / 9, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix3dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix4(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix4dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix4dv(location, value.remaining() >> 4, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix4dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix2x3(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix2x3dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix2x3dv(location, value.remaining() / 6, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix2x3dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix2x4(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix2x4dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix2x4dv(location, value.remaining() >> 3, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix2x4dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix3x2(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix3x2dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix3x2dv(location, value.remaining() / 6, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix3x2dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix3x4(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix3x4dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix3x4dv(location, value.remaining() / 12, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix3x4dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix4x2(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix4x2dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix4x2dv(location, value.remaining() >> 3, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix4x2dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix4x3(final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glUniformMatrix4x3dv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformMatrix4x3dv(location, value.remaining() / 12, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix4x3dv(final int p0, final int p1, final boolean p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glGetUniform(final int program, final int location, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glGetUniformdv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetUniformdv(program, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformdv(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glProgramUniform1dEXT(final int program, final int location, final double x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform1dEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform1dEXT(program, location, x, function_pointer);
    }
    
    private static native void nglProgramUniform1dEXT(final int p0, final int p1, final double p2, final long p3);
    
    public static void glProgramUniform2dEXT(final int program, final int location, final double x, final double y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform2dEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform2dEXT(program, location, x, y, function_pointer);
    }
    
    private static native void nglProgramUniform2dEXT(final int p0, final int p1, final double p2, final double p3, final long p4);
    
    public static void glProgramUniform3dEXT(final int program, final int location, final double x, final double y, final double z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform3dEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform3dEXT(program, location, x, y, z, function_pointer);
    }
    
    private static native void nglProgramUniform3dEXT(final int p0, final int p1, final double p2, final double p3, final double p4, final long p5);
    
    public static void glProgramUniform4dEXT(final int program, final int location, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform4dEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform4dEXT(program, location, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramUniform4dEXT(final int p0, final int p1, final double p2, final double p3, final double p4, final double p5, final long p6);
    
    public static void glProgramUniform1EXT(final int program, final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform1dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniform1dvEXT(program, location, value.remaining(), value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform1dvEXT(final int p0, final int p1, final int p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform2EXT(final int program, final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform2dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniform2dvEXT(program, location, value.remaining() >> 1, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform2dvEXT(final int p0, final int p1, final int p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform3EXT(final int program, final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform3dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniform3dvEXT(program, location, value.remaining() / 3, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform3dvEXT(final int p0, final int p1, final int p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform4EXT(final int program, final int location, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniform4dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniform4dvEXT(program, location, value.remaining() >> 2, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform4dvEXT(final int p0, final int p1, final int p2, final DoubleBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniformMatrix2EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix2dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix2dvEXT(program, location, value.remaining() >> 2, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix2dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix3EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix3dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix3dvEXT(program, location, value.remaining() / 9, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix3dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix4EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix4dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix4dvEXT(program, location, value.remaining() >> 4, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix4dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix2x3EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix2x3dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix2x3dvEXT(program, location, value.remaining() / 6, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix2x3dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix2x4EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix2x4dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix2x4dvEXT(program, location, value.remaining() >> 3, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix2x4dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix3x2EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix3x2dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix3x2dvEXT(program, location, value.remaining() / 6, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix3x2dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix3x4EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix3x4dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix3x4dvEXT(program, location, value.remaining() / 12, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix3x4dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix4x2EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix4x2dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix4x2dvEXT(program, location, value.remaining() >> 3, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix4x2dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
    
    public static void glProgramUniformMatrix4x3EXT(final int program, final int location, final boolean transpose, final DoubleBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_gpu_shader_fp64_glProgramUniformMatrix4x3dvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformMatrix4x3dvEXT(program, location, value.remaining() / 12, transpose, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformMatrix4x3dvEXT(final int p0, final int p1, final int p2, final boolean p3, final DoubleBuffer p4, final int p5, final long p6);
}
