package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBImaging
{
    public static final int GL_CONSTANT_COLOR = 32769;
    public static final int GL_ONE_MINUS_CONSTANT_COLOR = 32770;
    public static final int GL_CONSTANT_ALPHA = 32771;
    public static final int GL_ONE_MINUS_CONSTANT_ALPHA = 32772;
    public static final int GL_BLEND_COLOR = 32773;
    public static final int GL_FUNC_ADD = 32774;
    public static final int GL_MIN = 32775;
    public static final int GL_MAX = 32776;
    public static final int GL_BLEND_EQUATION = 32777;
    public static final int GL_FUNC_SUBTRACT = 32778;
    public static final int GL_FUNC_REVERSE_SUBTRACT = 32779;
    public static final int GL_COLOR_MATRIX = 32945;
    public static final int GL_COLOR_MATRIX_STACK_DEPTH = 32946;
    public static final int GL_MAX_COLOR_MATRIX_STACK_DEPTH = 32947;
    public static final int GL_POST_COLOR_MATRIX_RED_SCALE = 32948;
    public static final int GL_POST_COLOR_MATRIX_GREEN_SCALE = 32949;
    public static final int GL_POST_COLOR_MATRIX_BLUE_SCALE = 32950;
    public static final int GL_POST_COLOR_MATRIX_ALPHA_SCALE = 32951;
    public static final int GL_POST_COLOR_MATRIX_RED_BIAS = 32952;
    public static final int GL_POST_COLOR_MATRIX_GREEN_BIAS = 32953;
    public static final int GL_POST_COLOR_MATRIX_BLUE_BIAS = 32954;
    public static final int GL_POST_COLOR_MATRIX_ALPHA_BIAS = 32955;
    public static final int GL_COLOR_TABLE = 32976;
    public static final int GL_POST_CONVOLUTION_COLOR_TABLE = 32977;
    public static final int GL_POST_COLOR_MATRIX_COLOR_TABLE = 32978;
    public static final int GL_PROXY_COLOR_TABLE = 32979;
    public static final int GL_PROXY_POST_CONVOLUTION_COLOR_TABLE = 32980;
    public static final int GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = 32981;
    public static final int GL_COLOR_TABLE_SCALE = 32982;
    public static final int GL_COLOR_TABLE_BIAS = 32983;
    public static final int GL_COLOR_TABLE_FORMAT = 32984;
    public static final int GL_COLOR_TABLE_WIDTH = 32985;
    public static final int GL_COLOR_TABLE_RED_SIZE = 32986;
    public static final int GL_COLOR_TABLE_GREEN_SIZE = 32987;
    public static final int GL_COLOR_TABLE_BLUE_SIZE = 32988;
    public static final int GL_COLOR_TABLE_ALPHA_SIZE = 32989;
    public static final int GL_COLOR_TABLE_LUMINANCE_SIZE = 32990;
    public static final int GL_COLOR_TABLE_INTENSITY_SIZE = 32991;
    public static final int GL_CONVOLUTION_1D = 32784;
    public static final int GL_CONVOLUTION_2D = 32785;
    public static final int GL_SEPARABLE_2D = 32786;
    public static final int GL_CONVOLUTION_BORDER_MODE = 32787;
    public static final int GL_CONVOLUTION_FILTER_SCALE = 32788;
    public static final int GL_CONVOLUTION_FILTER_BIAS = 32789;
    public static final int GL_REDUCE = 32790;
    public static final int GL_CONVOLUTION_FORMAT = 32791;
    public static final int GL_CONVOLUTION_WIDTH = 32792;
    public static final int GL_CONVOLUTION_HEIGHT = 32793;
    public static final int GL_MAX_CONVOLUTION_WIDTH = 32794;
    public static final int GL_MAX_CONVOLUTION_HEIGHT = 32795;
    public static final int GL_POST_CONVOLUTION_RED_SCALE = 32796;
    public static final int GL_POST_CONVOLUTION_GREEN_SCALE = 32797;
    public static final int GL_POST_CONVOLUTION_BLUE_SCALE = 32798;
    public static final int GL_POST_CONVOLUTION_ALPHA_SCALE = 32799;
    public static final int GL_POST_CONVOLUTION_RED_BIAS = 32800;
    public static final int GL_POST_CONVOLUTION_GREEN_BIAS = 32801;
    public static final int GL_POST_CONVOLUTION_BLUE_BIAS = 32802;
    public static final int GL_POST_CONVOLUTION_ALPHA_BIAS = 32803;
    public static final int GL_IGNORE_BORDER = 33104;
    public static final int GL_CONSTANT_BORDER = 33105;
    public static final int GL_REPLICATE_BORDER = 33107;
    public static final int GL_CONVOLUTION_BORDER_COLOR = 33108;
    public static final int GL_HISTOGRAM = 32804;
    public static final int GL_PROXY_HISTOGRAM = 32805;
    public static final int GL_HISTOGRAM_WIDTH = 32806;
    public static final int GL_HISTOGRAM_FORMAT = 32807;
    public static final int GL_HISTOGRAM_RED_SIZE = 32808;
    public static final int GL_HISTOGRAM_GREEN_SIZE = 32809;
    public static final int GL_HISTOGRAM_BLUE_SIZE = 32810;
    public static final int GL_HISTOGRAM_ALPHA_SIZE = 32811;
    public static final int GL_HISTOGRAM_LUMINANCE_SIZE = 32812;
    public static final int GL_HISTOGRAM_SINK = 32813;
    public static final int GL_MINMAX = 32814;
    public static final int GL_MINMAX_FORMAT = 32815;
    public static final int GL_MINMAX_SINK = 32816;
    public static final int GL_TABLE_TOO_LARGE = 32817;
    
    public static void glColorTable(final int target, final int internalFormat, final int width, final int format, final int type, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorTable(target, internalFormat, width, format, type, data, data.position(), function_pointer);
    }
    
    public static void glColorTable(final int target, final int internalFormat, final int width, final int format, final int type, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorTable(target, internalFormat, width, format, type, data, data.position() << 3, function_pointer);
    }
    
    public static void glColorTable(final int target, final int internalFormat, final int width, final int format, final int type, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorTable(target, internalFormat, width, format, type, data, data.position() << 2, function_pointer);
    }
    
    private static native void nglColorTable(final int p0, final int p1, final int p2, final int p3, final int p4, final Buffer p5, final int p6, final long p7);
    
    public static void glColorTable(final int target, final int internalFormat, final int width, final int format, final int type, final long data_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOenabled(caps);
        nglColorTableBO(target, internalFormat, width, format, type, data_buffer_offset, function_pointer);
    }
    
    private static native void nglColorTableBO(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5, final long p6);
    
    public static void glColorSubTable(final int target, final int start, final int count, final int format, final int type, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorSubTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorSubTable(target, start, count, format, type, data, data.position(), function_pointer);
    }
    
    public static void glColorSubTable(final int target, final int start, final int count, final int format, final int type, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorSubTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorSubTable(target, start, count, format, type, data, data.position() << 3, function_pointer);
    }
    
    public static void glColorSubTable(final int target, final int start, final int count, final int format, final int type, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorSubTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(data, 256);
        nglColorSubTable(target, start, count, format, type, data, data.position() << 2, function_pointer);
    }
    
    private static native void nglColorSubTable(final int p0, final int p1, final int p2, final int p3, final int p4, final Buffer p5, final int p6, final long p7);
    
    public static void glColorSubTable(final int target, final int start, final int count, final int format, final int type, final long data_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorSubTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOenabled(caps);
        nglColorSubTableBO(target, start, count, format, type, data_buffer_offset, function_pointer);
    }
    
    private static native void nglColorSubTableBO(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5, final long p6);
    
    public static void glColorTableParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTableParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglColorTableParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglColorTableParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glColorTableParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glColorTableParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglColorTableParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglColorTableParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glCopyColorSubTable(final int target, final int start, final int x, final int y, final int width) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glCopyColorSubTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCopyColorSubTable(target, start, x, y, width, function_pointer);
    }
    
    private static native void nglCopyColorSubTable(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glCopyColorTable(final int target, final int internalformat, final int x, final int y, final int width) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glCopyColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCopyColorTable(target, internalformat, x, y, width, function_pointer);
    }
    
    private static native void nglCopyColorTable(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glGetColorTable(final int target, final int format, final int type, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 256);
        nglGetColorTable(target, format, type, data, data.position(), function_pointer);
    }
    
    public static void glGetColorTable(final int target, final int format, final int type, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 256);
        nglGetColorTable(target, format, type, data, data.position() << 3, function_pointer);
    }
    
    public static void glGetColorTable(final int target, final int format, final int type, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetColorTable_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 256);
        nglGetColorTable(target, format, type, data, data.position() << 2, function_pointer);
    }
    
    private static native void nglGetColorTable(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final long p5);
    
    public static void glGetColorTableParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetColorTableParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetColorTableParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetColorTableParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glGetColorTableParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetColorTableParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetColorTableParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetColorTableParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glBlendEquation(final int mode) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glBlendEquation_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendEquation(mode, function_pointer);
    }
    
    private static native void nglBlendEquation(final int p0, final long p1);
    
    public static void glBlendColor(final float red, final float green, final float blue, final float alpha) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glBlendColor_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBlendColor(red, green, blue, alpha, function_pointer);
    }
    
    private static native void nglBlendColor(final float p0, final float p1, final float p2, final float p3, final long p4);
    
    public static void glHistogram(final int target, final int width, final int internalformat, final boolean sink) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglHistogram(target, width, internalformat, sink, function_pointer);
    }
    
    private static native void nglHistogram(final int p0, final int p1, final int p2, final boolean p3, final long p4);
    
    public static void glResetHistogram(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glResetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglResetHistogram(target, function_pointer);
    }
    
    private static native void nglResetHistogram(final int p0, final long p1);
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final ByteBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 256);
        nglGetHistogram(target, reset, format, type, values, values.position(), function_pointer);
    }
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final DoubleBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 256);
        nglGetHistogram(target, reset, format, type, values, values.position() << 3, function_pointer);
    }
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 256);
        nglGetHistogram(target, reset, format, type, values, values.position() << 2, function_pointer);
    }
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 256);
        nglGetHistogram(target, reset, format, type, values, values.position() << 2, function_pointer);
    }
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final ShortBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 256);
        nglGetHistogram(target, reset, format, type, values, values.position() << 1, function_pointer);
    }
    
    private static native void nglGetHistogram(final int p0, final boolean p1, final int p2, final int p3, final Buffer p4, final int p5, final long p6);
    
    public static void glGetHistogram(final int target, final boolean reset, final int format, final int type, final long values_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogram_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOenabled(caps);
        nglGetHistogramBO(target, reset, format, type, values_buffer_offset, function_pointer);
    }
    
    private static native void nglGetHistogramBO(final int p0, final boolean p1, final int p2, final int p3, final long p4, final long p5);
    
    public static void glGetHistogramParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogramParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 256);
        nglGetHistogramParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetHistogramParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetHistogramParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetHistogramParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 256);
        nglGetHistogramParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetHistogramParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glMinmax(final int target, final int internalformat, final boolean sink) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglMinmax(target, internalformat, sink, function_pointer);
    }
    
    private static native void nglMinmax(final int p0, final int p1, final boolean p2, final long p3);
    
    public static void glResetMinmax(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glResetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglResetMinmax(target, function_pointer);
    }
    
    private static native void nglResetMinmax(final int p0, final long p1);
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final ByteBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 4);
        nglGetMinmax(target, reset, format, types, values, values.position(), function_pointer);
    }
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final DoubleBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 4);
        nglGetMinmax(target, reset, format, types, values, values.position() << 3, function_pointer);
    }
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 4);
        nglGetMinmax(target, reset, format, types, values, values.position() << 2, function_pointer);
    }
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 4);
        nglGetMinmax(target, reset, format, types, values, values.position() << 2, function_pointer);
    }
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final ShortBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkBuffer(values, 4);
        nglGetMinmax(target, reset, format, types, values, values.position() << 1, function_pointer);
    }
    
    private static native void nglGetMinmax(final int p0, final boolean p1, final int p2, final int p3, final Buffer p4, final int p5, final long p6);
    
    public static void glGetMinmax(final int target, final boolean reset, final int format, final int types, final long values_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmax_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOenabled(caps);
        nglGetMinmaxBO(target, reset, format, types, values_buffer_offset, function_pointer);
    }
    
    private static native void nglGetMinmaxBO(final int p0, final boolean p1, final int p2, final int p3, final long p4, final long p5);
    
    public static void glGetMinmaxParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmaxParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetMinmaxParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetMinmaxParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetMinmaxParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetMinmaxParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetMinmaxParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetMinmaxParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final ByteBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, 1, 1));
        nglConvolutionFilter1D(target, internalformat, width, format, type, image, image.position(), function_pointer);
    }
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final DoubleBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, 1, 1));
        nglConvolutionFilter1D(target, internalformat, width, format, type, image, image.position() << 3, function_pointer);
    }
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final FloatBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, 1, 1));
        nglConvolutionFilter1D(target, internalformat, width, format, type, image, image.position() << 2, function_pointer);
    }
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final IntBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, 1, 1));
        nglConvolutionFilter1D(target, internalformat, width, format, type, image, image.position() << 2, function_pointer);
    }
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final ShortBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, 1, 1));
        nglConvolutionFilter1D(target, internalformat, width, format, type, image, image.position() << 1, function_pointer);
    }
    
    private static native void nglConvolutionFilter1D(final int p0, final int p1, final int p2, final int p3, final int p4, final Buffer p5, final int p6, final long p7);
    
    public static void glConvolutionFilter1D(final int target, final int internalformat, final int width, final int format, final int type, final long image_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOenabled(caps);
        nglConvolutionFilter1DBO(target, internalformat, width, format, type, image_buffer_offset, function_pointer);
    }
    
    private static native void nglConvolutionFilter1DBO(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5, final long p6);
    
    public static void glConvolutionFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, height, 1));
        nglConvolutionFilter2D(target, internalformat, width, height, format, type, image, image.position(), function_pointer);
    }
    
    public static void glConvolutionFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, height, 1));
        nglConvolutionFilter2D(target, internalformat, width, height, format, type, image, image.position() << 2, function_pointer);
    }
    
    public static void glConvolutionFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkBuffer(image, GLChecks.calculateImageStorage(image, format, type, width, height, 1));
        nglConvolutionFilter2D(target, internalformat, width, height, format, type, image, image.position() << 1, function_pointer);
    }
    
    private static native void nglConvolutionFilter2D(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final Buffer p6, final int p7, final long p8);
    
    public static void glConvolutionFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final long image_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOenabled(caps);
        nglConvolutionFilter2DBO(target, internalformat, width, height, format, type, image_buffer_offset, function_pointer);
    }
    
    private static native void nglConvolutionFilter2DBO(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final long p6, final long p7);
    
    public static void glConvolutionParameterf(final int target, final int pname, final float params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionParameterf_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglConvolutionParameterf(target, pname, params, function_pointer);
    }
    
    private static native void nglConvolutionParameterf(final int p0, final int p1, final float p2, final long p3);
    
    public static void glConvolutionParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglConvolutionParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglConvolutionParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glConvolutionParameteri(final int target, final int pname, final int params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionParameteri_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglConvolutionParameteri(target, pname, params, function_pointer);
    }
    
    private static native void nglConvolutionParameteri(final int p0, final int p1, final int p2, final long p3);
    
    public static void glConvolutionParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glConvolutionParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglConvolutionParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglConvolutionParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glCopyConvolutionFilter1D(final int target, final int internalformat, final int x, final int y, final int width) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glCopyConvolutionFilter1D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCopyConvolutionFilter1D(target, internalformat, x, y, width, function_pointer);
    }
    
    private static native void nglCopyConvolutionFilter1D(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glCopyConvolutionFilter2D(final int target, final int internalformat, final int x, final int y, final int width, final int height) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glCopyConvolutionFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCopyConvolutionFilter2D(target, internalformat, x, y, width, height, function_pointer);
    }
    
    private static native void nglCopyConvolutionFilter2D(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final long p6);
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final ByteBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(image);
        nglGetConvolutionFilter(target, format, type, image, image.position(), function_pointer);
    }
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final DoubleBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(image);
        nglGetConvolutionFilter(target, format, type, image, image.position() << 3, function_pointer);
    }
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final FloatBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(image);
        nglGetConvolutionFilter(target, format, type, image, image.position() << 2, function_pointer);
    }
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final IntBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(image);
        nglGetConvolutionFilter(target, format, type, image, image.position() << 2, function_pointer);
    }
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final ShortBuffer image) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(image);
        nglGetConvolutionFilter(target, format, type, image, image.position() << 1, function_pointer);
    }
    
    private static native void nglGetConvolutionFilter(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final long p5);
    
    public static void glGetConvolutionFilter(final int target, final int format, final int type, final long image_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOenabled(caps);
        nglGetConvolutionFilterBO(target, format, type, image_buffer_offset, function_pointer);
    }
    
    private static native void nglGetConvolutionFilterBO(final int p0, final int p1, final int p2, final long p3, final long p4);
    
    public static void glGetConvolutionParameter(final int target, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionParameterfv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetConvolutionParameterfv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetConvolutionParameterfv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetConvolutionParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetConvolutionParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetConvolutionParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetConvolutionParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer row, final ByteBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position(), column, column.position(), function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer row, final DoubleBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position(), column, column.position() << 3, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer row, final FloatBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position(), column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer row, final IntBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position(), column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ByteBuffer row, final ShortBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position(), column, column.position() << 1, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final DoubleBuffer row, final ByteBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 3, column, column.position(), function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final DoubleBuffer row, final DoubleBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 3, column, column.position() << 3, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final DoubleBuffer row, final FloatBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 3, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final DoubleBuffer row, final IntBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 3, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final DoubleBuffer row, final ShortBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 3, column, column.position() << 1, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final FloatBuffer row, final ByteBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position(), function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final FloatBuffer row, final DoubleBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 3, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final FloatBuffer row, final FloatBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final FloatBuffer row, final IntBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final FloatBuffer row, final ShortBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 1, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer row, final ByteBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position(), function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer row, final DoubleBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 3, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer row, final FloatBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer row, final IntBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final IntBuffer row, final ShortBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 2, column, column.position() << 1, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer row, final ByteBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 1, column, column.position(), function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer row, final DoubleBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 1, column, column.position() << 3, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer row, final FloatBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 1, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer row, final IntBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 1, column, column.position() << 2, function_pointer);
    }
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final ShortBuffer row, final ShortBuffer column) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        nglSeparableFilter2D(target, internalformat, width, height, format, type, row, row.position() << 1, column, column.position() << 1, function_pointer);
    }
    
    private static native void nglSeparableFilter2D(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final Buffer p6, final int p7, final Buffer p8, final int p9, final long p10);
    
    public static void glSeparableFilter2D(final int target, final int internalformat, final int width, final int height, final int format, final int type, final long row_buffer_offset, final long column_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glSeparableFilter2D_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureUnpackPBOenabled(caps);
        nglSeparableFilter2DBO(target, internalformat, width, height, format, type, row_buffer_offset, column_buffer_offset, function_pointer);
    }
    
    private static native void nglSeparableFilter2DBO(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final long p6, final long p7, final long p8);
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ByteBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position(), span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ByteBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position(), span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ByteBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position(), span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ByteBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position(), span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final DoubleBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 3, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final DoubleBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 3, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final DoubleBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 3, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final DoubleBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 3, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final IntBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 2, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final IntBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 2, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final IntBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 2, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final IntBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 2, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ShortBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 1, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ShortBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 1, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ShortBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 1, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ByteBuffer row, final ShortBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position(), column, column.position() << 1, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ByteBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position(), span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ByteBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position(), span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ByteBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position(), span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ByteBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position(), span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final DoubleBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 3, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final DoubleBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 3, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final DoubleBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 3, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final DoubleBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 3, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final IntBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 2, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final IntBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 2, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final IntBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 2, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final IntBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 2, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ShortBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 1, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ShortBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 1, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ShortBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 1, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final DoubleBuffer row, final ShortBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 3, column, column.position() << 1, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ByteBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ByteBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ByteBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ByteBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final DoubleBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final DoubleBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final DoubleBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final DoubleBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final IntBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final IntBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final IntBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final IntBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ShortBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ShortBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ShortBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final FloatBuffer row, final ShortBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ByteBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ByteBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ByteBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ByteBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position(), span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final DoubleBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final DoubleBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final DoubleBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final DoubleBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 3, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final IntBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final IntBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final IntBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final IntBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 2, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ShortBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ShortBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ShortBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final IntBuffer row, final ShortBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 2, column, column.position() << 1, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ByteBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position(), span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ByteBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position(), span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ByteBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position(), span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ByteBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position(), span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final DoubleBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 3, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final DoubleBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 3, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final DoubleBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 3, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final DoubleBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 3, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final IntBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 2, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final IntBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 2, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final IntBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 2, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final IntBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 2, span, span.position() << 1, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ShortBuffer column, final ByteBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 1, span, span.position(), function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ShortBuffer column, final DoubleBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 1, span, span.position() << 3, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ShortBuffer column, final IntBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 1, span, span.position() << 2, function_pointer);
    }
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final ShortBuffer row, final ShortBuffer column, final ShortBuffer span) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOdisabled(caps);
        BufferChecks.checkDirect(row);
        BufferChecks.checkDirect(column);
        BufferChecks.checkDirect(span);
        nglGetSeparableFilter(target, format, type, row, row.position() << 1, column, column.position() << 1, span, span.position() << 1, function_pointer);
    }
    
    private static native void nglGetSeparableFilter(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final Buffer p5, final int p6, final Buffer p7, final int p8, final long p9);
    
    public static void glGetSeparableFilter(final int target, final int format, final int type, final long row_buffer_offset, final long column_buffer_offset, final long span_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_imaging_glGetSeparableFilter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensurePackPBOenabled(caps);
        nglGetSeparableFilterBO(target, format, type, row_buffer_offset, column_buffer_offset, span_buffer_offset, function_pointer);
    }
    
    private static native void nglGetSeparableFilterBO(final int p0, final int p1, final int p2, final long p3, final long p4, final long p5, final long p6);
}
