package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ARBMapBufferRange
{
    public static final int GL_MAP_READ_BIT = 1;
    public static final int GL_MAP_WRITE_BIT = 2;
    public static final int GL_MAP_INVALIDATE_RANGE_BIT = 4;
    public static final int GL_MAP_INVALIDATE_BUFFER_BIT = 8;
    public static final int GL_MAP_FLUSH_EXPLICIT_BIT = 16;
    public static final int GL_MAP_UNSYNCHRONIZED_BIT = 32;
    
    public static ByteBuffer glMapBufferRange(final int target, final long offset, final long length, final int access, final ByteBuffer old_buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_map_buffer_range_glMapBufferRange_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (old_buffer != null) {
            BufferChecks.checkDirect(old_buffer);
        }
        final ByteBuffer __result = nglMapBufferRange(target, offset, length, access, old_buffer, function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglMapBufferRange(final int p0, final long p1, final long p2, final int p3, final ByteBuffer p4, final long p5);
    
    public static void glFlushMappedBufferRange(final int target, final long offset, final long length) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_map_buffer_range_glFlushMappedBufferRange_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFlushMappedBufferRange(target, offset, length, function_pointer);
    }
    
    private static native void nglFlushMappedBufferRange(final int p0, final long p1, final long p2, final long p3);
}
