package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBMatrixPalette
{
    public static final int GL_MATRIX_PALETTE_ARB = 34880;
    public static final int GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB = 34881;
    public static final int GL_MAX_PALETTE_MATRICES_ARB = 34882;
    public static final int GL_CURRENT_PALETTE_MATRIX_ARB = 34883;
    public static final int GL_MATRIX_INDEX_ARRAY_ARB = 34884;
    public static final int GL_CURRENT_MATRIX_INDEX_ARB = 34885;
    public static final int GL_MATRIX_INDEX_ARRAY_SIZE_ARB = 34886;
    public static final int GL_MATRIX_INDEX_ARRAY_TYPE_ARB = 34887;
    public static final int GL_MATRIX_INDEX_ARRAY_STRIDE_ARB = 34888;
    public static final int GL_MATRIX_INDEX_ARRAY_POINTER_ARB = 34889;
    
    public static void glCurrentPaletteMatrixARB(final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glCurrentPaletteMatrixARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCurrentPaletteMatrixARB(index, function_pointer);
    }
    
    private static native void nglCurrentPaletteMatrixARB(final int p0, final long p1);
    
    public static void glMatrixIndexPointerARB(final int size, final int stride, final ByteBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        nglMatrixIndexPointerARB(size, 5121, stride, GLChecks.getReferences(caps).ARB_matrix_palette_glMatrixIndexPointerARB_pPointer = pPointer, pPointer.position(), function_pointer);
    }
    
    public static void glMatrixIndexPointerARB(final int size, final int stride, final IntBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        nglMatrixIndexPointerARB(size, 5125, stride, GLChecks.getReferences(caps).ARB_matrix_palette_glMatrixIndexPointerARB_pPointer = pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glMatrixIndexPointerARB(final int size, final int stride, final ShortBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        nglMatrixIndexPointerARB(size, 5123, stride, GLChecks.getReferences(caps).ARB_matrix_palette_glMatrixIndexPointerARB_pPointer = pPointer, pPointer.position() << 1, function_pointer);
    }
    
    private static native void nglMatrixIndexPointerARB(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final long p5);
    
    public static void glMatrixIndexPointerARB(final int size, final int type, final int stride, final long pPointer_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOenabled(caps);
        nglMatrixIndexPointerARBBO(size, type, stride, pPointer_buffer_offset, function_pointer);
    }
    
    private static native void nglMatrixIndexPointerARBBO(final int p0, final int p1, final int p2, final long p3, final long p4);
    
    public static void glMatrixIndexuARB(final ByteBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexubvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pIndices);
        nglMatrixIndexubvARB(pIndices.remaining(), pIndices, pIndices.position(), function_pointer);
    }
    
    private static native void nglMatrixIndexubvARB(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static void glMatrixIndexuARB(final ShortBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexusvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pIndices);
        nglMatrixIndexusvARB(pIndices.remaining(), pIndices, pIndices.position(), function_pointer);
    }
    
    private static native void nglMatrixIndexusvARB(final int p0, final ShortBuffer p1, final int p2, final long p3);
    
    public static void glMatrixIndexuARB(final IntBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_matrix_palette_glMatrixIndexuivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pIndices);
        nglMatrixIndexuivARB(pIndices.remaining(), pIndices, pIndices.position(), function_pointer);
    }
    
    private static native void nglMatrixIndexuivARB(final int p0, final IntBuffer p1, final int p2, final long p3);
}
