package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ARBOcclusionQuery
{
    public static final int GL_SAMPLES_PASSED_ARB = 35092;
    public static final int GL_QUERY_COUNTER_BITS_ARB = 34916;
    public static final int GL_CURRENT_QUERY_ARB = 34917;
    public static final int GL_QUERY_RESULT_ARB = 34918;
    public static final int GL_QUERY_RESULT_AVAILABLE_ARB = 34919;
    
    public static void glGenQueriesARB(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGenQueriesARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglGenQueriesARB(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglGenQueriesARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenQueriesARB() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGenQueriesARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer ids = APIUtils.getBufferInt();
        nglGenQueriesARB(1, ids, ids.position(), function_pointer);
        return ids.get(0);
    }
    
    public static void glDeleteQueriesARB(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glDeleteQueriesARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglDeleteQueriesARB(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglDeleteQueriesARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteQueriesARB(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glDeleteQueriesARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteQueriesARB(1, APIUtils.getBufferInt().put(0, id), 0, function_pointer);
    }
    
    public static boolean glIsQueryARB(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glIsQueryARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsQueryARB(id, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsQueryARB(final int p0, final long p1);
    
    public static void glBeginQueryARB(final int target, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glBeginQueryARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBeginQueryARB(target, id, function_pointer);
    }
    
    private static native void nglBeginQueryARB(final int p0, final int p1, final long p2);
    
    public static void glEndQueryARB(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glEndQueryARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEndQueryARB(target, function_pointer);
    }
    
    private static native void nglEndQueryARB(final int p0, final long p1);
    
    public static void glGetQueryARB(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryivARB(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQueryARB(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryivARB(target, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObjectARB(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryObjectivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectivARB(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQueryObjectiARB(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryObjectivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryObjectivARB(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObjectuARB(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryObjectuivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectuivARB(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectuivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQueryObjectuiARB(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_occlusion_query_glGetQueryObjectuivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryObjectuivARB(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
