package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public class ARBProgram
{
    public static final int GL_PROGRAM_FORMAT_ASCII_ARB = 34933;
    public static final int GL_PROGRAM_LENGTH_ARB = 34343;
    public static final int GL_PROGRAM_FORMAT_ARB = 34934;
    public static final int GL_PROGRAM_BINDING_ARB = 34423;
    public static final int GL_PROGRAM_INSTRUCTIONS_ARB = 34976;
    public static final int GL_MAX_PROGRAM_INSTRUCTIONS_ARB = 34977;
    public static final int GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB = 34978;
    public static final int GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB = 34979;
    public static final int GL_PROGRAM_TEMPORARIES_ARB = 34980;
    public static final int GL_MAX_PROGRAM_TEMPORARIES_ARB = 34981;
    public static final int GL_PROGRAM_NATIVE_TEMPORARIES_ARB = 34982;
    public static final int GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB = 34983;
    public static final int GL_PROGRAM_PARAMETERS_ARB = 34984;
    public static final int GL_MAX_PROGRAM_PARAMETERS_ARB = 34985;
    public static final int GL_PROGRAM_NATIVE_PARAMETERS_ARB = 34986;
    public static final int GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB = 34987;
    public static final int GL_PROGRAM_ATTRIBS_ARB = 34988;
    public static final int GL_MAX_PROGRAM_ATTRIBS_ARB = 34989;
    public static final int GL_PROGRAM_NATIVE_ATTRIBS_ARB = 34990;
    public static final int GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB = 34991;
    public static final int GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB = 34996;
    public static final int GL_MAX_PROGRAM_ENV_PARAMETERS_ARB = 34997;
    public static final int GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB = 34998;
    public static final int GL_PROGRAM_STRING_ARB = 34344;
    public static final int GL_PROGRAM_ERROR_POSITION_ARB = 34379;
    public static final int GL_CURRENT_MATRIX_ARB = 34369;
    public static final int GL_TRANSPOSE_CURRENT_MATRIX_ARB = 34999;
    public static final int GL_CURRENT_MATRIX_STACK_DEPTH_ARB = 34368;
    public static final int GL_MAX_PROGRAM_MATRICES_ARB = 34351;
    public static final int GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB = 34350;
    public static final int GL_PROGRAM_ERROR_STRING_ARB = 34932;
    public static final int GL_MATRIX0_ARB = 35008;
    public static final int GL_MATRIX1_ARB = 35009;
    public static final int GL_MATRIX2_ARB = 35010;
    public static final int GL_MATRIX3_ARB = 35011;
    public static final int GL_MATRIX4_ARB = 35012;
    public static final int GL_MATRIX5_ARB = 35013;
    public static final int GL_MATRIX6_ARB = 35014;
    public static final int GL_MATRIX7_ARB = 35015;
    public static final int GL_MATRIX8_ARB = 35016;
    public static final int GL_MATRIX9_ARB = 35017;
    public static final int GL_MATRIX10_ARB = 35018;
    public static final int GL_MATRIX11_ARB = 35019;
    public static final int GL_MATRIX12_ARB = 35020;
    public static final int GL_MATRIX13_ARB = 35021;
    public static final int GL_MATRIX14_ARB = 35022;
    public static final int GL_MATRIX15_ARB = 35023;
    public static final int GL_MATRIX16_ARB = 35024;
    public static final int GL_MATRIX17_ARB = 35025;
    public static final int GL_MATRIX18_ARB = 35026;
    public static final int GL_MATRIX19_ARB = 35027;
    public static final int GL_MATRIX20_ARB = 35028;
    public static final int GL_MATRIX21_ARB = 35029;
    public static final int GL_MATRIX22_ARB = 35030;
    public static final int GL_MATRIX23_ARB = 35031;
    public static final int GL_MATRIX24_ARB = 35032;
    public static final int GL_MATRIX25_ARB = 35033;
    public static final int GL_MATRIX26_ARB = 35034;
    public static final int GL_MATRIX27_ARB = 35035;
    public static final int GL_MATRIX28_ARB = 35036;
    public static final int GL_MATRIX29_ARB = 35037;
    public static final int GL_MATRIX30_ARB = 35038;
    public static final int GL_MATRIX31_ARB = 35039;
    
    public static void glProgramStringARB(final int target, final int format, final ByteBuffer string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramStringARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(string);
        nglProgramStringARB(target, format, string.remaining(), string, string.position(), function_pointer);
    }
    
    private static native void nglProgramStringARB(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final long p5);
    
    public static void glProgramStringARB(final int target, final int format, final CharSequence string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramStringARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramStringARB(target, format, string.length(), APIUtils.getBuffer(string), 0, function_pointer);
    }
    
    public static void glBindProgramARB(final int target, final int program) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glBindProgramARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindProgramARB(target, program, function_pointer);
    }
    
    private static native void nglBindProgramARB(final int p0, final int p1, final long p2);
    
    public static void glDeleteProgramsARB(final IntBuffer programs) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glDeleteProgramsARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(programs);
        nglDeleteProgramsARB(programs.remaining(), programs, programs.position(), function_pointer);
    }
    
    private static native void nglDeleteProgramsARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteProgramsARB(final int program) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glDeleteProgramsARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteProgramsARB(1, APIUtils.getBufferInt().put(0, program), 0, function_pointer);
    }
    
    public static void glGenProgramsARB(final IntBuffer programs) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGenProgramsARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(programs);
        nglGenProgramsARB(programs.remaining(), programs, programs.position(), function_pointer);
    }
    
    private static native void nglGenProgramsARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenProgramsARB() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGenProgramsARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer programs = APIUtils.getBufferInt();
        nglGenProgramsARB(1, programs, programs.position(), function_pointer);
        return programs.get(0);
    }
    
    public static void glProgramEnvParameter4fARB(final int target, final int index, final float x, final float y, final float z, final float w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramEnvParameter4fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramEnvParameter4fARB(target, index, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramEnvParameter4fARB(final int p0, final int p1, final float p2, final float p3, final float p4, final float p5, final long p6);
    
    public static void glProgramEnvParameter4dARB(final int target, final int index, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramEnvParameter4dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramEnvParameter4dARB(target, index, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramEnvParameter4dARB(final int p0, final int p1, final double p2, final double p3, final double p4, final double p5, final long p6);
    
    public static void glProgramEnvParameter4ARB(final int target, final int index, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramEnvParameter4fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglProgramEnvParameter4fvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramEnvParameter4fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glProgramEnvParameter4ARB(final int target, final int index, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramEnvParameter4dvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglProgramEnvParameter4dvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramEnvParameter4dvARB(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glProgramLocalParameter4fARB(final int target, final int index, final float x, final float y, final float z, final float w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramLocalParameter4fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramLocalParameter4fARB(target, index, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramLocalParameter4fARB(final int p0, final int p1, final float p2, final float p3, final float p4, final float p5, final long p6);
    
    public static void glProgramLocalParameter4dARB(final int target, final int index, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramLocalParameter4dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramLocalParameter4dARB(target, index, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramLocalParameter4dARB(final int p0, final int p1, final double p2, final double p3, final double p4, final double p5, final long p6);
    
    public static void glProgramLocalParameter4ARB(final int target, final int index, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramLocalParameter4fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglProgramLocalParameter4fvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramLocalParameter4fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glProgramLocalParameter4ARB(final int target, final int index, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glProgramLocalParameter4dvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglProgramLocalParameter4dvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramLocalParameter4dvARB(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glGetProgramEnvParameterARB(final int target, final int index, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramEnvParameterfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramEnvParameterfvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramEnvParameterfvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetProgramEnvParameterARB(final int target, final int index, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramEnvParameterdvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramEnvParameterdvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramEnvParameterdvARB(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glGetProgramLocalParameterARB(final int target, final int index, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramLocalParameterfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramLocalParameterfvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramLocalParameterfvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetProgramLocalParameterARB(final int target, final int index, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramLocalParameterdvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramLocalParameterdvARB(target, index, params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramLocalParameterdvARB(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glGetProgramARB(final int target, final int parameterName, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramivARB(target, parameterName, params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetProgramARB(final int target, final int parameterName) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetProgramivARB(target, parameterName, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetProgramStringARB(final int target, final int parameterName, final ByteBuffer paramString) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramStringARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(paramString);
        nglGetProgramStringARB(target, parameterName, paramString, paramString.position(), function_pointer);
    }
    
    private static native void nglGetProgramStringARB(final int p0, final int p1, final Buffer p2, final int p3, final long p4);
    
    public static String glGetProgramStringARB(final int target, final int parameterName) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glGetProgramStringARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int programLength = glGetProgramARB(target, 34343);
        final ByteBuffer paramString = APIUtils.getBufferByte(programLength);
        nglGetProgramStringARB(target, parameterName, paramString, paramString.position(), function_pointer);
        paramString.limit(programLength);
        return APIUtils.getString(paramString);
    }
    
    public static boolean glIsProgramARB(final int program) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_program_glIsProgramARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsProgramARB(program, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsProgramARB(final int p0, final long p1);
}
