package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBShaderObjects
{
    public static final int GL_PROGRAM_OBJECT_ARB = 35648;
    public static final int GL_OBJECT_TYPE_ARB = 35662;
    public static final int GL_OBJECT_SUBTYPE_ARB = 35663;
    public static final int GL_OBJECT_DELETE_STATUS_ARB = 35712;
    public static final int GL_OBJECT_COMPILE_STATUS_ARB = 35713;
    public static final int GL_OBJECT_LINK_STATUS_ARB = 35714;
    public static final int GL_OBJECT_VALIDATE_STATUS_ARB = 35715;
    public static final int GL_OBJECT_INFO_LOG_LENGTH_ARB = 35716;
    public static final int GL_OBJECT_ATTACHED_OBJECTS_ARB = 35717;
    public static final int GL_OBJECT_ACTIVE_UNIFORMS_ARB = 35718;
    public static final int GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB = 35719;
    public static final int GL_OBJECT_SHADER_SOURCE_LENGTH_ARB = 35720;
    public static final int GL_SHADER_OBJECT_ARB = 35656;
    public static final int GL_FLOAT = 5126;
    public static final int GL_FLOAT_VEC2_ARB = 35664;
    public static final int GL_FLOAT_VEC3_ARB = 35665;
    public static final int GL_FLOAT_VEC4_ARB = 35666;
    public static final int GL_INT = 5124;
    public static final int GL_INT_VEC2_ARB = 35667;
    public static final int GL_INT_VEC3_ARB = 35668;
    public static final int GL_INT_VEC4_ARB = 35669;
    public static final int GL_BOOL_ARB = 35670;
    public static final int GL_BOOL_VEC2_ARB = 35671;
    public static final int GL_BOOL_VEC3_ARB = 35672;
    public static final int GL_BOOL_VEC4_ARB = 35673;
    public static final int GL_FLOAT_MAT2_ARB = 35674;
    public static final int GL_FLOAT_MAT3_ARB = 35675;
    public static final int GL_FLOAT_MAT4_ARB = 35676;
    public static final int GL_SAMPLER_1D_ARB = 35677;
    public static final int GL_SAMPLER_2D_ARB = 35678;
    public static final int GL_SAMPLER_3D_ARB = 35679;
    public static final int GL_SAMPLER_CUBE_ARB = 35680;
    public static final int GL_SAMPLER_1D_SHADOW_ARB = 35681;
    public static final int GL_SAMPLER_2D_SHADOW_ARB = 35682;
    public static final int GL_SAMPLER_2D_RECT_ARB = 35683;
    public static final int GL_SAMPLER_2D_RECT_SHADOW_ARB = 35684;
    
    public static void glDeleteObjectARB(final int obj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glDeleteObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteObjectARB(obj, function_pointer);
    }
    
    private static native void nglDeleteObjectARB(final int p0, final long p1);
    
    public static int glGetHandleARB(final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetHandleARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglGetHandleARB(pname, function_pointer);
        return __result;
    }
    
    private static native int nglGetHandleARB(final int p0, final long p1);
    
    public static void glDetachObjectARB(final int containerObj, final int attachedObj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glDetachObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDetachObjectARB(containerObj, attachedObj, function_pointer);
    }
    
    private static native void nglDetachObjectARB(final int p0, final int p1, final long p2);
    
    public static int glCreateShaderObjectARB(final int shaderType) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glCreateShaderObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglCreateShaderObjectARB(shaderType, function_pointer);
        return __result;
    }
    
    private static native int nglCreateShaderObjectARB(final int p0, final long p1);
    
    public static void glShaderSourceARB(final int shader, final ByteBuffer string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glShaderSourceARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(string);
        nglShaderSourceARB(shader, 1, string, string.position(), string.remaining(), function_pointer);
    }
    
    private static native void nglShaderSourceARB(final int p0, final int p1, final ByteBuffer p2, final int p3, final int p4, final long p5);
    
    public static void glShaderSourceARB(final int shader, final CharSequence string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glShaderSourceARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglShaderSourceARB(shader, 1, APIUtils.getBuffer(string), 0, string.length(), function_pointer);
    }
    
    public static void glShaderSourceARB(final int shader, final CharSequence[] strings) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glShaderSourceARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglShaderSourceARB3(shader, strings.length, APIUtils.getBuffer(strings), 0, APIUtils.getLengths(strings), 0, function_pointer);
    }
    
    private static native void nglShaderSourceARB3(final int p0, final int p1, final ByteBuffer p2, final int p3, final IntBuffer p4, final int p5, final long p6);
    
    public static void glCompileShaderARB(final int shaderObj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glCompileShaderARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglCompileShaderARB(shaderObj, function_pointer);
    }
    
    private static native void nglCompileShaderARB(final int p0, final long p1);
    
    public static int glCreateProgramObjectARB() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glCreateProgramObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglCreateProgramObjectARB(function_pointer);
        return __result;
    }
    
    private static native int nglCreateProgramObjectARB(final long p0);
    
    public static void glAttachObjectARB(final int containerObj, final int obj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glAttachObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglAttachObjectARB(containerObj, obj, function_pointer);
    }
    
    private static native void nglAttachObjectARB(final int p0, final int p1, final long p2);
    
    public static void glLinkProgramARB(final int programObj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glLinkProgramARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglLinkProgramARB(programObj, function_pointer);
    }
    
    private static native void nglLinkProgramARB(final int p0, final long p1);
    
    public static void glUseProgramObjectARB(final int programObj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUseProgramObjectARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUseProgramObjectARB(programObj, function_pointer);
    }
    
    private static native void nglUseProgramObjectARB(final int p0, final long p1);
    
    public static void glValidateProgramARB(final int programObj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glValidateProgramARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglValidateProgramARB(programObj, function_pointer);
    }
    
    private static native void nglValidateProgramARB(final int p0, final long p1);
    
    public static void glUniform1fARB(final int location, final float v0) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform1fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform1fARB(location, v0, function_pointer);
    }
    
    private static native void nglUniform1fARB(final int p0, final float p1, final long p2);
    
    public static void glUniform2fARB(final int location, final float v0, final float v1) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform2fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform2fARB(location, v0, v1, function_pointer);
    }
    
    private static native void nglUniform2fARB(final int p0, final float p1, final float p2, final long p3);
    
    public static void glUniform3fARB(final int location, final float v0, final float v1, final float v2) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform3fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform3fARB(location, v0, v1, v2, function_pointer);
    }
    
    private static native void nglUniform3fARB(final int p0, final float p1, final float p2, final float p3, final long p4);
    
    public static void glUniform4fARB(final int location, final float v0, final float v1, final float v2, final float v3) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform4fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform4fARB(location, v0, v1, v2, v3, function_pointer);
    }
    
    private static native void nglUniform4fARB(final int p0, final float p1, final float p2, final float p3, final float p4, final long p5);
    
    public static void glUniform1iARB(final int location, final int v0) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform1iARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform1iARB(location, v0, function_pointer);
    }
    
    private static native void nglUniform1iARB(final int p0, final int p1, final long p2);
    
    public static void glUniform2iARB(final int location, final int v0, final int v1) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform2iARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform2iARB(location, v0, v1, function_pointer);
    }
    
    private static native void nglUniform2iARB(final int p0, final int p1, final int p2, final long p3);
    
    public static void glUniform3iARB(final int location, final int v0, final int v1, final int v2) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform3iARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform3iARB(location, v0, v1, v2, function_pointer);
    }
    
    private static native void nglUniform3iARB(final int p0, final int p1, final int p2, final int p3, final long p4);
    
    public static void glUniform4iARB(final int location, final int v0, final int v1, final int v2, final int v3) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform4iARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform4iARB(location, v0, v1, v2, v3, function_pointer);
    }
    
    private static native void nglUniform4iARB(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glUniform1ARB(final int location, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform1fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform1fvARB(location, values.remaining(), values, values.position(), function_pointer);
    }
    
    private static native void nglUniform1fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glUniform2ARB(final int location, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform2fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform2fvARB(location, values.remaining() >> 1, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform2fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glUniform3ARB(final int location, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform3fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform3fvARB(location, values.remaining() / 3, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform3fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glUniform4ARB(final int location, final FloatBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform4fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform4fvARB(location, values.remaining() >> 2, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform4fvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glUniform1ARB(final int location, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform1ivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform1ivARB(location, values.remaining(), values, values.position(), function_pointer);
    }
    
    private static native void nglUniform1ivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glUniform2ARB(final int location, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform2ivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform2ivARB(location, values.remaining() >> 1, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform2ivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glUniform3ARB(final int location, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform3ivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform3ivARB(location, values.remaining() / 3, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform3ivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glUniform4ARB(final int location, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniform4ivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(values);
        nglUniform4ivARB(location, values.remaining() >> 2, values, values.position(), function_pointer);
    }
    
    private static native void nglUniform4ivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glUniformMatrix2ARB(final int location, final boolean transpose, final FloatBuffer matrices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniformMatrix2fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(matrices);
        nglUniformMatrix2fvARB(location, matrices.remaining() >> 2, transpose, matrices, matrices.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix2fvARB(final int p0, final int p1, final boolean p2, final FloatBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix3ARB(final int location, final boolean transpose, final FloatBuffer matrices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniformMatrix3fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(matrices);
        nglUniformMatrix3fvARB(location, matrices.remaining() / 9, transpose, matrices, matrices.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix3fvARB(final int p0, final int p1, final boolean p2, final FloatBuffer p3, final int p4, final long p5);
    
    public static void glUniformMatrix4ARB(final int location, final boolean transpose, final FloatBuffer matrices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glUniformMatrix4fvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(matrices);
        nglUniformMatrix4fvARB(location, matrices.remaining() >> 4, transpose, matrices, matrices.position(), function_pointer);
    }
    
    private static native void nglUniformMatrix4fvARB(final int p0, final int p1, final boolean p2, final FloatBuffer p3, final int p4, final long p5);
    
    public static void glGetObjectParameterARB(final int obj, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetObjectParameterfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetObjectParameterfvARB(obj, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetObjectParameterfvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static float glGetObjectParameterfARB(final int obj, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetObjectParameterfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final FloatBuffer params = APIUtils.getBufferFloat();
        nglGetObjectParameterfvARB(obj, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetObjectParameterARB(final int obj, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetObjectParameterivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetObjectParameterivARB(obj, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetObjectParameterivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetObjectParameteriARB(final int obj, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetObjectParameterivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetObjectParameterivARB(obj, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetInfoLogARB(final int obj, final IntBuffer length, final ByteBuffer infoLog) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetInfoLogARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkDirect(infoLog);
        nglGetInfoLogARB(obj, infoLog.remaining(), length, (length != null) ? length.position() : 0, infoLog, infoLog.position(), function_pointer);
    }
    
    private static native void nglGetInfoLogARB(final int p0, final int p1, final IntBuffer p2, final int p3, final ByteBuffer p4, final int p5, final long p6);
    
    public static String glGetInfoLogARB(final int obj, final int maxLength) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetInfoLogARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer infoLog_length = APIUtils.getLengths();
        final ByteBuffer infoLog = APIUtils.getBufferByte(maxLength);
        nglGetInfoLogARB(obj, maxLength, infoLog_length, 0, infoLog, infoLog.position(), function_pointer);
        infoLog.limit(infoLog_length.get(0));
        return APIUtils.getString(infoLog);
    }
    
    public static void glGetAttachedObjectsARB(final int containerObj, final IntBuffer count, final IntBuffer obj) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetAttachedObjectsARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (count != null) {
            BufferChecks.checkBuffer(count, 1);
        }
        BufferChecks.checkDirect(obj);
        nglGetAttachedObjectsARB(containerObj, obj.remaining(), count, (count != null) ? count.position() : 0, obj, obj.position(), function_pointer);
    }
    
    private static native void nglGetAttachedObjectsARB(final int p0, final int p1, final IntBuffer p2, final int p3, final IntBuffer p4, final int p5, final long p6);
    
    public static int glGetUniformLocationARB(final int programObj, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetUniformLocationARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        final int __result = nglGetUniformLocationARB(programObj, name, name.position(), function_pointer);
        return __result;
    }
    
    private static native int nglGetUniformLocationARB(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static int glGetUniformLocationARB(final int programObj, final CharSequence name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetUniformLocationARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglGetUniformLocationARB(programObj, APIUtils.getBufferNT(name), 0, function_pointer);
        return __result;
    }
    
    public static void glGetActiveUniformARB(final int programObj, final int index, final IntBuffer length, final IntBuffer size, final IntBuffer type, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetActiveUniformARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkBuffer(size, 1);
        BufferChecks.checkBuffer(type, 1);
        BufferChecks.checkDirect(name);
        nglGetActiveUniformARB(programObj, index, name.remaining(), length, (length != null) ? length.position() : 0, size, size.position(), type, type.position(), name, name.position(), function_pointer);
    }
    
    private static native void nglGetActiveUniformARB(final int p0, final int p1, final int p2, final IntBuffer p3, final int p4, final IntBuffer p5, final int p6, final IntBuffer p7, final int p8, final ByteBuffer p9, final int p10, final long p11);
    
    public static String glGetActiveUniformARB(final int programObj, final int index, final int maxLength, final IntBuffer sizeType) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetActiveUniformARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(sizeType, 2);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(maxLength);
        nglGetActiveUniformARB(programObj, index, maxLength, name_length, 0, sizeType, sizeType.position(), sizeType, sizeType.position() + 1, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static String glGetActiveUniformARB(final int programObj, final int index, final int maxLength) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetActiveUniformARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(maxLength);
        nglGetActiveUniformARB(programObj, index, maxLength, name_length, 0, APIUtils.getBufferInt(), 0, APIUtils.getBufferInt(), 1, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static int glGetActiveUniformSizeARB(final int programObj, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetActiveUniformARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer size = APIUtils.getBufferInt();
        nglGetActiveUniformARB(programObj, index, 0, null, 0, size, size.position(), size, 1, APIUtils.getBufferByte(0), 0, function_pointer);
        return size.get(0);
    }
    
    public static int glGetActiveUniformTypeARB(final int programObj, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetActiveUniformARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer type = APIUtils.getBufferInt();
        nglGetActiveUniformARB(programObj, index, 0, null, 0, type, 1, type, type.position(), APIUtils.getBufferByte(0), 0, function_pointer);
        return type.get(0);
    }
    
    public static void glGetUniformARB(final int programObj, final int location, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetUniformfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetUniformfvARB(programObj, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformfvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetUniformARB(final int programObj, final int location, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetUniformivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetUniformivARB(programObj, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glGetShaderSourceARB(final int obj, final IntBuffer length, final ByteBuffer source) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetShaderSourceARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkDirect(source);
        nglGetShaderSourceARB(obj, source.remaining(), length, (length != null) ? length.position() : 0, source, source.position(), function_pointer);
    }
    
    private static native void nglGetShaderSourceARB(final int p0, final int p1, final IntBuffer p2, final int p3, final ByteBuffer p4, final int p5, final long p6);
    
    public static String glGetShaderSourceARB(final int obj, final int maxLength) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_objects_glGetShaderSourceARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer source_length = APIUtils.getLengths();
        final ByteBuffer source = APIUtils.getBufferByte(maxLength);
        nglGetShaderSourceARB(obj, maxLength, source_length, 0, source, source.position(), function_pointer);
        source.limit(source_length.get(0));
        return APIUtils.getString(source);
    }
}
