package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBShaderSubroutine
{
    public static final int GL_ACTIVE_SUBROUTINES = 36325;
    public static final int GL_ACTIVE_SUBROUTINE_UNIFORMS = 36326;
    public static final int GL_ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS = 36423;
    public static final int GL_ACTIVE_SUBROUTINE_MAX_LENGTH = 36424;
    public static final int GL_ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH = 36425;
    public static final int GL_MAX_SUBROUTINES = 36327;
    public static final int GL_MAX_SUBROUTINE_UNIFORM_LOCATIONS = 36328;
    public static final int GL_NUM_COMPATIBLE_SUBROUTINES = 36426;
    public static final int GL_COMPATIBLE_SUBROUTINES = 36427;
    public static final int GL_UNIFORM_SIZE = 35384;
    public static final int GL_UNIFORM_NAME_LENGTH = 35385;
    
    public static int glGetSubroutineUniformLocation(final int program, final int shadertype, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetSubroutineUniformLocation_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        final int __result = nglGetSubroutineUniformLocation(program, shadertype, name, name.position(), function_pointer);
        return __result;
    }
    
    private static native int nglGetSubroutineUniformLocation(final int p0, final int p1, final ByteBuffer p2, final int p3, final long p4);
    
    public static int glGetSubroutineIndex(final int program, final int shadertype, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetSubroutineIndex_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        final int __result = nglGetSubroutineIndex(program, shadertype, name, name.position(), function_pointer);
        return __result;
    }
    
    private static native int nglGetSubroutineIndex(final int p0, final int p1, final ByteBuffer p2, final int p3, final long p4);
    
    public static void glGetActiveSubroutineUniform(final int program, final int shadertype, final int index, final int pname, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineUniformiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(values, 1);
        nglGetActiveSubroutineUniformiv(program, shadertype, index, pname, values, values.position(), function_pointer);
    }
    
    private static native void nglGetActiveSubroutineUniformiv(final int p0, final int p1, final int p2, final int p3, final IntBuffer p4, final int p5, final long p6);
    
    public static int glGetActiveSubroutineUniform(final int program, final int shadertype, final int index, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineUniformiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer values = APIUtils.getBufferInt();
        nglGetActiveSubroutineUniformiv(program, shadertype, index, pname, values, values.position(), function_pointer);
        return values.get(0);
    }
    
    public static void glGetActiveSubroutineUniformName(final int program, final int shadertype, final int index, final IntBuffer length, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineUniformName_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkDirect(name);
        nglGetActiveSubroutineUniformName(program, shadertype, index, name.remaining(), length, (length != null) ? length.position() : 0, name, name.position(), function_pointer);
    }
    
    private static native void nglGetActiveSubroutineUniformName(final int p0, final int p1, final int p2, final int p3, final IntBuffer p4, final int p5, final ByteBuffer p6, final int p7, final long p8);
    
    public static String glGetActiveSubroutineUniformName(final int program, final int shadertype, final int index, final int bufsize) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineUniformName_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(bufsize);
        nglGetActiveSubroutineUniformName(program, shadertype, index, bufsize, name_length, 0, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static void glGetActiveSubroutineName(final int program, final int shadertype, final int index, final IntBuffer length, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineName_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkDirect(name);
        nglGetActiveSubroutineName(program, shadertype, index, name.remaining(), length, (length != null) ? length.position() : 0, name, name.position(), function_pointer);
    }
    
    private static native void nglGetActiveSubroutineName(final int p0, final int p1, final int p2, final int p3, final IntBuffer p4, final int p5, final ByteBuffer p6, final int p7, final long p8);
    
    public static String glGetActiveSubroutineName(final int program, final int shadertype, final int index, final int bufsize) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetActiveSubroutineName_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(bufsize);
        nglGetActiveSubroutineName(program, shadertype, index, bufsize, name_length, 0, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static void glUniformSubroutinesu(final int shadertype, final IntBuffer indices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glUniformSubroutinesuiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(indices);
        nglUniformSubroutinesuiv(shadertype, indices.remaining(), indices, indices.position(), function_pointer);
    }
    
    private static native void nglUniformSubroutinesuiv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glGetUniformSubroutineu(final int shadertype, final int location, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetUniformSubroutineuiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetUniformSubroutineuiv(shadertype, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformSubroutineuiv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetUniformSubroutineu(final int shadertype, final int location) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetUniformSubroutineuiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetUniformSubroutineuiv(shadertype, location, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetProgramStage(final int program, final int shadertype, final int pname, final IntBuffer values) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetProgramStageiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(values, 1);
        nglGetProgramStageiv(program, shadertype, pname, values, values.position(), function_pointer);
    }
    
    private static native void nglGetProgramStageiv(final int p0, final int p1, final int p2, final IntBuffer p3, final int p4, final long p5);
    
    public static int glGetProgramStage(final int program, final int shadertype, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_shader_subroutine_glGetProgramStageiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer values = APIUtils.getBufferInt();
        nglGetProgramStageiv(program, shadertype, pname, values, values.position(), function_pointer);
        return values.get(0);
    }
}
