package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBTextureMultisample
{
    public static final int GL_SAMPLE_POSITION = 36432;
    public static final int GL_SAMPLE_MASK = 36433;
    public static final int GL_SAMPLE_MASK_VALUE = 36434;
    public static final int GL_TEXTURE_2D_MULTISAMPLE = 37120;
    public static final int GL_PROXY_TEXTURE_2D_MULTISAMPLE = 37121;
    public static final int GL_TEXTURE_2D_MULTISAMPLE_ARRAY = 37122;
    public static final int GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY = 37123;
    public static final int GL_MAX_SAMPLE_MASK_WORDS = 36441;
    public static final int GL_MAX_COLOR_TEXTURE_SAMPLES = 37134;
    public static final int GL_MAX_DEPTH_TEXTURE_SAMPLES = 37135;
    public static final int GL_MAX_INTEGER_SAMPLES = 37136;
    public static final int GL_TEXTURE_BINDING_2D_MULTISAMPLE = 37124;
    public static final int GL_TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY = 37125;
    public static final int GL_TEXTURE_SAMPLES = 37126;
    public static final int GL_TEXTURE_FIXED_SAMPLE_LOCATIONS = 37127;
    public static final int GL_SAMPLER_2D_MULTISAMPLE = 37128;
    public static final int GL_INT_SAMPLER_2D_MULTISAMPLE = 37129;
    public static final int GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE = 37130;
    public static final int GL_SAMPLER_2D_MULTISAMPLE_ARRAY = 37131;
    public static final int GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY = 37132;
    public static final int GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY = 37133;
    
    public static void glTexImage2DMultisample(final int target, final int samples, final int internalformat, final int width, final int height, final boolean fixedsamplelocations) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_texture_multisample_glTexImage2DMultisample_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglTexImage2DMultisample(target, samples, internalformat, width, height, fixedsamplelocations, function_pointer);
    }
    
    private static native void nglTexImage2DMultisample(final int p0, final int p1, final int p2, final int p3, final int p4, final boolean p5, final long p6);
    
    public static void glTexImage3DMultisample(final int target, final int samples, final int internalformat, final int width, final int height, final int depth, final boolean fixedsamplelocations) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_texture_multisample_glTexImage3DMultisample_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglTexImage3DMultisample(target, samples, internalformat, width, height, depth, fixedsamplelocations, function_pointer);
    }
    
    private static native void nglTexImage3DMultisample(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final boolean p6, final long p7);
    
    public static void glGetMultisample(final int pname, final int index, final FloatBuffer val) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_texture_multisample_glGetMultisamplefv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(val, 2);
        nglGetMultisamplefv(pname, index, val, val.position(), function_pointer);
    }
    
    private static native void nglGetMultisamplefv(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glSampleMaski(final int index, final int mask) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_texture_multisample_glSampleMaski_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglSampleMaski(index, mask, function_pointer);
    }
    
    private static native void nglSampleMaski(final int p0, final int p1, final long p2);
}
