package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBTimerQuery
{
    public static final int GL_TIME_ELAPSED = 35007;
    public static final int GL_TIMESTAMP = 36392;
    
    public static void glQueryCounter(final int id, final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_timer_query_glQueryCounter_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglQueryCounter(id, target, function_pointer);
    }
    
    private static native void nglQueryCounter(final int p0, final int p1, final long p2);
    
    public static void glGetQueryObject(final int id, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_timer_query_glGetQueryObjecti64v_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjecti64v(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjecti64v(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetQueryObject(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_timer_query_glGetQueryObjecti64v_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetQueryObjecti64v(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObjectu(final int id, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_timer_query_glGetQueryObjectui64v_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectui64v(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectui64v(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetQueryObjectu(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_timer_query_glGetQueryObjectui64v_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetQueryObjectui64v(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
