package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBTransformFeedback2
{
    public static final int GL_TRANSFORM_FEEDBACK = 36386;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED = 36387;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE = 36388;
    public static final int GL_TRANSFORM_FEEDBACK_BINDING = 36389;
    
    public static void glBindTransformFeedback(final int target, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glBindTransformFeedback_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindTransformFeedback(target, id, function_pointer);
    }
    
    private static native void nglBindTransformFeedback(final int p0, final int p1, final long p2);
    
    public static void glDeleteTransformFeedbacks(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glDeleteTransformFeedbacks_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglDeleteTransformFeedbacks(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglDeleteTransformFeedbacks(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteTransformFeedbacks(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glDeleteTransformFeedbacks_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteTransformFeedbacks(1, APIUtils.getBufferInt().put(0, id), 0, function_pointer);
    }
    
    public static void glGenTransformFeedbacks(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glGenTransformFeedbacks_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglGenTransformFeedbacks(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglGenTransformFeedbacks(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenTransformFeedbacks() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glGenTransformFeedbacks_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer ids = APIUtils.getBufferInt();
        nglGenTransformFeedbacks(1, ids, ids.position(), function_pointer);
        return ids.get(0);
    }
    
    public static boolean glIsTransformFeedback(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glIsTransformFeedback_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsTransformFeedback(id, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsTransformFeedback(final int p0, final long p1);
    
    public static void glPauseTransformFeedback() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glPauseTransformFeedback_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglPauseTransformFeedback(function_pointer);
    }
    
    private static native void nglPauseTransformFeedback(final long p0);
    
    public static void glResumeTransformFeedback() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glResumeTransformFeedback_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglResumeTransformFeedback(function_pointer);
    }
    
    private static native void nglResumeTransformFeedback(final long p0);
    
    public static void glDrawTransformFeedback(final int mode, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback2_glDrawTransformFeedback_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawTransformFeedback(mode, id, function_pointer);
    }
    
    private static native void nglDrawTransformFeedback(final int p0, final int p1, final long p2);
}
