package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBTransformFeedback3
{
    public static final int GL_MAX_TRANSFORM_FEEDBACK_BUFFERS = 36464;
    public static final int GL_MAX_VERTEX_STREAMS = 36465;
    
    public static void glDrawTransformFeedbackStream(final int mode, final int id, final int stream) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback3_glDrawTransformFeedbackStream_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawTransformFeedbackStream(mode, id, stream, function_pointer);
    }
    
    private static native void nglDrawTransformFeedbackStream(final int p0, final int p1, final int p2, final long p3);
    
    public static void glBeginQueryIndexed(final int target, final int index, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback3_glBeginQueryIndexed_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBeginQueryIndexed(target, index, id, function_pointer);
    }
    
    private static native void nglBeginQueryIndexed(final int p0, final int p1, final int p2, final long p3);
    
    public static void glEndQueryIndexed(final int target, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback3_glEndQueryIndexed_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEndQueryIndexed(target, index, function_pointer);
    }
    
    private static native void nglEndQueryIndexed(final int p0, final int p1, final long p2);
    
    public static void glGetQueryIndexed(final int target, final int index, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback3_glGetQueryIndexediv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryIndexediv(target, index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryIndexediv(final int p0, final int p1, final int p2, final IntBuffer p3, final int p4, final long p5);
    
    public static int glGetQueryIndexed(final int target, final int index, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transform_feedback3_glGetQueryIndexediv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryIndexediv(target, index, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
