package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ARBTransposeMatrix
{
    public static final int GL_TRANSPOSE_MODELVIEW_MATRIX_ARB = 34019;
    public static final int GL_TRANSPOSE_PROJECTION_MATRIX_ARB = 34020;
    public static final int GL_TRANSPOSE_TEXTURE_MATRIX_ARB = 34021;
    public static final int GL_TRANSPOSE_COLOR_MATRIX_ARB = 34022;
    
    public static void glLoadTransposeMatrixARB(final FloatBuffer pfMtx) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transpose_matrix_glLoadTransposeMatrixfARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(pfMtx, 16);
        nglLoadTransposeMatrixfARB(pfMtx, pfMtx.position(), function_pointer);
    }
    
    private static native void nglLoadTransposeMatrixfARB(final FloatBuffer p0, final int p1, final long p2);
    
    public static void glMultTransposeMatrixARB(final FloatBuffer pfMtx) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_transpose_matrix_glMultTransposeMatrixfARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(pfMtx, 16);
        nglMultTransposeMatrixfARB(pfMtx, pfMtx.position(), function_pointer);
    }
    
    private static native void nglMultTransposeMatrixfARB(final FloatBuffer p0, final int p1, final long p2);
}
