package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBVertexArrayObject
{
    public static final int GL_VERTEX_ARRAY_BINDING = 34229;
    
    public static void glBindVertexArray(final int array) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glBindVertexArray_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindVertexArray(array, function_pointer);
    }
    
    private static native void nglBindVertexArray(final int p0, final long p1);
    
    public static void glDeleteVertexArrays(final IntBuffer arrays) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glDeleteVertexArrays_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(arrays);
        nglDeleteVertexArrays(arrays.remaining(), arrays, arrays.position(), function_pointer);
    }
    
    private static native void nglDeleteVertexArrays(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteVertexArrays(final int array) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glDeleteVertexArrays_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteVertexArrays(1, APIUtils.getBufferInt().put(0, array), 0, function_pointer);
    }
    
    public static void glGenVertexArrays(final IntBuffer arrays) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glGenVertexArrays_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(arrays);
        nglGenVertexArrays(arrays.remaining(), arrays, arrays.position(), function_pointer);
    }
    
    private static native void nglGenVertexArrays(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenVertexArrays() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glGenVertexArrays_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer arrays = APIUtils.getBufferInt();
        nglGenVertexArrays(1, arrays, arrays.position(), function_pointer);
        return arrays.get(0);
    }
    
    public static boolean glIsVertexArray(final int array) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_array_object_glIsVertexArray_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsVertexArray(array, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsVertexArray(final int p0, final long p1);
}
