package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBVertexBlend
{
    public static final int GL_MAX_VERTEX_UNITS_ARB = 34468;
    public static final int GL_ACTIVE_VERTEX_UNITS_ARB = 34469;
    public static final int GL_WEIGHT_SUM_UNITY_ARB = 34470;
    public static final int GL_VERTEX_BLEND_ARB = 34471;
    public static final int GL_CURRENT_WEIGHT_ARB = 34472;
    public static final int GL_WEIGHT_ARRAY_TYPE_ARB = 34473;
    public static final int GL_WEIGHT_ARRAY_STRIDE_ARB = 34474;
    public static final int GL_WEIGHT_ARRAY_SIZE_ARB = 34475;
    public static final int GL_WEIGHT_ARRAY_POINTER_ARB = 34476;
    public static final int GL_WEIGHT_ARRAY_ARB = 34477;
    public static final int GL_MODELVIEW0_ARB = 5888;
    public static final int GL_MODELVIEW1_ARB = 34058;
    public static final int GL_MODELVIEW2_ARB = 34594;
    public static final int GL_MODELVIEW3_ARB = 34595;
    public static final int GL_MODELVIEW4_ARB = 34596;
    public static final int GL_MODELVIEW5_ARB = 34597;
    public static final int GL_MODELVIEW6_ARB = 34598;
    public static final int GL_MODELVIEW7_ARB = 34599;
    public static final int GL_MODELVIEW8_ARB = 34600;
    public static final int GL_MODELVIEW9_ARB = 34601;
    public static final int GL_MODELVIEW10_ARB = 34602;
    public static final int GL_MODELVIEW11_ARB = 34603;
    public static final int GL_MODELVIEW12_ARB = 34604;
    public static final int GL_MODELVIEW13_ARB = 34605;
    public static final int GL_MODELVIEW14_ARB = 34606;
    public static final int GL_MODELVIEW15_ARB = 34607;
    public static final int GL_MODELVIEW16_ARB = 34608;
    public static final int GL_MODELVIEW17_ARB = 34609;
    public static final int GL_MODELVIEW18_ARB = 34610;
    public static final int GL_MODELVIEW19_ARB = 34611;
    public static final int GL_MODELVIEW20_ARB = 34612;
    public static final int GL_MODELVIEW21_ARB = 34613;
    public static final int GL_MODELVIEW22_ARB = 34614;
    public static final int GL_MODELVIEW23_ARB = 34615;
    public static final int GL_MODELVIEW24_ARB = 34616;
    public static final int GL_MODELVIEW25_ARB = 34617;
    public static final int GL_MODELVIEW26_ARB = 34618;
    public static final int GL_MODELVIEW27_ARB = 34619;
    public static final int GL_MODELVIEW28_ARB = 34620;
    public static final int GL_MODELVIEW29_ARB = 34621;
    public static final int GL_MODELVIEW30_ARB = 34622;
    public static final int GL_MODELVIEW31_ARB = 34623;
    
    public static void glWeightARB(final ByteBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightbvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightbvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightbvARB(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static void glWeightARB(final ShortBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightsvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightsvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightsvARB(final int p0, final ShortBuffer p1, final int p2, final long p3);
    
    public static void glWeightARB(final IntBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightivARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightivARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glWeightARB(final FloatBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightfvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightfvARB(final int p0, final FloatBuffer p1, final int p2, final long p3);
    
    public static void glWeightARB(final DoubleBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightdvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightdvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightdvARB(final int p0, final DoubleBuffer p1, final int p2, final long p3);
    
    public static void glWeightuARB(final ByteBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightubvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightubvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightubvARB(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static void glWeightuARB(final ShortBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightusvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightusvARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightusvARB(final int p0, final ShortBuffer p1, final int p2, final long p3);
    
    public static void glWeightuARB(final IntBuffer pWeights) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightuivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pWeights);
        nglWeightuivARB(pWeights.remaining(), pWeights, pWeights.position(), function_pointer);
    }
    
    private static native void nglWeightuivARB(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glWeightPointerARB(final int size, final int stride, final DoubleBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        nglWeightPointerARB(size, 5130, stride, GLChecks.getReferences(caps).ARB_vertex_blend_glWeightPointerARB_pPointer = pPointer, pPointer.position() << 3, function_pointer);
    }
    
    public static void glWeightPointerARB(final int size, final int stride, final FloatBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        nglWeightPointerARB(size, 5126, stride, GLChecks.getReferences(caps).ARB_vertex_blend_glWeightPointerARB_pPointer = pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glWeightPointerARB(final int size, final boolean unsigned, final int stride, final ByteBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        GLChecks.getReferences(caps).ARB_vertex_blend_glWeightPointerARB_pPointer = pPointer;
        nglWeightPointerARB(size, unsigned ? 5121 : 5120, stride, pPointer, pPointer.position(), function_pointer);
    }
    
    public static void glWeightPointerARB(final int size, final boolean unsigned, final int stride, final IntBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        GLChecks.getReferences(caps).ARB_vertex_blend_glWeightPointerARB_pPointer = pPointer;
        nglWeightPointerARB(size, unsigned ? 5125 : 5124, stride, pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glWeightPointerARB(final int size, final boolean unsigned, final int stride, final ShortBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(pPointer);
        GLChecks.getReferences(caps).ARB_vertex_blend_glWeightPointerARB_pPointer = pPointer;
        nglWeightPointerARB(size, unsigned ? 5123 : 5122, stride, pPointer, pPointer.position() << 1, function_pointer);
    }
    
    private static native void nglWeightPointerARB(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final long p5);
    
    public static void glWeightPointerARB(final int size, final int type, final int stride, final long pPointer_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glWeightPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOenabled(caps);
        nglWeightPointerARBBO(size, type, stride, pPointer_buffer_offset, function_pointer);
    }
    
    private static native void nglWeightPointerARBBO(final int p0, final int p1, final int p2, final long p3, final long p4);
    
    public static void glVertexBlendARB(final int count) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_blend_glVertexBlendARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexBlendARB(count, function_pointer);
    }
    
    private static native void nglVertexBlendARB(final int p0, final long p1);
}
