package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ARBVertexProgram extends ARBProgram
{
    public static final int GL_VERTEX_PROGRAM_ARB = 34336;
    public static final int GL_VERTEX_PROGRAM_POINT_SIZE_ARB = 34370;
    public static final int GL_VERTEX_PROGRAM_TWO_SIDE_ARB = 34371;
    public static final int GL_COLOR_SUM_ARB = 33880;
    public static final int GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB = 34338;
    public static final int GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB = 34339;
    public static final int GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB = 34340;
    public static final int GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB = 34341;
    public static final int GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB = 34922;
    public static final int GL_CURRENT_VERTEX_ATTRIB_ARB = 34342;
    public static final int GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB = 34373;
    public static final int GL_PROGRAM_ADDRESS_REGISTERS_ARB = 34992;
    public static final int GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB = 34993;
    public static final int GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = 34994;
    public static final int GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = 34995;
    public static final int GL_MAX_VERTEX_ATTRIBS_ARB = 34921;
    
    public static void glVertexAttrib1sARB(final int index, final short x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib1sARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib1sARB(index, x, function_pointer);
    }
    
    private static native void nglVertexAttrib1sARB(final int p0, final short p1, final long p2);
    
    public static void glVertexAttrib1fARB(final int index, final float x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib1fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib1fARB(index, x, function_pointer);
    }
    
    private static native void nglVertexAttrib1fARB(final int p0, final float p1, final long p2);
    
    public static void glVertexAttrib1dARB(final int index, final double x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib1dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib1dARB(index, x, function_pointer);
    }
    
    private static native void nglVertexAttrib1dARB(final int p0, final double p1, final long p2);
    
    public static void glVertexAttrib2sARB(final int index, final short x, final short y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib2sARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib2sARB(index, x, y, function_pointer);
    }
    
    private static native void nglVertexAttrib2sARB(final int p0, final short p1, final short p2, final long p3);
    
    public static void glVertexAttrib2fARB(final int index, final float x, final float y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib2fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib2fARB(index, x, y, function_pointer);
    }
    
    private static native void nglVertexAttrib2fARB(final int p0, final float p1, final float p2, final long p3);
    
    public static void glVertexAttrib2dARB(final int index, final double x, final double y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib2dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib2dARB(index, x, y, function_pointer);
    }
    
    private static native void nglVertexAttrib2dARB(final int p0, final double p1, final double p2, final long p3);
    
    public static void glVertexAttrib3sARB(final int index, final short x, final short y, final short z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib3sARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib3sARB(index, x, y, z, function_pointer);
    }
    
    private static native void nglVertexAttrib3sARB(final int p0, final short p1, final short p2, final short p3, final long p4);
    
    public static void glVertexAttrib3fARB(final int index, final float x, final float y, final float z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib3fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib3fARB(index, x, y, z, function_pointer);
    }
    
    private static native void nglVertexAttrib3fARB(final int p0, final float p1, final float p2, final float p3, final long p4);
    
    public static void glVertexAttrib3dARB(final int index, final double x, final double y, final double z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib3dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib3dARB(index, x, y, z, function_pointer);
    }
    
    private static native void nglVertexAttrib3dARB(final int p0, final double p1, final double p2, final double p3, final long p4);
    
    public static void glVertexAttrib4sARB(final int index, final short x, final short y, final short z, final short w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib4sARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib4sARB(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttrib4sARB(final int p0, final short p1, final short p2, final short p3, final short p4, final long p5);
    
    public static void glVertexAttrib4fARB(final int index, final float x, final float y, final float z, final float w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib4fARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib4fARB(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttrib4fARB(final int p0, final float p1, final float p2, final float p3, final float p4, final long p5);
    
    public static void glVertexAttrib4dARB(final int index, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib4dARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib4dARB(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttrib4dARB(final int p0, final double p1, final double p2, final double p3, final double p4, final long p5);
    
    public static void glVertexAttrib4NubARB(final int index, final byte x, final byte y, final byte z, final byte w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttrib4NubARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttrib4NubARB(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttrib4NubARB(final int p0, final byte p1, final byte p2, final byte p3, final byte p4, final long p5);
    
    public static void glVertexAttribPointerARB(final int index, final int size, final boolean normalized, final int stride, final DoubleBuffer buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(buffer);
        nglVertexAttribPointerARB(index, size, 5130, normalized, stride, GLChecks.getReferences(caps).glVertexAttribPointer_buffer[index] = buffer, buffer.position() << 3, function_pointer);
    }
    
    public static void glVertexAttribPointerARB(final int index, final int size, final boolean normalized, final int stride, final FloatBuffer buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(buffer);
        nglVertexAttribPointerARB(index, size, 5126, normalized, stride, GLChecks.getReferences(caps).glVertexAttribPointer_buffer[index] = buffer, buffer.position() << 2, function_pointer);
    }
    
    public static void glVertexAttribPointerARB(final int index, final int size, final boolean unsigned, final boolean normalized, final int stride, final ByteBuffer buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(buffer);
        GLChecks.getReferences(caps).glVertexAttribPointer_buffer[index] = buffer;
        nglVertexAttribPointerARB(index, size, unsigned ? 5121 : 5120, normalized, stride, buffer, buffer.position(), function_pointer);
    }
    
    public static void glVertexAttribPointerARB(final int index, final int size, final boolean unsigned, final boolean normalized, final int stride, final IntBuffer buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(buffer);
        GLChecks.getReferences(caps).glVertexAttribPointer_buffer[index] = buffer;
        nglVertexAttribPointerARB(index, size, unsigned ? 5125 : 5124, normalized, stride, buffer, buffer.position() << 2, function_pointer);
    }
    
    public static void glVertexAttribPointerARB(final int index, final int size, final boolean unsigned, final boolean normalized, final int stride, final ShortBuffer buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(buffer);
        GLChecks.getReferences(caps).glVertexAttribPointer_buffer[index] = buffer;
        nglVertexAttribPointerARB(index, size, unsigned ? 5123 : 5122, normalized, stride, buffer, buffer.position() << 1, function_pointer);
    }
    
    private static native void nglVertexAttribPointerARB(final int p0, final int p1, final int p2, final boolean p3, final int p4, final Buffer p5, final int p6, final long p7);
    
    public static void glVertexAttribPointerARB(final int index, final int size, final int type, final boolean normalized, final int stride, final long buffer_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glVertexAttribPointerARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOenabled(caps);
        nglVertexAttribPointerARBBO(index, size, type, normalized, stride, buffer_buffer_offset, function_pointer);
    }
    
    private static native void nglVertexAttribPointerARBBO(final int p0, final int p1, final int p2, final boolean p3, final int p4, final long p5, final long p6);
    
    public static void glEnableVertexAttribArrayARB(final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glEnableVertexAttribArrayARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEnableVertexAttribArrayARB(index, function_pointer);
    }
    
    private static native void nglEnableVertexAttribArrayARB(final int p0, final long p1);
    
    public static void glDisableVertexAttribArrayARB(final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glDisableVertexAttribArrayARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDisableVertexAttribArrayARB(index, function_pointer);
    }
    
    private static native void nglDisableVertexAttribArrayARB(final int p0, final long p1);
    
    public static void glGetVertexAttribARB(final int index, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glGetVertexAttribfvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVertexAttribfvARB(index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVertexAttribfvARB(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetVertexAttribARB(final int index, final int pname, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glGetVertexAttribdvARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVertexAttribdvARB(index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVertexAttribdvARB(final int p0, final int p1, final DoubleBuffer p2, final int p3, final long p4);
    
    public static void glGetVertexAttribARB(final int index, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glGetVertexAttribivARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVertexAttribivARB(index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVertexAttribivARB(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static ByteBuffer glGetVertexAttribPointerARB(final int index, final int pname, final long result_size) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ARB_vertex_program_glGetVertexAttribPointervARB_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final ByteBuffer __result = nglGetVertexAttribPointervARB(index, pname, result_size, function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglGetVertexAttribPointervARB(final int p0, final int p1, final long p2, final long p3);
}
