package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ATIElementArray
{
    public static final int GL_ELEMENT_ARRAY_ATI = 34664;
    public static final int GL_ELEMENT_ARRAY_TYPE_ATI = 34665;
    public static final int GL_ELEMENT_ARRAY_POINTER_ATI = 34666;
    
    public static void glElementPointerATI(final ByteBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_element_array_glElementPointerATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglElementPointerATI(5121, pPointer, pPointer.position(), function_pointer);
    }
    
    public static void glElementPointerATI(final IntBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_element_array_glElementPointerATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglElementPointerATI(5125, pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glElementPointerATI(final ShortBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_element_array_glElementPointerATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglElementPointerATI(5123, pPointer, pPointer.position() << 1, function_pointer);
    }
    
    private static native void nglElementPointerATI(final int p0, final Buffer p1, final int p2, final long p3);
    
    public static void glDrawElementArrayATI(final int mode, final int count) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_element_array_glDrawElementArrayATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawElementArrayATI(mode, count, function_pointer);
    }
    
    private static native void nglDrawElementArrayATI(final int p0, final int p1, final long p2);
    
    public static void glDrawRangeElementArrayATI(final int mode, final int start, final int end, final int count) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_element_array_glDrawRangeElementArrayATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawRangeElementArrayATI(mode, start, end, count, function_pointer);
    }
    
    private static native void nglDrawRangeElementArrayATI(final int p0, final int p1, final int p2, final int p3, final long p4);
}
