package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ATIEnvmapBumpmap
{
    public static final int GL_BUMP_ROT_MATRIX_ATI = 34677;
    public static final int GL_BUMP_ROT_MATRIX_SIZE_ATI = 34678;
    public static final int GL_BUMP_NUM_TEX_UNITS_ATI = 34679;
    public static final int GL_BUMP_TEX_UNITS_ATI = 34680;
    public static final int GL_DUDV_ATI = 34681;
    public static final int GL_DU8DV8_ATI = 34682;
    public static final int GL_BUMP_ENVMAP_ATI = 34683;
    public static final int GL_BUMP_TARGET_ATI = 34684;
    
    public static void glTexBumpParameterATI(final int pname, final FloatBuffer param) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_envmap_bumpmap_glTexBumpParameterfvATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(param, 4);
        nglTexBumpParameterfvATI(pname, param, param.position(), function_pointer);
    }
    
    private static native void nglTexBumpParameterfvATI(final int p0, final FloatBuffer p1, final int p2, final long p3);
    
    public static void glTexBumpParameterATI(final int pname, final IntBuffer param) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_envmap_bumpmap_glTexBumpParameterivATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(param, 4);
        nglTexBumpParameterivATI(pname, param, param.position(), function_pointer);
    }
    
    private static native void nglTexBumpParameterivATI(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glGetTexBumpParameterATI(final int pname, final FloatBuffer param) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_envmap_bumpmap_glGetTexBumpParameterfvATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(param, 4);
        nglGetTexBumpParameterfvATI(pname, param, param.position(), function_pointer);
    }
    
    private static native void nglGetTexBumpParameterfvATI(final int p0, final FloatBuffer p1, final int p2, final long p3);
    
    public static void glGetTexBumpParameterATI(final int pname, final IntBuffer param) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_envmap_bumpmap_glGetTexBumpParameterivATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(param, 4);
        nglGetTexBumpParameterivATI(pname, param, param.position(), function_pointer);
    }
    
    private static native void nglGetTexBumpParameterivATI(final int p0, final IntBuffer p1, final int p2, final long p3);
}
