package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class ATIMapObjectBuffer
{
    public static ByteBuffer glMapObjectBufferATI(final int buffer, final ByteBuffer old_buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_map_object_buffer_glMapObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (old_buffer != null) {
            BufferChecks.checkDirect(old_buffer);
        }
        final ByteBuffer __result = nglMapObjectBufferATI(buffer, GLChecks.getBufferObjectSizeATI(caps, buffer), old_buffer, function_pointer);
        return __result;
    }
    
    public static ByteBuffer glMapObjectBufferATI(final int buffer, final long length, final ByteBuffer old_buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_map_object_buffer_glMapObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (old_buffer != null) {
            BufferChecks.checkDirect(old_buffer);
        }
        final ByteBuffer __result = nglMapObjectBufferATI(buffer, length, old_buffer, function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglMapObjectBufferATI(final int p0, final long p1, final ByteBuffer p2, final long p3);
    
    public static void glUnmapObjectBufferATI(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_map_object_buffer_glUnmapObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUnmapObjectBufferATI(buffer, function_pointer);
    }
    
    private static native void nglUnmapObjectBufferATI(final int p0, final long p1);
}
