package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class ATIVertexArrayObject
{
    public static final int GL_STATIC_ATI = 34656;
    public static final int GL_DYNAMIC_ATI = 34657;
    public static final int GL_PRESERVE_ATI = 34658;
    public static final int GL_DISCARD_ATI = 34659;
    public static final int GL_OBJECT_BUFFER_SIZE_ATI = 34660;
    public static final int GL_OBJECT_BUFFER_USAGE_ATI = 34661;
    public static final int GL_ARRAY_OBJECT_BUFFER_ATI = 34662;
    public static final int GL_ARRAY_OBJECT_OFFSET_ATI = 34663;
    
    public static int glNewObjectBufferATI(final int size, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglNewObjectBufferATI(size, null, 0, usage, function_pointer);
        return __result;
    }
    
    public static int glNewObjectBufferATI(final ByteBuffer pPointer, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        final int __result = nglNewObjectBufferATI(pPointer.remaining(), pPointer, pPointer.position(), usage, function_pointer);
        return __result;
    }
    
    public static int glNewObjectBufferATI(final DoubleBuffer pPointer, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        final int __result = nglNewObjectBufferATI(pPointer.remaining() << 3, pPointer, pPointer.position() << 3, usage, function_pointer);
        return __result;
    }
    
    public static int glNewObjectBufferATI(final FloatBuffer pPointer, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        final int __result = nglNewObjectBufferATI(pPointer.remaining() << 2, pPointer, pPointer.position() << 2, usage, function_pointer);
        return __result;
    }
    
    public static int glNewObjectBufferATI(final IntBuffer pPointer, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        final int __result = nglNewObjectBufferATI(pPointer.remaining() << 2, pPointer, pPointer.position() << 2, usage, function_pointer);
        return __result;
    }
    
    public static int glNewObjectBufferATI(final ShortBuffer pPointer, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glNewObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        final int __result = nglNewObjectBufferATI(pPointer.remaining() << 1, pPointer, pPointer.position() << 1, usage, function_pointer);
        return __result;
    }
    
    private static native int nglNewObjectBufferATI(final int p0, final Buffer p1, final int p2, final int p3, final long p4);
    
    public static boolean glIsObjectBufferATI(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glIsObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsObjectBufferATI(buffer, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsObjectBufferATI(final int p0, final long p1);
    
    public static void glUpdateObjectBufferATI(final int buffer, final int offset, final ByteBuffer pPointer, final int preserve) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glUpdateObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglUpdateObjectBufferATI(buffer, offset, pPointer.remaining(), pPointer, pPointer.position(), preserve, function_pointer);
    }
    
    public static void glUpdateObjectBufferATI(final int buffer, final int offset, final DoubleBuffer pPointer, final int preserve) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glUpdateObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglUpdateObjectBufferATI(buffer, offset, pPointer.remaining() << 3, pPointer, pPointer.position() << 3, preserve, function_pointer);
    }
    
    public static void glUpdateObjectBufferATI(final int buffer, final int offset, final FloatBuffer pPointer, final int preserve) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glUpdateObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglUpdateObjectBufferATI(buffer, offset, pPointer.remaining() << 2, pPointer, pPointer.position() << 2, preserve, function_pointer);
    }
    
    public static void glUpdateObjectBufferATI(final int buffer, final int offset, final IntBuffer pPointer, final int preserve) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glUpdateObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglUpdateObjectBufferATI(buffer, offset, pPointer.remaining() << 2, pPointer, pPointer.position() << 2, preserve, function_pointer);
    }
    
    public static void glUpdateObjectBufferATI(final int buffer, final int offset, final ShortBuffer pPointer, final int preserve) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glUpdateObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglUpdateObjectBufferATI(buffer, offset, pPointer.remaining() << 1, pPointer, pPointer.position() << 1, preserve, function_pointer);
    }
    
    private static native void nglUpdateObjectBufferATI(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final int p5, final long p6);
    
    public static void glGetObjectBufferATI(final int buffer, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetObjectBufferfvATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetObjectBufferfvATI(buffer, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetObjectBufferfvATI(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetObjectBufferATI(final int buffer, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetObjectBufferivATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetObjectBufferivATI(buffer, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetObjectBufferivATI(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glFreeObjectBufferATI(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glFreeObjectBufferATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFreeObjectBufferATI(buffer, function_pointer);
    }
    
    private static native void nglFreeObjectBufferATI(final int p0, final long p1);
    
    public static void glArrayObjectATI(final int array, final int size, final int type, final int stride, final int buffer, final int offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glArrayObjectATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglArrayObjectATI(array, size, type, stride, buffer, offset, function_pointer);
    }
    
    private static native void nglArrayObjectATI(final int p0, final int p1, final int p2, final int p3, final int p4, final int p5, final long p6);
    
    public static void glGetArrayObjectATI(final int array, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetArrayObjectfvATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetArrayObjectfvATI(array, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetArrayObjectfvATI(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetArrayObjectATI(final int array, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetArrayObjectivATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetArrayObjectivATI(array, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetArrayObjectivATI(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static void glVariantArrayObjectATI(final int id, final int type, final int stride, final int buffer, final int offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glVariantArrayObjectATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVariantArrayObjectATI(id, type, stride, buffer, offset, function_pointer);
    }
    
    private static native void nglVariantArrayObjectATI(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5);
    
    public static void glGetVariantArrayObjectATI(final int id, final int pname, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetVariantArrayObjectfvATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVariantArrayObjectfvATI(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVariantArrayObjectfvATI(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glGetVariantArrayObjectATI(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.ATI_vertex_array_object_glGetVariantArrayObjectivATI_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVariantArrayObjectivATI(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVariantArrayObjectivATI(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
}
