package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class EXTDrawBuffers2
{
    public static void glColorMaskIndexedEXT(final int buf, final boolean r, final boolean g, final boolean b, final boolean a) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glColorMaskIndexedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglColorMaskIndexedEXT(buf, r, g, b, a, function_pointer);
    }
    
    private static native void nglColorMaskIndexedEXT(final int p0, final boolean p1, final boolean p2, final boolean p3, final boolean p4, final long p5);
    
    public static void glGetBooleanIndexedEXT(final int value, final int index, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glGetBooleanIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 4);
        nglGetBooleanIndexedvEXT(value, index, data, data.position(), function_pointer);
    }
    
    private static native void nglGetBooleanIndexedvEXT(final int p0, final int p1, final ByteBuffer p2, final int p3, final long p4);
    
    public static boolean glGetBooleanIndexedEXT(final int value, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glGetBooleanIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final ByteBuffer data = APIUtils.getBufferByte(1);
        nglGetBooleanIndexedvEXT(value, index, data, data.position(), function_pointer);
        return data.get(0) == 1;
    }
    
    public static void glGetIntegerIndexedEXT(final int value, final int index, final IntBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glGetIntegerIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 4);
        nglGetIntegerIndexedvEXT(value, index, data, data.position(), function_pointer);
    }
    
    private static native void nglGetIntegerIndexedvEXT(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetIntegerIndexedEXT(final int value, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glGetIntegerIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer data = APIUtils.getBufferInt();
        nglGetIntegerIndexedvEXT(value, index, data, data.position(), function_pointer);
        return data.get(0);
    }
    
    public static void glEnableIndexedEXT(final int target, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glEnableIndexedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEnableIndexedEXT(target, index, function_pointer);
    }
    
    private static native void nglEnableIndexedEXT(final int p0, final int p1, final long p2);
    
    public static void glDisableIndexedEXT(final int target, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glDisableIndexedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDisableIndexedEXT(target, index, function_pointer);
    }
    
    private static native void nglDisableIndexedEXT(final int p0, final int p1, final long p2);
    
    public static boolean glIsEnabledIndexedEXT(final int target, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_buffers2_glIsEnabledIndexedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsEnabledIndexedEXT(target, index, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsEnabledIndexedEXT(final int p0, final int p1, final long p2);
}
