package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class EXTDrawInstanced
{
    public static void glDrawArraysInstancedEXT(final int mode, final int first, final int count, final int primcount) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_instanced_glDrawArraysInstancedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawArraysInstancedEXT(mode, first, count, primcount, function_pointer);
    }
    
    private static native void nglDrawArraysInstancedEXT(final int p0, final int p1, final int p2, final int p3, final long p4);
    
    public static void glDrawElementsInstancedEXT(final int mode, final ByteBuffer indices, final int primcount) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_instanced_glDrawElementsInstancedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedEXT(mode, indices.remaining(), 5121, indices, indices.position(), primcount, function_pointer);
    }
    
    public static void glDrawElementsInstancedEXT(final int mode, final IntBuffer indices, final int primcount) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_instanced_glDrawElementsInstancedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedEXT(mode, indices.remaining(), 5125, indices, indices.position() << 2, primcount, function_pointer);
    }
    
    public static void glDrawElementsInstancedEXT(final int mode, final ShortBuffer indices, final int primcount) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_instanced_glDrawElementsInstancedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(indices);
        nglDrawElementsInstancedEXT(mode, indices.remaining(), 5123, indices, indices.position() << 1, primcount, function_pointer);
    }
    
    private static native void nglDrawElementsInstancedEXT(final int p0, final int p1, final int p2, final Buffer p3, final int p4, final int p5, final long p6);
    
    public static void glDrawElementsInstancedEXT(final int mode, final int count, final int type, final long indices_buffer_offset, final int primcount) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_instanced_glDrawElementsInstancedEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOenabled(caps);
        nglDrawElementsInstancedEXTBO(mode, count, type, indices_buffer_offset, primcount, function_pointer);
    }
    
    private static native void nglDrawElementsInstancedEXTBO(final int p0, final int p1, final int p2, final long p3, final int p4, final long p5);
}
