package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class EXTDrawRangeElements
{
    public static final int GL_MAX_ELEMENTS_VERTICES_EXT = 33000;
    public static final int GL_MAX_ELEMENTS_INDICES_EXT = 33001;
    
    public static void glDrawRangeElementsEXT(final int mode, final int start, final int end, final ByteBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_range_elements_glDrawRangeElementsEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(pIndices);
        nglDrawRangeElementsEXT(mode, start, end, pIndices.remaining(), 5121, pIndices, pIndices.position(), function_pointer);
    }
    
    public static void glDrawRangeElementsEXT(final int mode, final int start, final int end, final IntBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_range_elements_glDrawRangeElementsEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(pIndices);
        nglDrawRangeElementsEXT(mode, start, end, pIndices.remaining(), 5125, pIndices, pIndices.position() << 2, function_pointer);
    }
    
    public static void glDrawRangeElementsEXT(final int mode, final int start, final int end, final ShortBuffer pIndices) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_range_elements_glDrawRangeElementsEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOdisabled(caps);
        BufferChecks.checkDirect(pIndices);
        nglDrawRangeElementsEXT(mode, start, end, pIndices.remaining(), 5123, pIndices, pIndices.position() << 1, function_pointer);
    }
    
    private static native void nglDrawRangeElementsEXT(final int p0, final int p1, final int p2, final int p3, final int p4, final Buffer p5, final int p6, final long p7);
    
    public static void glDrawRangeElementsEXT(final int mode, final int start, final int end, final int count, final int type, final long pIndices_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_draw_range_elements_glDrawRangeElementsEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureElementVBOenabled(caps);
        nglDrawRangeElementsEXTBO(mode, start, end, count, type, pIndices_buffer_offset, function_pointer);
    }
    
    private static native void nglDrawRangeElementsEXTBO(final int p0, final int p1, final int p2, final int p3, final int p4, final long p5, final long p6);
}
