package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class EXTFogCoord
{
    public static final int GL_FOG_COORDINATE_SOURCE_EXT = 33872;
    public static final int GL_FOG_COORDINATE_EXT = 33873;
    public static final int GL_FRAGMENT_DEPTH_EXT = 33874;
    public static final int GL_CURRENT_FOG_COORDINATE_EXT = 33875;
    public static final int GL_FOG_COORDINATE_ARRAY_TYPE_EXT = 33876;
    public static final int GL_FOG_COORDINATE_ARRAY_STRIDE_EXT = 33877;
    public static final int GL_FOG_COORDINATE_ARRAY_POINTER_EXT = 33878;
    public static final int GL_FOG_COORDINATE_ARRAY_EXT = 33879;
    
    public static void glFogCoordfEXT(final float coord) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_fog_coord_glFogCoordfEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFogCoordfEXT(coord, function_pointer);
    }
    
    private static native void nglFogCoordfEXT(final float p0, final long p1);
    
    public static void glFogCoorddEXT(final double coord) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_fog_coord_glFogCoorddEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFogCoorddEXT(coord, function_pointer);
    }
    
    private static native void nglFogCoorddEXT(final double p0, final long p1);
    
    public static void glFogCoordPointerEXT(final int stride, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_fog_coord_glFogCoordPointerEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(data);
        nglFogCoordPointerEXT(5130, stride, GLChecks.getReferences(caps).EXT_fog_coord_glFogCoordPointerEXT_data = data, data.position() << 3, function_pointer);
    }
    
    public static void glFogCoordPointerEXT(final int stride, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_fog_coord_glFogCoordPointerEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOdisabled(caps);
        BufferChecks.checkDirect(data);
        nglFogCoordPointerEXT(5126, stride, GLChecks.getReferences(caps).EXT_fog_coord_glFogCoordPointerEXT_data = data, data.position() << 2, function_pointer);
    }
    
    private static native void nglFogCoordPointerEXT(final int p0, final int p1, final Buffer p2, final int p3, final long p4);
    
    public static void glFogCoordPointerEXT(final int type, final int stride, final long data_buffer_offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_fog_coord_glFogCoordPointerEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        GLChecks.ensureArrayVBOenabled(caps);
        nglFogCoordPointerEXTBO(type, stride, data_buffer_offset, function_pointer);
    }
    
    private static native void nglFogCoordPointerEXTBO(final int p0, final int p1, final long p2, final long p3);
}
