package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class EXTGpuProgramParameters
{
    public static void glProgramEnvParameters4EXT(final int target, final int index, final int count, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_gpu_program_parameters_glProgramEnvParameters4fvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, count << 2);
        nglProgramEnvParameters4fvEXT(target, index, count, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramEnvParameters4fvEXT(final int p0, final int p1, final int p2, final FloatBuffer p3, final int p4, final long p5);
    
    public static void glProgramLocalParameters4EXT(final int target, final int index, final int count, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_gpu_program_parameters_glProgramLocalParameters4fvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, count << 2);
        nglProgramLocalParameters4fvEXT(target, index, count, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramLocalParameters4fvEXT(final int p0, final int p1, final int p2, final FloatBuffer p3, final int p4, final long p5);
}
