package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class EXTSeparateShaderObjects
{
    public static final int GL_ACTIVE_PROGRAM_EXT = 35725;
    
    public static void glUseShaderProgramEXT(final int type, final int program) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_separate_shader_objects_glUseShaderProgramEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUseShaderProgramEXT(type, program, function_pointer);
    }
    
    private static native void nglUseShaderProgramEXT(final int p0, final int p1, final long p2);
    
    public static void glActiveProgramEXT(final int program) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_separate_shader_objects_glActiveProgramEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglActiveProgramEXT(program, function_pointer);
    }
    
    private static native void nglActiveProgramEXT(final int p0, final long p1);
    
    public static int glCreateShaderProgramEXT(final int type, final ByteBuffer string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_separate_shader_objects_glCreateShaderProgramEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(string);
        BufferChecks.checkNullTerminated(string);
        final int __result = nglCreateShaderProgramEXT(type, string, string.position(), function_pointer);
        return __result;
    }
    
    private static native int nglCreateShaderProgramEXT(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static int glCreateShaderProgramEXT(final int type, final CharSequence string) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_separate_shader_objects_glCreateShaderProgramEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglCreateShaderProgramEXT(type, APIUtils.getBufferNT(string), 0, function_pointer);
        return __result;
    }
}
