package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class EXTTimerQuery
{
    public static final int GL_TIME_ELAPSED_EXT = 35007;
    
    public static void glGetQueryObjectEXT(final int id, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_timer_query_glGetQueryObjecti64vEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjecti64vEXT(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjecti64vEXT(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetQueryObjectEXT(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_timer_query_glGetQueryObjecti64vEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetQueryObjecti64vEXT(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObjectuEXT(final int id, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_timer_query_glGetQueryObjectui64vEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectui64vEXT(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectui64vEXT(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetQueryObjectuEXT(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.EXT_timer_query_glGetQueryObjectui64vEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetQueryObjectui64vEXT(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
