package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class GL15
{
    public static final int GL_ARRAY_BUFFER = 34962;
    public static final int GL_ELEMENT_ARRAY_BUFFER = 34963;
    public static final int GL_ARRAY_BUFFER_BINDING = 34964;
    public static final int GL_ELEMENT_ARRAY_BUFFER_BINDING = 34965;
    public static final int GL_VERTEX_ARRAY_BUFFER_BINDING = 34966;
    public static final int GL_NORMAL_ARRAY_BUFFER_BINDING = 34967;
    public static final int GL_COLOR_ARRAY_BUFFER_BINDING = 34968;
    public static final int GL_INDEX_ARRAY_BUFFER_BINDING = 34969;
    public static final int GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING = 34970;
    public static final int GL_EDGE_FLAG_ARRAY_BUFFER_BINDING = 34971;
    public static final int GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING = 34972;
    public static final int GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING = 34973;
    public static final int GL_WEIGHT_ARRAY_BUFFER_BINDING = 34974;
    public static final int GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING = 34975;
    public static final int GL_STREAM_DRAW = 35040;
    public static final int GL_STREAM_READ = 35041;
    public static final int GL_STREAM_COPY = 35042;
    public static final int GL_STATIC_DRAW = 35044;
    public static final int GL_STATIC_READ = 35045;
    public static final int GL_STATIC_COPY = 35046;
    public static final int GL_DYNAMIC_DRAW = 35048;
    public static final int GL_DYNAMIC_READ = 35049;
    public static final int GL_DYNAMIC_COPY = 35050;
    public static final int GL_READ_ONLY = 35000;
    public static final int GL_WRITE_ONLY = 35001;
    public static final int GL_READ_WRITE = 35002;
    public static final int GL_BUFFER_SIZE = 34660;
    public static final int GL_BUFFER_USAGE = 34661;
    public static final int GL_BUFFER_ACCESS = 35003;
    public static final int GL_BUFFER_MAPPED = 35004;
    public static final int GL_BUFFER_MAP_POINTER = 35005;
    public static final int FOG_COORD_SRC = 33872;
    public static final int GL_FOG_COORD = 33873;
    public static final int GL_CURRENT_FOG_COORD = 33875;
    public static final int GL_FOG_COORD_ARRAY_TYPE = 33876;
    public static final int GL_FOG_COORD_ARRAY_STRIDE = 33877;
    public static final int GL_FOG_COORD_ARRAY_POINTER = 33878;
    public static final int GL_FOG_COORD_ARRAY = 33879;
    public static final int GL_FOG_COORD_ARRAY_BUFFER_BINDING = 34973;
    public static final int GL_SRC0_RGB = 34176;
    public static final int GL_SRC1_RGB = 34177;
    public static final int GL_SRC2_RGB = 34178;
    public static final int GL_SRC0_ALPHA = 34184;
    public static final int GL_SRC1_ALPHA = 34185;
    public static final int GL_SRC2_ALPHA = 34186;
    public static final int GL_SAMPLES_PASSED = 35092;
    public static final int GL_QUERY_COUNTER_BITS = 34916;
    public static final int GL_CURRENT_QUERY = 34917;
    public static final int GL_QUERY_RESULT = 34918;
    public static final int GL_QUERY_RESULT_AVAILABLE = 34919;
    
    public static void glBindBuffer(final int target, final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBindBuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        StateTracker.bindBuffer(caps, target, buffer);
        nglBindBuffer(target, buffer, function_pointer);
    }
    
    private static native void nglBindBuffer(final int p0, final int p1, final long p2);
    
    public static void glDeleteBuffers(final IntBuffer buffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glDeleteBuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(buffers);
        nglDeleteBuffers(buffers.remaining(), buffers, buffers.position(), function_pointer);
    }
    
    private static native void nglDeleteBuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteBuffers(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glDeleteBuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteBuffers(1, APIUtils.getBufferInt().put(0, buffer), 0, function_pointer);
    }
    
    public static void glGenBuffers(final IntBuffer buffers) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGenBuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(buffers);
        nglGenBuffers(buffers.remaining(), buffers, buffers.position(), function_pointer);
    }
    
    private static native void nglGenBuffers(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenBuffers() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGenBuffers_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer buffers = APIUtils.getBufferInt();
        nglGenBuffers(1, buffers, buffers.position(), function_pointer);
        return buffers.get(0);
    }
    
    public static boolean glIsBuffer(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glIsBuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsBuffer(buffer, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsBuffer(final int p0, final long p1);
    
    public static void glBufferData(final int target, final long size, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBufferData(target, size, null, 0, usage, function_pointer);
    }
    
    public static void glBufferData(final int target, final ByteBuffer data, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferData(target, data.remaining(), data, data.position(), usage, function_pointer);
    }
    
    public static void glBufferData(final int target, final DoubleBuffer data, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferData(target, data.remaining() << 3, data, data.position() << 3, usage, function_pointer);
    }
    
    public static void glBufferData(final int target, final FloatBuffer data, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferData(target, data.remaining() << 2, data, data.position() << 2, usage, function_pointer);
    }
    
    public static void glBufferData(final int target, final IntBuffer data, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferData(target, data.remaining() << 2, data, data.position() << 2, usage, function_pointer);
    }
    
    public static void glBufferData(final int target, final ShortBuffer data, final int usage) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferData(target, data.remaining() << 1, data, data.position() << 1, usage, function_pointer);
    }
    
    private static native void nglBufferData(final int p0, final long p1, final Buffer p2, final int p3, final int p4, final long p5);
    
    public static void glBufferSubData(final int target, final long offset, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferSubData(target, offset, data.remaining(), data, data.position(), function_pointer);
    }
    
    public static void glBufferSubData(final int target, final long offset, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferSubData(target, offset, data.remaining() << 3, data, data.position() << 3, function_pointer);
    }
    
    public static void glBufferSubData(final int target, final long offset, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferSubData(target, offset, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glBufferSubData(final int target, final long offset, final IntBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferSubData(target, offset, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glBufferSubData(final int target, final long offset, final ShortBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglBufferSubData(target, offset, data.remaining() << 1, data, data.position() << 1, function_pointer);
    }
    
    private static native void nglBufferSubData(final int p0, final long p1, final long p2, final Buffer p3, final int p4, final long p5);
    
    public static void glGetBufferSubData(final int target, final long offset, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglGetBufferSubData(target, offset, data.remaining(), data, data.position(), function_pointer);
    }
    
    public static void glGetBufferSubData(final int target, final long offset, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglGetBufferSubData(target, offset, data.remaining() << 3, data, data.position() << 3, function_pointer);
    }
    
    public static void glGetBufferSubData(final int target, final long offset, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglGetBufferSubData(target, offset, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glGetBufferSubData(final int target, final long offset, final IntBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglGetBufferSubData(target, offset, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glGetBufferSubData(final int target, final long offset, final ShortBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferSubData_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglGetBufferSubData(target, offset, data.remaining() << 1, data, data.position() << 1, function_pointer);
    }
    
    private static native void nglGetBufferSubData(final int p0, final long p1, final long p2, final Buffer p3, final int p4, final long p5);
    
    public static ByteBuffer glMapBuffer(final int target, final int access, final ByteBuffer old_buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glMapBuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (old_buffer != null) {
            BufferChecks.checkDirect(old_buffer);
        }
        final ByteBuffer __result = nglMapBuffer(target, access, GLChecks.getBufferObjectSize(caps, target), old_buffer, function_pointer);
        return __result;
    }
    
    public static ByteBuffer glMapBuffer(final int target, final int access, final long length, final ByteBuffer old_buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glMapBuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (old_buffer != null) {
            BufferChecks.checkDirect(old_buffer);
        }
        final ByteBuffer __result = nglMapBuffer(target, access, length, old_buffer, function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglMapBuffer(final int p0, final int p1, final long p2, final ByteBuffer p3, final long p4);
    
    public static boolean glUnmapBuffer(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glUnmapBuffer_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglUnmapBuffer(target, function_pointer);
        return __result;
    }
    
    private static native boolean nglUnmapBuffer(final int p0, final long p1);
    
    public static void glGetBufferParameter(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetBufferParameteriv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetBufferParameteriv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetBufferParameter(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferParameteriv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetBufferParameteriv(target, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static ByteBuffer glGetBufferPointer(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetBufferPointerv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final ByteBuffer __result = nglGetBufferPointerv(target, pname, GLChecks.getBufferObjectSize(caps, target), function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglGetBufferPointerv(final int p0, final int p1, final long p2, final long p3);
    
    public static void glGenQueries(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGenQueries_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglGenQueries(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglGenQueries(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenQueries() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGenQueries_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer ids = APIUtils.getBufferInt();
        nglGenQueries(1, ids, ids.position(), function_pointer);
        return ids.get(0);
    }
    
    public static void glDeleteQueries(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glDeleteQueries_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglDeleteQueries(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglDeleteQueries(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteQueries(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glDeleteQueries_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteQueries(1, APIUtils.getBufferInt().put(0, id), 0, function_pointer);
    }
    
    public static boolean glIsQuery(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glIsQuery_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsQuery(id, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsQuery(final int p0, final long p1);
    
    public static void glBeginQuery(final int target, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glBeginQuery_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBeginQuery(target, id, function_pointer);
    }
    
    private static native void nglBeginQuery(final int p0, final int p1, final long p2);
    
    public static void glEndQuery(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glEndQuery_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEndQuery(target, function_pointer);
    }
    
    private static native void nglEndQuery(final int p0, final long p1);
    
    public static void glGetQuery(final int target, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryiv(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryiv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQuery(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryiv(target, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObject(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryObjectiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectiv(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectiv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQueryObjecti(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryObjectiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryObjectiv(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetQueryObjectu(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryObjectuiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetQueryObjectuiv(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetQueryObjectuiv(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetQueryObjectui(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.GL15_glGetQueryObjectuiv_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetQueryObjectuiv(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
