package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

final class LinuxDisplayPeerInfo extends LinuxPeerInfo
{
    LinuxDisplayPeerInfo(final PixelFormat pixel_format) throws LWJGLException {
        LinuxDisplay.lockAWT();
        try {
            GLContext.loadOpenGLLibrary();
            try {
                LinuxDisplay.incDisplay();
                try {
                    initDefaultPeerInfo(LinuxDisplay.getDisplay(), LinuxDisplay.getDefaultScreen(), this.getHandle(), pixel_format);
                }
                catch (LWJGLException e) {
                    LinuxDisplay.decDisplay();
                    throw e;
                }
            }
            catch (LWJGLException e) {
                GLContext.unloadOpenGLLibrary();
                throw e;
            }
        }
        finally {
            LinuxDisplay.unlockAWT();
        }
    }
    
    private static native void initDefaultPeerInfo(final long p0, final int p1, final ByteBuffer p2, final PixelFormat p3) throws LWJGLException;
    
    protected void doLockAndInitHandle() throws LWJGLException {
        LinuxDisplay.lockAWT();
        try {
            initDrawable(LinuxDisplay.getWindow(), this.getHandle());
        }
        finally {
            LinuxDisplay.unlockAWT();
        }
    }
    
    private static native void initDrawable(final long p0, final ByteBuffer p1);
    
    protected void doUnlock() throws LWJGLException {
    }
    
    public void destroy() {
        super.destroy();
        LinuxDisplay.lockAWT();
        LinuxDisplay.decDisplay();
        GLContext.unloadOpenGLLibrary();
        LinuxDisplay.unlockAWT();
    }
}
