package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

abstract class MacOSXPeerInfo extends PeerInfo
{
    MacOSXPeerInfo(final PixelFormat pixel_format, final boolean use_display_bpp, final boolean support_window, final boolean support_pbuffer, final boolean double_buffered) throws LWJGLException {
        super(createHandle());
        if (pixel_format.isFloatingPoint() && !LWJGLUtil.isMacOSXEqualsOrBetterThan(10, 4)) {
            throw new LWJGLException("Floating point pixel format requested, but is not supported");
        }
        this.choosePixelFormat(pixel_format, use_display_bpp, support_window, support_pbuffer, double_buffered);
    }
    
    private static native ByteBuffer createHandle();
    
    private void choosePixelFormat(final PixelFormat pixel_format, final boolean use_display_bpp, final boolean support_window, final boolean support_pbuffer, final boolean double_buffered) throws LWJGLException {
        nChoosePixelFormat(this.getHandle(), pixel_format, use_display_bpp, support_window, support_pbuffer, double_buffered);
    }
    
    private static native void nChoosePixelFormat(final ByteBuffer p0, final PixelFormat p1, final boolean p2, final boolean p3, final boolean p4, final boolean p5) throws LWJGLException;
    
    public void destroy() {
        nDestroy(this.getHandle());
    }
    
    private static native void nDestroy(final ByteBuffer p0);
}
