package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVExplicitMultisample
{
    public static final int GL_SAMPLE_POSITION_NV = 36432;
    public static final int GL_SAMPLE_MASK_NV = 36433;
    public static final int GL_SAMPLE_MASK_VALUE_NV = 36434;
    public static final int GL_TEXTURE_BINDING_RENDERBUFFER_NV = 36435;
    public static final int GL_TEXTURE_RENDERBUFFER_DATA_STORE_BINDING_NV = 36436;
    public static final int GL_MAX_SAMPLE_MASK_WORDS_NV = 36441;
    public static final int GL_TEXTURE_RENDERBUFFER_NV = 36437;
    public static final int GL_SAMPLER_RENDERBUFFER_NV = 36438;
    public static final int GL_INT_SAMPLER_RENDERBUFFER_NV = 36439;
    public static final int GL_UNSIGNED_INT_SAMPLER_RENDERBUFFER_NV = 36440;
    
    public static void glGetBooleanIndexedEXT(final int pname, final int index, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glGetBooleanIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 16);
        nglGetBooleanIndexedvEXT(pname, index, data, data.position(), function_pointer);
    }
    
    private static native void nglGetBooleanIndexedvEXT(final int p0, final int p1, final ByteBuffer p2, final int p3, final long p4);
    
    public static boolean glGetBooleanIndexedEXT(final int pname, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glGetBooleanIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final ByteBuffer data = APIUtils.getBufferByte(1);
        nglGetBooleanIndexedvEXT(pname, index, data, data.position(), function_pointer);
        return data.get(0) == 1;
    }
    
    public static void glGetIntegerIndexedEXT(final int pname, final int index, final IntBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glGetIntegerIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(data, 16);
        nglGetIntegerIndexedvEXT(pname, index, data, data.position(), function_pointer);
    }
    
    private static native void nglGetIntegerIndexedvEXT(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetIntegerIndexedEXT(final int pname, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glGetIntegerIndexedvEXT_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer data = APIUtils.getBufferInt();
        nglGetIntegerIndexedvEXT(pname, index, data, data.position(), function_pointer);
        return data.get(0);
    }
    
    public static void glGetMultisampleNV(final int pname, final int index, final FloatBuffer val) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glGetMultisamplefvNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(val, 2);
        nglGetMultisamplefvNV(pname, index, val, val.position(), function_pointer);
    }
    
    private static native void nglGetMultisamplefvNV(final int p0, final int p1, final FloatBuffer p2, final int p3, final long p4);
    
    public static void glSampleMaskIndexedNV(final int index, final int mask) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glSampleMaskIndexedNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglSampleMaskIndexedNV(index, mask, function_pointer);
    }
    
    private static native void nglSampleMaskIndexedNV(final int p0, final int p1, final long p2);
    
    public static void glTexRenderbufferNV(final int target, final int renderbuffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_explicit_multisample_glTexRenderbufferNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglTexRenderbufferNV(target, renderbuffer, function_pointer);
    }
    
    private static native void nglTexRenderbufferNV(final int p0, final int p1, final long p2);
}
