package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class NVFence
{
    public static final int GL_ALL_COMPLETED_NV = 34034;
    public static final int GL_FENCE_STATUS_NV = 34035;
    public static final int GL_FENCE_CONDITION_NV = 34036;
    
    public static void glGenFencesNV(final IntBuffer piFences) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glGenFencesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(piFences);
        nglGenFencesNV(piFences.remaining(), piFences, piFences.position(), function_pointer);
    }
    
    private static native void nglGenFencesNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteFencesNV(final IntBuffer piFences) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glDeleteFencesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(piFences);
        nglDeleteFencesNV(piFences.remaining(), piFences, piFences.position(), function_pointer);
    }
    
    private static native void nglDeleteFencesNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glSetFenceNV(final int fence, final int condition) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glSetFenceNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglSetFenceNV(fence, condition, function_pointer);
    }
    
    private static native void nglSetFenceNV(final int p0, final int p1, final long p2);
    
    public static boolean glTestFenceNV(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glTestFenceNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglTestFenceNV(fence, function_pointer);
        return __result;
    }
    
    private static native boolean nglTestFenceNV(final int p0, final long p1);
    
    public static void glFinishFenceNV(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glFinishFenceNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFinishFenceNV(fence, function_pointer);
    }
    
    private static native void nglFinishFenceNV(final int p0, final long p1);
    
    public static boolean glIsFenceNV(final int fence) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glIsFenceNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsFenceNV(fence, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsFenceNV(final int p0, final long p1);
    
    public static void glGetFenceivNV(final int fence, final int pname, final IntBuffer piParams) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fence_glGetFenceivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(piParams, 4);
        nglGetFenceivNV(fence, pname, piParams, piParams.position(), function_pointer);
    }
    
    private static native void nglGetFenceivNV(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
}
