package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVFragmentProgram extends NVProgram
{
    public static final int GL_FRAGMENT_PROGRAM_NV = 34928;
    public static final int GL_MAX_TEXTURE_COORDS_NV = 34929;
    public static final int GL_MAX_TEXTURE_IMAGE_UNITS_NV = 34930;
    public static final int GL_FRAGMENT_PROGRAM_BINDING_NV = 34931;
    public static final int GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV = 34920;
    
    public static void glProgramNamedParameter4fNV(final int id, final ByteBuffer name, final float x, final float y, final float z, final float w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fragment_program_glProgramNamedParameter4fNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        nglProgramNamedParameter4fNV(id, name.remaining(), name, name.position(), x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramNamedParameter4fNV(final int p0, final int p1, final ByteBuffer p2, final int p3, final float p4, final float p5, final float p6, final float p7, final long p8);
    
    public static void glProgramNamedParameter4dNV(final int id, final ByteBuffer name, final double x, final double y, final double z, final double w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fragment_program_glProgramNamedParameter4dNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        nglProgramNamedParameter4dNV(id, name.remaining(), name, name.position(), x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramNamedParameter4dNV(final int p0, final int p1, final ByteBuffer p2, final int p3, final double p4, final double p5, final double p6, final double p7, final long p8);
    
    public static void glGetProgramNamedParameterNV(final int id, final ByteBuffer name, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fragment_program_glGetProgramNamedParameterfvNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramNamedParameterfvNV(id, name.remaining(), name, name.position(), params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramNamedParameterfvNV(final int p0, final int p1, final ByteBuffer p2, final int p3, final FloatBuffer p4, final int p5, final long p6);
    
    public static void glGetProgramNamedParameterNV(final int id, final ByteBuffer name, final DoubleBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_fragment_program_glGetProgramNamedParameterdvNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkBuffer(params, 4);
        nglGetProgramNamedParameterdvNV(id, name.remaining(), name, name.position(), params, params.position(), function_pointer);
    }
    
    private static native void nglGetProgramNamedParameterdvNV(final int p0, final int p1, final ByteBuffer p2, final int p3, final DoubleBuffer p4, final int p5, final long p6);
}
