package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVGpuShader5
{
    public static final int GL_INT64_NV = 5134;
    public static final int GL_UNSIGNED_INT64_NV = 5135;
    public static final int GL_INT8_NV = 36832;
    public static final int GL_INT8_VEC2_NV = 36833;
    public static final int GL_INT8_VEC3_NV = 36834;
    public static final int GL_INT8_VEC4_NV = 36835;
    public static final int GL_INT16_NV = 36836;
    public static final int GL_INT16_VEC2_NV = 36837;
    public static final int GL_INT16_VEC3_NV = 36838;
    public static final int GL_INT16_VEC4_NV = 36839;
    public static final int GL_INT64_VEC2_NV = 36841;
    public static final int GL_INT64_VEC3_NV = 36842;
    public static final int GL_INT64_VEC4_NV = 36843;
    public static final int GL_UNSIGNED_INT8_NV = 36844;
    public static final int GL_UNSIGNED_INT8_VEC2_NV = 36845;
    public static final int GL_UNSIGNED_INT8_VEC3_NV = 36846;
    public static final int GL_UNSIGNED_INT8_VEC4_NV = 36847;
    public static final int GL_UNSIGNED_INT16_NV = 36848;
    public static final int GL_UNSIGNED_INT16_VEC2_NV = 36849;
    public static final int GL_UNSIGNED_INT16_VEC3_NV = 36850;
    public static final int GL_UNSIGNED_INT16_VEC4_NV = 36851;
    public static final int GL_UNSIGNED_INT64_VEC2_NV = 36853;
    public static final int GL_UNSIGNED_INT64_VEC3_NV = 36854;
    public static final int GL_UNSIGNED_INT64_VEC4_NV = 36855;
    public static final int GL_FLOAT16_NV = 36856;
    public static final int GL_FLOAT16_VEC2_NV = 36857;
    public static final int GL_FLOAT16_VEC3_NV = 36858;
    public static final int GL_FLOAT16_VEC4_NV = 36859;
    public static final int GL_PATCHES = 14;
    
    public static void glUniform1i64NV(final int location, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform1i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform1i64NV(location, x, function_pointer);
    }
    
    private static native void nglUniform1i64NV(final int p0, final long p1, final long p2);
    
    public static void glUniform2i64NV(final int location, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform2i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform2i64NV(location, x, y, function_pointer);
    }
    
    private static native void nglUniform2i64NV(final int p0, final long p1, final long p2, final long p3);
    
    public static void glUniform3i64NV(final int location, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform3i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform3i64NV(location, x, y, z, function_pointer);
    }
    
    private static native void nglUniform3i64NV(final int p0, final long p1, final long p2, final long p3, final long p4);
    
    public static void glUniform4i64NV(final int location, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform4i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform4i64NV(location, x, y, z, w, function_pointer);
    }
    
    private static native void nglUniform4i64NV(final int p0, final long p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glUniform1NV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform1i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 1);
        nglUniform1i64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform1i64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform2NV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform2i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 2);
        nglUniform2i64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform2i64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform3NV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform3i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 3);
        nglUniform3i64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform3i64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform4NV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform4i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 4);
        nglUniform4i64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform4i64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform1ui64NV(final int location, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform1ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform1ui64NV(location, x, function_pointer);
    }
    
    private static native void nglUniform1ui64NV(final int p0, final long p1, final long p2);
    
    public static void glUniform2ui64NV(final int location, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform2ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform2ui64NV(location, x, y, function_pointer);
    }
    
    private static native void nglUniform2ui64NV(final int p0, final long p1, final long p2, final long p3);
    
    public static void glUniform3ui64NV(final int location, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform3ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform3ui64NV(location, x, y, z, function_pointer);
    }
    
    private static native void nglUniform3ui64NV(final int p0, final long p1, final long p2, final long p3, final long p4);
    
    public static void glUniform4ui64NV(final int location, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform4ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniform4ui64NV(location, x, y, z, w, function_pointer);
    }
    
    private static native void nglUniform4ui64NV(final int p0, final long p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glUniform1uNV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform1ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 1);
        nglUniform1ui64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform1ui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform2uNV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform2ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 2);
        nglUniform2ui64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform2ui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform3uNV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform3ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 3);
        nglUniform3ui64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform3ui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glUniform4uNV(final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glUniform4ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 4);
        nglUniform4ui64vNV(location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglUniform4ui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glGetUniformNV(final int program, final int location, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glGetUniformi64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetUniformi64vNV(program, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformi64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glGetUniformuNV(final int program, final int location, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glGetUniformui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglGetUniformui64vNV(program, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glProgramUniform1i64NV(final int program, final int location, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform1i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform1i64NV(program, location, x, function_pointer);
    }
    
    private static native void nglProgramUniform1i64NV(final int p0, final int p1, final long p2, final long p3);
    
    public static void glProgramUniform2i64NV(final int program, final int location, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform2i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform2i64NV(program, location, x, y, function_pointer);
    }
    
    private static native void nglProgramUniform2i64NV(final int p0, final int p1, final long p2, final long p3, final long p4);
    
    public static void glProgramUniform3i64NV(final int program, final int location, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform3i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform3i64NV(program, location, x, y, z, function_pointer);
    }
    
    private static native void nglProgramUniform3i64NV(final int p0, final int p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glProgramUniform4i64NV(final int program, final int location, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform4i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform4i64NV(program, location, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramUniform4i64NV(final int p0, final int p1, final long p2, final long p3, final long p4, final long p5, final long p6);
    
    public static void glProgramUniform1NV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform1i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 1);
        nglProgramUniform1i64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform1i64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform2NV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform2i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 2);
        nglProgramUniform2i64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform2i64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform3NV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform3i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 3);
        nglProgramUniform3i64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform3i64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform4NV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform4i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 4);
        nglProgramUniform4i64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform4i64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform1ui64NV(final int program, final int location, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform1ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform1ui64NV(program, location, x, function_pointer);
    }
    
    private static native void nglProgramUniform1ui64NV(final int p0, final int p1, final long p2, final long p3);
    
    public static void glProgramUniform2ui64NV(final int program, final int location, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform2ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform2ui64NV(program, location, x, y, function_pointer);
    }
    
    private static native void nglProgramUniform2ui64NV(final int p0, final int p1, final long p2, final long p3, final long p4);
    
    public static void glProgramUniform3ui64NV(final int program, final int location, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform3ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform3ui64NV(program, location, x, y, z, function_pointer);
    }
    
    private static native void nglProgramUniform3ui64NV(final int p0, final int p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glProgramUniform4ui64NV(final int program, final int location, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform4ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniform4ui64NV(program, location, x, y, z, w, function_pointer);
    }
    
    private static native void nglProgramUniform4ui64NV(final int p0, final int p1, final long p2, final long p3, final long p4, final long p5, final long p6);
    
    public static void glProgramUniform1uNV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform1ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 1);
        nglProgramUniform1ui64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform1ui64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform2uNV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform2ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 2);
        nglProgramUniform2ui64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform2ui64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform3uNV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform3ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 3);
        nglProgramUniform3ui64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform3ui64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
    
    public static void glProgramUniform4uNV(final int program, final int location, final int count, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_gpu_shader5_glProgramUniform4ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(value, 4);
        nglProgramUniform4ui64vNV(program, location, count, value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniform4ui64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
}
