package org.lwjgl.opengl;

import java.nio.*;
import org.lwjgl.*;

public final class NVOcclusionQuery
{
    public static final int GL_OCCLUSION_TEST_HP = 33125;
    public static final int GL_OCCLUSION_TEST_RESULT_HP = 33126;
    public static final int GL_PIXEL_COUNTER_BITS_NV = 34916;
    public static final int GL_CURRENT_OCCLUSION_QUERY_ID_NV = 34917;
    public static final int GL_PIXEL_COUNT_NV = 34918;
    public static final int GL_PIXEL_COUNT_AVAILABLE_NV = 34919;
    
    public static void glGenOcclusionQueriesNV(final IntBuffer piIDs) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGenOcclusionQueriesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(piIDs);
        nglGenOcclusionQueriesNV(piIDs.remaining(), piIDs, piIDs.position(), function_pointer);
    }
    
    private static native void nglGenOcclusionQueriesNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenOcclusionQueriesNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGenOcclusionQueriesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer piIDs = APIUtils.getBufferInt();
        nglGenOcclusionQueriesNV(1, piIDs, piIDs.position(), function_pointer);
        return piIDs.get(0);
    }
    
    public static void glDeleteOcclusionQueriesNV(final IntBuffer piIDs) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glDeleteOcclusionQueriesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(piIDs);
        nglDeleteOcclusionQueriesNV(piIDs.remaining(), piIDs, piIDs.position(), function_pointer);
    }
    
    private static native void nglDeleteOcclusionQueriesNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteOcclusionQueriesNV(final int piID) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glDeleteOcclusionQueriesNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteOcclusionQueriesNV(1, APIUtils.getBufferInt().put(0, piID), 0, function_pointer);
    }
    
    public static boolean glIsOcclusionQueryNV(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glIsOcclusionQueryNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsOcclusionQueryNV(id, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsOcclusionQueryNV(final int p0, final long p1);
    
    public static void glBeginOcclusionQueryNV(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glBeginOcclusionQueryNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBeginOcclusionQueryNV(id, function_pointer);
    }
    
    private static native void nglBeginOcclusionQueryNV(final int p0, final long p1);
    
    public static void glEndOcclusionQueryNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glEndOcclusionQueryNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEndOcclusionQueryNV(function_pointer);
    }
    
    private static native void nglEndOcclusionQueryNV(final long p0);
    
    public static void glGetOcclusionQueryuNV(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGetOcclusionQueryuivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetOcclusionQueryuivNV(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetOcclusionQueryuivNV(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetOcclusionQueryuiNV(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGetOcclusionQueryuivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetOcclusionQueryuivNV(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetOcclusionQueryNV(final int id, final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGetOcclusionQueryivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetOcclusionQueryivNV(id, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetOcclusionQueryivNV(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetOcclusionQueryiNV(final int id, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_occlusion_query_glGetOcclusionQueryivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer params = APIUtils.getBufferInt();
        nglGetOcclusionQueryivNV(id, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
}
