package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVParameterBufferObject
{
    public static final int GL_MAX_PROGRAM_PARAMETER_BUFFER_BINDINGS_NV = 36256;
    public static final int GL_MAX_PROGRAM_PARAMETER_BUFFER_SIZE_NV = 36257;
    public static final int GL_VERTEX_PROGRAM_PARAMETER_BUFFER_NV = 36258;
    public static final int GL_GEOMETRY_PROGRAM_PARAMETER_BUFFER_NV = 36259;
    public static final int GL_FRAGMENT_PROGRAM_PARAMETER_BUFFER_NV = 36260;
    
    public static void glProgramBufferParametersNV(final int target, final int buffer, final int index, final FloatBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_parameter_buffer_object_glProgramBufferParametersfvNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglProgramBufferParametersfvNV(target, buffer, index, params.remaining() >> 2, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramBufferParametersfvNV(final int p0, final int p1, final int p2, final int p3, final FloatBuffer p4, final int p5, final long p6);
    
    public static void glProgramBufferParametersINV(final int target, final int buffer, final int index, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_parameter_buffer_object_glProgramBufferParametersIivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglProgramBufferParametersIivNV(target, buffer, index, params.remaining() >> 2, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramBufferParametersIivNV(final int p0, final int p1, final int p2, final int p3, final IntBuffer p4, final int p5, final long p6);
    
    public static void glProgramBufferParametersIuNV(final int target, final int buffer, final int index, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_parameter_buffer_object_glProgramBufferParametersIuivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(params);
        nglProgramBufferParametersIuivNV(target, buffer, index, params.remaining() >> 2, params, params.position(), function_pointer);
    }
    
    private static native void nglProgramBufferParametersIuivNV(final int p0, final int p1, final int p2, final int p3, final IntBuffer p4, final int p5, final long p6);
}
