package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVPixelDataRange
{
    public static final int GL_WRITE_PIXEL_DATA_RANGE_NV = 34936;
    public static final int GL_READ_PIXEL_DATA_RANGE_NV = 34937;
    public static final int GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV = 34938;
    public static final int GL_READ_PIXEL_DATA_RANGE_LENGTH_NV = 34939;
    public static final int GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV = 34940;
    public static final int GL_READ_PIXEL_DATA_RANGE_POINTER_NV = 34941;
    
    public static void glPixelDataRangeNV(final int target, final ByteBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglPixelDataRangeNV(target, data.remaining(), data, data.position(), function_pointer);
    }
    
    public static void glPixelDataRangeNV(final int target, final DoubleBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglPixelDataRangeNV(target, data.remaining() << 3, data, data.position() << 3, function_pointer);
    }
    
    public static void glPixelDataRangeNV(final int target, final FloatBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglPixelDataRangeNV(target, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glPixelDataRangeNV(final int target, final IntBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglPixelDataRangeNV(target, data.remaining() << 2, data, data.position() << 2, function_pointer);
    }
    
    public static void glPixelDataRangeNV(final int target, final ShortBuffer data) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(data);
        nglPixelDataRangeNV(target, data.remaining() << 1, data, data.position() << 1, function_pointer);
    }
    
    private static native void nglPixelDataRangeNV(final int p0, final int p1, final Buffer p2, final int p3, final long p4);
    
    public static void glFlushPixelDataRangeNV(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_pixel_data_range_glFlushPixelDataRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFlushPixelDataRangeNV(target, function_pointer);
    }
    
    private static native void nglFlushPixelDataRangeNV(final int p0, final long p1);
}
