package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVPointSprite
{
    public static final int GL_POINT_SPRITE_NV = 34913;
    public static final int GL_COORD_REPLACE_NV = 34914;
    public static final int GL_POINT_SPRITE_R_MODE_NV = 34915;
    
    public static void glPointParameteriNV(final int pname, final int param) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_point_sprite_glPointParameteriNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglPointParameteriNV(pname, param, function_pointer);
    }
    
    private static native void nglPointParameteriNV(final int p0, final int p1, final long p2);
    
    public static void glPointParameterNV(final int pname, final IntBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_point_sprite_glPointParameterivNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglPointParameterivNV(pname, params, params.position(), function_pointer);
    }
    
    private static native void nglPointParameterivNV(final int p0, final IntBuffer p1, final int p2, final long p3);
}
