package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVShaderBufferLoad
{
    public static final int GL_BUFFER_GPU_ADDRESS_NV = 36637;
    public static final int GL_GPU_ADDRESS_NV = 36660;
    public static final int GL_MAX_SHADER_BUFFER_ADDRESS_NV = 36661;
    
    public static void glMakeBufferResidentNV(final int target, final int access) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glMakeBufferResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglMakeBufferResidentNV(target, access, function_pointer);
    }
    
    private static native void nglMakeBufferResidentNV(final int p0, final int p1, final long p2);
    
    public static void glMakeBufferNonResidentNV(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glMakeBufferNonResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglMakeBufferNonResidentNV(target, function_pointer);
    }
    
    private static native void nglMakeBufferNonResidentNV(final int p0, final long p1);
    
    public static boolean glIsBufferResidentNV(final int target) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glIsBufferResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsBufferResidentNV(target, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsBufferResidentNV(final int p0, final long p1);
    
    public static void glMakeNamedBufferResidentNV(final int buffer, final int access) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glMakeNamedBufferResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglMakeNamedBufferResidentNV(buffer, access, function_pointer);
    }
    
    private static native void nglMakeNamedBufferResidentNV(final int p0, final int p1, final long p2);
    
    public static void glMakeNamedBufferNonResidentNV(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glMakeNamedBufferNonResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglMakeNamedBufferNonResidentNV(buffer, function_pointer);
    }
    
    private static native void nglMakeNamedBufferNonResidentNV(final int p0, final long p1);
    
    public static boolean glIsNamedBufferResidentNV(final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glIsNamedBufferResidentNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsNamedBufferResidentNV(buffer, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsNamedBufferResidentNV(final int p0, final long p1);
    
    public static void glGetBufferParameteruNV(final int target, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetBufferParameterui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetBufferParameterui64vNV(target, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetBufferParameterui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetBufferParameteruNV(final int target, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetBufferParameterui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetBufferParameterui64vNV(target, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetNamedBufferParameteruNV(final int buffer, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetNamedBufferParameterui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetNamedBufferParameterui64vNV(buffer, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetNamedBufferParameterui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static long glGetNamedBufferParameteruNV(final int buffer, final int pname) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetNamedBufferParameterui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer params = APIUtils.getBufferLong();
        nglGetNamedBufferParameterui64vNV(buffer, pname, params, params.position(), function_pointer);
        return params.get(0);
    }
    
    public static void glGetIntegeruNV(final int value, final LongBuffer result) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetIntegerui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(result, 1);
        nglGetIntegerui64vNV(value, result, result.position(), function_pointer);
    }
    
    private static native void nglGetIntegerui64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static long glGetIntegeruNV(final int value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetIntegerui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final LongBuffer result = APIUtils.getBufferLong();
        nglGetIntegerui64vNV(value, result, result.position(), function_pointer);
        return result.get(0);
    }
    
    public static void glUniformui64NV(final int location, final long value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glUniformui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglUniformui64NV(location, value, function_pointer);
    }
    
    private static native void nglUniformui64NV(final int p0, final long p1, final long p2);
    
    public static void glUniformuNV(final int location, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glUniformui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglUniformui64vNV(location, value.remaining(), value, value.position(), function_pointer);
    }
    
    private static native void nglUniformui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glGetUniformuNV(final int program, final int location, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glGetUniformui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 1);
        nglGetUniformui64vNV(program, location, params, params.position(), function_pointer);
    }
    
    private static native void nglGetUniformui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glProgramUniformui64NV(final int program, final int location, final long value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glProgramUniformui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglProgramUniformui64NV(program, location, value, function_pointer);
    }
    
    private static native void nglProgramUniformui64NV(final int p0, final int p1, final long p2, final long p3);
    
    public static void glProgramUniformuNV(final int program, final int location, final LongBuffer value) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_shader_buffer_load_glProgramUniformui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(value);
        nglProgramUniformui64vNV(program, location, value.remaining(), value, value.position(), function_pointer);
    }
    
    private static native void nglProgramUniformui64vNV(final int p0, final int p1, final int p2, final LongBuffer p3, final int p4, final long p5);
}
