package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVTransformFeedback
{
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_NV = 35982;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_START_NV = 35972;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_NV = 35973;
    public static final int GL_TRANSFORM_FEEDBACK_RECORD_NV = 35974;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_NV = 35983;
    public static final int GL_INTERLEAVED_ATTRIBS_NV = 35980;
    public static final int GL_SEPARATE_ATTRIBS_NV = 35981;
    public static final int GL_PRIMITIVES_GENERATED_NV = 35975;
    public static final int GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV = 35976;
    public static final int GL_RASTERIZER_DISCARD_NV = 35977;
    public static final int GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV = 35978;
    public static final int GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV = 35979;
    public static final int GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV = 35968;
    public static final int GL_TRANSFORM_FEEDBACK_ATTRIBS_NV = 35966;
    public static final int GL_ACTIVE_VARYINGS_NV = 35969;
    public static final int GL_ACTIVE_VARYING_MAX_LENGTH_NV = 35970;
    public static final int GL_TRANSFORM_FEEDBACK_VARYINGS_NV = 35971;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_MODE_NV = 35967;
    public static final int GL_BACK_PRIMARY_COLOR_NV = 35959;
    public static final int GL_BACK_SECONDARY_COLOR_NV = 35960;
    public static final int GL_TEXTURE_COORD_NV = 35961;
    public static final int GL_CLIP_DISTANCE_NV = 35962;
    public static final int GL_VERTEX_ID_NV = 35963;
    public static final int GL_PRIMITIVE_ID_NV = 35964;
    public static final int GL_GENERIC_ATTRIB_NV = 35965;
    public static final int GL_LAYER_NV = 36266;
    
    public static void glBindBufferRangeNV(final int target, final int index, final int buffer, final long offset, final long size) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glBindBufferRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindBufferRangeNV(target, index, buffer, offset, size, function_pointer);
    }
    
    private static native void nglBindBufferRangeNV(final int p0, final int p1, final int p2, final long p3, final long p4, final long p5);
    
    public static void glBindBufferOffsetNV(final int target, final int index, final int buffer, final long offset) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glBindBufferOffsetNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindBufferOffsetNV(target, index, buffer, offset, function_pointer);
    }
    
    private static native void nglBindBufferOffsetNV(final int p0, final int p1, final int p2, final long p3, final long p4);
    
    public static void glBindBufferBaseNV(final int target, final int index, final int buffer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glBindBufferBaseNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindBufferBaseNV(target, index, buffer, function_pointer);
    }
    
    private static native void nglBindBufferBaseNV(final int p0, final int p1, final int p2, final long p3);
    
    public static void glTransformFeedbackAttribsNV(final IntBuffer attribs, final int bufferMode) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glTransformFeedbackAttribsNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(attribs);
        nglTransformFeedbackAttribsNV(attribs.remaining(), attribs, attribs.position(), bufferMode, function_pointer);
    }
    
    private static native void nglTransformFeedbackAttribsNV(final int p0, final IntBuffer p1, final int p2, final int p3, final long p4);
    
    public static void glTransformFeedbackVaryingsNV(final int program, final IntBuffer locations, final int bufferMode) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glTransformFeedbackVaryingsNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(locations);
        nglTransformFeedbackVaryingsNV(program, locations.remaining(), locations, locations.position(), bufferMode, function_pointer);
    }
    
    private static native void nglTransformFeedbackVaryingsNV(final int p0, final int p1, final IntBuffer p2, final int p3, final int p4, final long p5);
    
    public static void glBeginTransformFeedbackNV(final int primitiveMode) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glBeginTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBeginTransformFeedbackNV(primitiveMode, function_pointer);
    }
    
    private static native void nglBeginTransformFeedbackNV(final int p0, final long p1);
    
    public static void glEndTransformFeedbackNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glEndTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglEndTransformFeedbackNV(function_pointer);
    }
    
    private static native void nglEndTransformFeedbackNV(final long p0);
    
    public static int glGetVaryingLocationNV(final int program, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetVaryingLocationNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        final int __result = nglGetVaryingLocationNV(program, name, name.position(), function_pointer);
        return __result;
    }
    
    private static native int nglGetVaryingLocationNV(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static int glGetVaryingLocationNV(final int program, final CharSequence name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetVaryingLocationNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final int __result = nglGetVaryingLocationNV(program, APIUtils.getBufferNT(name), 0, function_pointer);
        return __result;
    }
    
    public static void glGetActiveVaryingNV(final int program, final int index, final IntBuffer length, final IntBuffer size, final IntBuffer type, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        if (length != null) {
            BufferChecks.checkBuffer(length, 1);
        }
        BufferChecks.checkBuffer(size, 1);
        BufferChecks.checkBuffer(type, 1);
        BufferChecks.checkDirect(name);
        nglGetActiveVaryingNV(program, index, name.remaining(), length, (length != null) ? length.position() : 0, size, size.position(), type, type.position(), name, name.position(), function_pointer);
    }
    
    private static native void nglGetActiveVaryingNV(final int p0, final int p1, final int p2, final IntBuffer p3, final int p4, final IntBuffer p5, final int p6, final IntBuffer p7, final int p8, final ByteBuffer p9, final int p10, final long p11);
    
    public static String glGetActiveVaryingNV(final int program, final int index, final int bufSize, final IntBuffer sizeType) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(sizeType, 2);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(bufSize);
        nglGetActiveVaryingNV(program, index, bufSize, name_length, 0, sizeType, sizeType.position(), sizeType, sizeType.position() + 1, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static String glGetActiveVaryingNV(final int program, final int index, final int bufSize) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer name_length = APIUtils.getLengths();
        final ByteBuffer name = APIUtils.getBufferByte(bufSize);
        nglGetActiveVaryingNV(program, index, bufSize, name_length, 0, APIUtils.getBufferInt(), 0, APIUtils.getBufferInt(), 1, name, name.position(), function_pointer);
        name.limit(name_length.get(0));
        return APIUtils.getString(name);
    }
    
    public static int glGetActiveVaryingSizeNV(final int program, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer size = APIUtils.getBufferInt();
        nglGetActiveVaryingNV(program, index, 0, null, 0, size, size.position(), size, 1, APIUtils.getBufferByte(0), 0, function_pointer);
        return size.get(0);
    }
    
    public static int glGetActiveVaryingTypeNV(final int program, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer type = APIUtils.getBufferInt();
        nglGetActiveVaryingNV(program, index, 0, null, 0, type, 1, type, type.position(), APIUtils.getBufferByte(0), 0, function_pointer);
        return type.get(0);
    }
    
    public static void glActiveVaryingNV(final int program, final ByteBuffer name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(name);
        BufferChecks.checkNullTerminated(name);
        nglActiveVaryingNV(program, name, name.position(), function_pointer);
    }
    
    private static native void nglActiveVaryingNV(final int p0, final ByteBuffer p1, final int p2, final long p3);
    
    public static void glActiveVaryingNV(final int program, final CharSequence name) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glActiveVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglActiveVaryingNV(program, APIUtils.getBufferNT(name), 0, function_pointer);
    }
    
    public static void glGetTransformFeedbackVaryingNV(final int program, final int index, final IntBuffer location) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetTransformFeedbackVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(location, 1);
        nglGetTransformFeedbackVaryingNV(program, index, location, location.position(), function_pointer);
    }
    
    private static native void nglGetTransformFeedbackVaryingNV(final int p0, final int p1, final IntBuffer p2, final int p3, final long p4);
    
    public static int glGetTransformFeedbackVaryingNV(final int program, final int index) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback_glGetTransformFeedbackVaryingNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer location = APIUtils.getBufferInt();
        nglGetTransformFeedbackVaryingNV(program, index, location, location.position(), function_pointer);
        return location.get(0);
    }
}
