package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVTransformFeedback2
{
    public static final int GL_TRANSFORM_FEEDBACK_NV = 36386;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_PAUSED_NV = 36387;
    public static final int GL_TRANSFORM_FEEDBACK_BUFFER_ACTIVE_NV = 36388;
    public static final int GL_TRANSFORM_FEEDBACK_BINDING_NV = 36389;
    
    public static void glBindTransformFeedbackNV(final int target, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glBindTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglBindTransformFeedbackNV(target, id, function_pointer);
    }
    
    private static native void nglBindTransformFeedbackNV(final int p0, final int p1, final long p2);
    
    public static void glDeleteTransformFeedbacksNV(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glDeleteTransformFeedbacksNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglDeleteTransformFeedbacksNV(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglDeleteTransformFeedbacksNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static void glDeleteTransformFeedbacksNV(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glDeleteTransformFeedbacksNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDeleteTransformFeedbacksNV(1, APIUtils.getBufferInt().put(0, id), 0, function_pointer);
    }
    
    public static void glGenTransformFeedbacksNV(final IntBuffer ids) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glGenTransformFeedbacksNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(ids);
        nglGenTransformFeedbacksNV(ids.remaining(), ids, ids.position(), function_pointer);
    }
    
    private static native void nglGenTransformFeedbacksNV(final int p0, final IntBuffer p1, final int p2, final long p3);
    
    public static int glGenTransformFeedbacksNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glGenTransformFeedbacksNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final IntBuffer ids = APIUtils.getBufferInt();
        nglGenTransformFeedbacksNV(1, ids, ids.position(), function_pointer);
        return ids.get(0);
    }
    
    public static boolean glIsTransformFeedbackNV(final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glIsTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final boolean __result = nglIsTransformFeedbackNV(id, function_pointer);
        return __result;
    }
    
    private static native boolean nglIsTransformFeedbackNV(final int p0, final long p1);
    
    public static void glPauseTransformFeedbackNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glPauseTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglPauseTransformFeedbackNV(function_pointer);
    }
    
    private static native void nglPauseTransformFeedbackNV(final long p0);
    
    public static void glResumeTransformFeedbackNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glResumeTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglResumeTransformFeedbackNV(function_pointer);
    }
    
    private static native void nglResumeTransformFeedbackNV(final long p0);
    
    public static void glDrawTransformFeedbackNV(final int mode, final int id) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_transform_feedback2_glDrawTransformFeedbackNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglDrawTransformFeedbackNV(mode, id, function_pointer);
    }
    
    private static native void nglDrawTransformFeedbackNV(final int p0, final int p1, final long p2);
}
