package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVVertexArrayRange
{
    public static final int GL_VERTEX_ARRAY_RANGE_NV = 34077;
    public static final int GL_VERTEX_ARRAY_RANGE_LENGTH_NV = 34078;
    public static final int GL_VERTEX_ARRAY_RANGE_VALID_NV = 34079;
    public static final int GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV = 34080;
    public static final int GL_VERTEX_ARRAY_RANGE_POINTER_NV = 34081;
    
    public static void glVertexArrayRangeNV(final ByteBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglVertexArrayRangeNV(pPointer.remaining(), pPointer, pPointer.position(), function_pointer);
    }
    
    public static void glVertexArrayRangeNV(final DoubleBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglVertexArrayRangeNV(pPointer.remaining() << 3, pPointer, pPointer.position() << 3, function_pointer);
    }
    
    public static void glVertexArrayRangeNV(final FloatBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglVertexArrayRangeNV(pPointer.remaining() << 2, pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glVertexArrayRangeNV(final IntBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglVertexArrayRangeNV(pPointer.remaining() << 2, pPointer, pPointer.position() << 2, function_pointer);
    }
    
    public static void glVertexArrayRangeNV(final ShortBuffer pPointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pPointer);
        nglVertexArrayRangeNV(pPointer.remaining() << 1, pPointer, pPointer.position() << 1, function_pointer);
    }
    
    private static native void nglVertexArrayRangeNV(final int p0, final Buffer p1, final int p2, final long p3);
    
    public static void glFlushVertexArrayRangeNV() {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glFlushVertexArrayRangeNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglFlushVertexArrayRangeNV(function_pointer);
    }
    
    private static native void nglFlushVertexArrayRangeNV(final long p0);
    
    public static ByteBuffer glAllocateMemoryNV(final int size, final float readFrequency, final float writeFrequency, final float priority) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glAllocateMemoryNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        final ByteBuffer __result = nglAllocateMemoryNV(size, readFrequency, writeFrequency, priority, size, function_pointer);
        return __result;
    }
    
    private static native ByteBuffer nglAllocateMemoryNV(final int p0, final float p1, final float p2, final float p3, final long p4, final long p5);
    
    public static void glFreeMemoryNV(final ByteBuffer pointer) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_array_range_glFreeMemoryNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkDirect(pointer);
        nglFreeMemoryNV(pointer, pointer.position(), function_pointer);
    }
    
    private static native void nglFreeMemoryNV(final Buffer p0, final int p1, final long p2);
}
