package org.lwjgl.opengl;

import org.lwjgl.*;
import java.nio.*;

public final class NVVertexAttribInteger64bit
{
    public static final int GL_INT64_NV = 5134;
    public static final int GL_UNSIGNED_INT64_NV = 5135;
    
    public static void glVertexAttribL1i64NV(final int index, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL1i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL1i64NV(index, x, function_pointer);
    }
    
    private static native void nglVertexAttribL1i64NV(final int p0, final long p1, final long p2);
    
    public static void glVertexAttribL2i64NV(final int index, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL2i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL2i64NV(index, x, y, function_pointer);
    }
    
    private static native void nglVertexAttribL2i64NV(final int p0, final long p1, final long p2, final long p3);
    
    public static void glVertexAttribL3i64NV(final int index, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL3i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL3i64NV(index, x, y, z, function_pointer);
    }
    
    private static native void nglVertexAttribL3i64NV(final int p0, final long p1, final long p2, final long p3, final long p4);
    
    public static void glVertexAttribL4i64NV(final int index, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL4i64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL4i64NV(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttribL4i64NV(final int p0, final long p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glVertexAttribL1NV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL1i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 1);
        nglVertexAttribL1i64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL1i64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL2NV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL2i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 2);
        nglVertexAttribL2i64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL2i64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL3NV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL3i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 3);
        nglVertexAttribL3i64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL3i64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL4NV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL4i64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 4);
        nglVertexAttribL4i64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL4i64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL1ui64NV(final int index, final long x) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL1ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL1ui64NV(index, x, function_pointer);
    }
    
    private static native void nglVertexAttribL1ui64NV(final int p0, final long p1, final long p2);
    
    public static void glVertexAttribL2ui64NV(final int index, final long x, final long y) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL2ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL2ui64NV(index, x, y, function_pointer);
    }
    
    private static native void nglVertexAttribL2ui64NV(final int p0, final long p1, final long p2, final long p3);
    
    public static void glVertexAttribL3ui64NV(final int index, final long x, final long y, final long z) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL3ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL3ui64NV(index, x, y, z, function_pointer);
    }
    
    private static native void nglVertexAttribL3ui64NV(final int p0, final long p1, final long p2, final long p3, final long p4);
    
    public static void glVertexAttribL4ui64NV(final int index, final long x, final long y, final long z, final long w) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL4ui64NV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribL4ui64NV(index, x, y, z, w, function_pointer);
    }
    
    private static native void nglVertexAttribL4ui64NV(final int p0, final long p1, final long p2, final long p3, final long p4, final long p5);
    
    public static void glVertexAttribL1uNV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL1ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 1);
        nglVertexAttribL1ui64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL1ui64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL2uNV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL2ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 2);
        nglVertexAttribL2ui64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL2ui64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL3uNV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL3ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 3);
        nglVertexAttribL3ui64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL3ui64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glVertexAttribL4uNV(final int index, final LongBuffer v) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribL4ui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(v, 4);
        nglVertexAttribL4ui64vNV(index, v, v.position(), function_pointer);
    }
    
    private static native void nglVertexAttribL4ui64vNV(final int p0, final LongBuffer p1, final int p2, final long p3);
    
    public static void glGetVertexAttribLNV(final int index, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glGetVertexAttribLi64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVertexAttribLi64vNV(index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVertexAttribLi64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glGetVertexAttribLuNV(final int index, final int pname, final LongBuffer params) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glGetVertexAttribLui64vNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        BufferChecks.checkBuffer(params, 4);
        nglGetVertexAttribLui64vNV(index, pname, params, params.position(), function_pointer);
    }
    
    private static native void nglGetVertexAttribLui64vNV(final int p0, final int p1, final LongBuffer p2, final int p3, final long p4);
    
    public static void glVertexAttribLFormatNV(final int index, final int size, final int type, final int stride) {
        final ContextCapabilities caps = GLContext.getCapabilities();
        final long function_pointer = caps.NV_vertex_attrib_integer_64bit_glVertexAttribLFormatNV_pointer;
        BufferChecks.checkFunctionAddress(function_pointer);
        nglVertexAttribLFormatNV(index, size, type, stride, function_pointer);
    }
    
    private static native void nglVertexAttribLFormatNV(final int p0, final int p1, final int p2, final int p3, final long p4);
}
